Thu Oct 18 00:33:13 2018  Kazuki Yamaguchi <k@rhe.jp>

	* ext/openssl: backport changes from openssl 2.1.2.

Wed Mar 28 23:08:46 2018  NAKAMURA Usaku  <usa@ruby-lang.org>

	get rid of test error/failure on Windows introduced at r62955

	* lib/webrick/httpresponse.rb (send_body_io): use seek if
	  NotImplementedError is raised in IO.copy_stream with offset.

	* lib/webrick/httpservlet/filehandler.rb (multipart_body): ditto.

Wed Mar 28 23:08:46 2018  Eric Wong  <normalperson@yhbt.net>

	webrick: support Proc objects as body responses

	* lib/webrick/httpresponse.rb (send_body): call send_body_proc
	  (send_body_proc): new method
	  (class ChunkedWrapper): new class

	* test/webrick/test_httpresponse.rb (test_send_body_proc): new test
	  (test_send_body_proc_chunked): ditto
	  [Feature #855]

	webrick: favor .write over << method

	This will make the next change to use IO.copy_stream
	easier-to-read.  When we can drop Ruby 2.4 support in a few
	years, this will allow us to use writev(2) with multiple
	arguments for headers and chunked responses.

	* lib/webrick/cgi.rb (write): new wrapper method
	  lib/webrick/httpresponse.rb: (send_header): use socket.write
	  (send_body_io): ditto
	  (send_body_string): ditto
	  (send_body_proc): ditto
	  (_write_data): ditto
	  (ChunkedWrapper#write): ditto
	  (_send_file): ditto

	webrick/httpresponse: IO.copy_stream for regular files

	Remove the redundant _send_file method since its functionality
	is unnecessary with IO.copy_stream.  IO.copy_stream also allows
	the use of sendfile under some OSes to speed up copies to
	non-TLS sockets.

	Testing with "curl >/dev/null" and "ruby -run -e httpd" to
	read a 1G file over Linux loopback reveals a reduction from
	around ~0.770 to ~0.490 seconds on the client side.

	* lib/webrick/httpresponse.rb (send_body_io): use IO.copy_stream
	  (_send_file): remove
	  [Feature #14237]

	webrick: use IO.copy_stream for single range response

	This is also compatible with range responses generated
	by Rack::File (tested with rack 2.0.3).

	* lib/webrick/httpresponse.rb (send_body_io): use Content-Range
	* lib/webrick/httpservlet/filehandler.rb (make_partial_content):
	  use File object for the single range case
	* test/webrick/test_filehandler.rb (get_res_body): use send_body
	  to test result

	test/webrick/test_filehandler.rb: stricter multipart range test

	We need to ensure we generate compatibile output in
	the face of future changes

	* test/webrick/test_filehandler.rb (test_make_partial_content):
	  check response body

	webrick: quiet warning for multi-part ranges

	Content-Length is ignored by WEBrick::HTTPResponse even if we
	calculate it, so instead we chunk responses to HTTP/1.1 clients
	and terminate HTTP/1.0 connections.

	* lib/webrick/httpservlet/filehandler.rb (make_partial_content):
	  quiet warning

	webrick/httpresponse: make ChunkedWrapper copy_stream-compatible

	The .write method needs to return the number of bytes written
	to avoid confusing IO.copy_stream.

	* lib/webrick/httpresponse.rb (ChunkedWrapper#write): return bytes written
	  (ChunkedWrapper#<<): return self

	webrick: use IO.copy_stream for multipart response

	Use the new Proc response body feature to generate a multipart
	range response dynamically.  We use a flat array to minimize
	object overhead as much as possible; as many ranges may fit
	into an HTTP request header.

	* lib/webrick/httpservlet/filehandler.rb (multipart_body): new method
	  (make_partial_content): use multipart_body

Wed Mar 28 21:24:24 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	unixsocket.c: abstract namespace

	* ext/socket/unixsocket.c (unixsock_path_value): fix r62991 for
	  Linux abstract namespace.

Wed Mar 28 19:36:24 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	pack.c: fix underflow

	* pack.c (pack_unpack_internal): get rid of underflow.
	  https://hackerone.com/reports/298246

Wed Mar 28 19:30:54 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	unixsocket.c: check NUL bytes

	* ext/socket/unixsocket.c (rsock_init_unixsock): check NUL bytes.
	  https://hackerone.com/reports/302997

Wed Mar 28 19:29:03 2018  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	Ignore file separator from tmpfile/tmpdir name.

Wed Mar 28 19:24:20 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	dir.c: check NUL bytes

	* dir.c (GlobPathValue): should be used in rb_push_glob only.
	  other methods should use FilePathValue.
	  https://hackerone.com/reports/302338

	* dir.c (rb_push_glob): expand GlobPathValue

Wed Mar 28 18:04:37 2018  Eric Wong  <normalperson@yhbt.net>

	webrick: prevent response splitting and header injection

	Original patch by tenderlove (with minor style adjustments).

	* lib/webrick/httpresponse.rb (send_header): call check_header
	  (check_header): raise on embedded CRLF in header value
	* test/webrick/test_httpresponse.rb
	  (test_prevent_response_splitting_headers): new test
	* (test_prevent_response_splitting_cookie_headers): ditto

Wed Mar 28 18:04:37 2018  Eric Wong  <normalperson@yhbt.net>

	webrick: use IO.copy_stream for multipart response

	Use the new Proc response body feature to generate a multipart
	range response dynamically.  We use a flat array to minimize
	object overhead as much as possible; as many ranges may fit
	into an HTTP request header.

	* lib/webrick/httpservlet/filehandler.rb (multipart_body): new method
	  (make_partial_content): use multipart_body

	webrick/httprequest: limit request headers size

	We use the same 112 KB limit started (AFAIK) by Mongrel, Thin,
	and Puma to prevent malicious users from using up all the memory
	with a single request.  This also limits the damage done by
	excessive ranges in multipart Range: requests.

	Due to the way we rely on IO#gets and the desire to keep
	the code simple, the actual maximum header may be 4093 bytes
	larger than 112 KB, but we're splitting hairs at that point.

	* lib/webrick/httprequest.rb: define MAX_HEADER_LENGTH
	  (read_header): raise when headers exceed max length

	webrick/httpservlet/cgihandler: reduce memory use

	WEBrick::HTTPRequest#body can be passed a block to process the
	body in chunks.  Use this feature to avoid building a giant
	string in memory.

	* lib/webrick/httpservlet/cgihandler.rb (do_GET):
	  avoid reading entire request body into memory
	  (do_POST is aliased to do_GET, so it handles bodies)

	webrick/httprequest: raise correct exception

	"BadRequest" alone does not resolve correctly, it is in the
	HTTPStatus namespace.

	* lib/webrick/httprequest.rb (read_chunked): use correct exception
	* test/webrick/test_httpserver.rb (test_eof_in_chunk): new test

	webrick/httprequest: use InputBufferSize for chunked requests

	While WEBrick::HTTPRequest#body provides a Proc interface
	for streaming large request bodies, clients must not force
	the server to use an excessively large chunk size.

	* lib/webrick/httprequest.rb (read_chunk_size): limit each
	  read and block.call to :InputBufferSize in config.
	* test/webrick/test_httpserver.rb (test_big_chunks): new test

	webrick: add test for Digest auth-int

	No changes to the actual code, this is a new test for
	a feature for which no tests existed.  I don't understand
	the Digest authentication code well at all, but this is
	necessary for the subsequent change.

	* test/webrick/test_httpauth.rb (test_digest_auth_int): new test
	  (credentials_for_request): support bodies with POST

	webrick/httpauth/digestauth: stream req.body

	WARNING! WARNING! WARNING!  LIKELY BROKEN CHANGE

	Pass a proc to WEBrick::HTTPRequest#body to avoid reading a
	potentially large request body into memory during
	authentication.

	WARNING! this will break apps completely which want to do
	something with the body besides calculating the MD5 digest
	of it.

	Also, keep in mind that probably nobody uses "auth-int".
	Servers such as Apache, lighttpd, nginx don't seem to
	support it; nor does curl when using POST/PUT bodies;
	and we didn't have tests for it until now...

	* lib/webrick/httpauth/digestauth.rb (_authenticate): stream req.body

Wed Mar 28 15:48:30 2018  Kazuki Yamaguchi <k@rhe.jp>

	backport some changes from openssl gem v2.0.6 and v2.0.7.
	[Backport #13935]

Wed Mar 28 15:24:15 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	Fix setting method visibility on method wrapped with prepend

	Ignore prepended modules when looking for already defined methods on a
	class to set the visibility on.
	[Fix GH-1834]

	From: Dylan Thacker-Smith Dylan.Smith@shopify.com

Wed Mar 28 15:02:43 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	resolv.rb: close socket

	* lib/resolv.rb (UnconnectedUDP#lazy_initialize): store new
	  sockets before binding, so the sockets get closed when the
	  requester is closing.

	* lib/resolv.rb (ConnectedUDP#lazy_initialize): ditto.

	* lib/resolv.rb (UnconnectedUDP#close): synchronize to get rid of
	  race condition.

	* lib/resolv.rb (ConnectedUDP#close): ditto.

	[Bug #14571]

	From: quixoten (Devin Christensen) quixoten@gmail.com

Wed Mar 28 14:59:27 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	socket.c: null byte at Socket.getnameinfo

	* ext/socket/socket.c (sock_s_getnameinfo): check null byte. patched by
	  tommy (Masahiro Tomita) in . [Bug #13994]

Wed Mar 28 14:53:57 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	date_core.c: defensive code

	* ext/date/date_core.c (f_cmp): check comparison failure.

	* ext/date/date_core.c (d_lite_step): deal with the comparison
	  result more defensively. [Bug #14549]

Wed Mar 28 14:50:52 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	string.c: clear substring code range

	* string.c (str_substr): substring of broken code range string may be
	  valid or broken. patch by tommy (Masahiro Tomita) at [Bug #14388].

Wed Mar 28 14:48:13 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	win32.c: memcpy instead of strlcpy

	* win32/win32.c (cmdglob): memcpy the exact size instead of
	  strlcpy with +1.

	* win32/win32.c (w32_cmdvector): ditto, with NUL-terminating.

Wed Mar 28 14:45:02 2018  Koichi Sasada  <ko1@atdot.net>

	check array for zsuper. [Bug #14279]

	* compile.c (iseq_compile_each0): for zsuper (NODE_ZSUPER), we need to
	  check given argument is Array or not.

	* test/ruby/test_super.rb: add a test for this bug.

Wed Mar 28 14:40:25 2018  Eric Wong  <normalperson@yhbt.net>

	net/ftp: fix FrozenError in BufferedSocket

	I noticed this bug while working on something else with
	RUBYOPT=-d on, existing test cases all passed with it.

	Note: I use String.new because it is the local style, here,
	I prefer +'' (or ''.b, for a future commit)

	* lib/net/ftp.rb (BufferedSocket#read): use String.new
	* test/net/ftp/test_buffered_socket.rb (test_read_nil): new test
	  [Bug #14323]

Wed Mar 28 14:29:26 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	clean autogenerated files

	* enc/depend (clean, clean-srcs): fix path of name2ctype.h, and
	  remove casefold.h too.

	* enc/jis/props.h: autogenerated file.
	  [Bug #13493]

	Update sources and include files after update

	Ignore enc/jis/props.h

Wed Mar 28 14:14:25 2018  URABE Shyouhei  <shyouhei@ruby-lang.org>

	fix SEGV touching uninitialized memory
	This function can be called from boot_defclass().
	No assumption can be made about object internals.

	fix SEGV touching uninitialized memory
	This function can be called from InitVM_Object().
	No assumption can be made about object internals.

	fix SEGV touching uninitialized local variable
	This imemo_name is used uninitialized because the switch
	above does not cover all possible imemo types.

	fix SEGV inspecting already freed objects
	obj_info() assumes the given object is alive. Passing freed
	objects to it results in SEGV.

	fix SEGV inspecting uninitialized objects
	obj_info() assumes the given object is alive. OTOH
	gc_writebarrier_incremental is called before or in middle of
	object initialization. Can casue SEGV.

Wed Mar 28 13:56:17 2018  NARUSE, Yui  <naruse@ruby-lang.org>

	raise error if value contains CR/LF in iniheader of
	initialize_http_header

	like r59693, initialize_http_header also should raise error.
	[Bug #14208]

Wed Mar 28 13:48:35 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	parse.y: end of script at newline

	* parse.y (parser_yylex): deal with end of script chars just after
	  ignored newline as other places. [Bug #14206]

Wed Mar 28 13:42:55 2018  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	[DOC] IO.new accepts external_encoding

	Revert part of r61278 [Bug #13655]
	[ci skip]

Wed Mar 28 13:42:55 2018  NARUSE, Yui  <naruse@ruby-lang.org>

	IO.new doesn't receive "-" as external_encoding [Bug #13655]

Thu Mar 22 15:38:43 2018  NAKAMURA Usaku  <usa@ruby-lang.org>

	Removed the obstacle to running test-all with VC14.

	* test/fiddle/test_import.rb (LIBC.fprintf): VC14's `fprintf` is very distinct
	  name, then, just ignore this test.

Thu Mar 22 12:28:23 2018  NAKAMURA Usaku  <usa@ruby-lang.org>

	merge https://github.com/ruby/openssl/commit/3af2635f117f8da563d180bc1c58702aecb16e0c
	patched by Kazuki Yamaguchi <k@rhe.jp>

	bio: prevent possible GC issue in ossl_obj2bio()

	Prevent the new object created by StringValue() from being GCed.
	Luckily, as none of the callers of ossl_obj2bio() reads from the
	returned BIO after possible triggering GC, this has not been a real
	problem.

	As a bonus, ossl_protect_obj2bio() function which is no longer used
	anywhere is removed.

	merge https://github.com/ruby/openssl/commit/f842b0d5c5e37527c11954a4b7a98c8d9cc57865
	patched by Kazuki Yamaguchi <k@rhe.jp>

	bio: do not use the FILE BIO method in ossl_obj2bio()

	Read everything from an IO object into a String first and use the
	memory buffer BIO method just as we do for String inputs.

	For MSVC builds, the FILE BIO method uses the "UPLINK" interface that
	requires the application to provide OPENSSL_Applink() function. For us,
	the "application" means ruby.exe, in which we can't do anything. As a
	workaround, avoid using the FILE BIO method at all.

	Usually private keys or X.509 certificates aren't that large and the
	temporarily increased memory usage hopefully won't be an issue.

	ext/openssl/ossl_version.h (OpenSSL::VERSION): bump to 1.1.1.

Thu Mar 22 11:24:43 2018  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (set_pioinfo_extra): use more reliable way to search
	  the position of pioinfo of VC14, and also support debug library of it.
	  patched by davispuh AT gmail.com
	  [ruby-core:76644] [Bug #12644]
	  this fixes also [Bug #12631]

Thu Mar 22 11:24:43 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	win32.c: suppress warnings

	* win32/win32.c (set_pioinfo_extra): remove "/*" within comment.

Thu Mar 22 11:24:43 2018  NARUSE, Yui  <naruse@ruby-lang.org>

	Support MSVC14 and 15 [Bug #11118]

	Search _pioinfo which is not exported after MSVC14.
	[Bug #12014] [GH-884]

Mon Mar 19 00:34:38 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	win32.c: unknown reparse tags

	* win32/win32.c (rb_w32_read_reparse_point): skip unknown reparse tags.
	  [Bug #14047]

Mon Mar 19 00:32:31 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/ruby/test_lazy_enumerator.rb: test for [Bug #14082]

	enum.c: check argument first

	* enum.c (enum_cycle_size): check an argument before the size of the
	  receiver, if it is given.

Mon Mar 19 00:32:31 2018  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	Fix size on Enumerable#cycle when the size is 0 [Bug #14082].

	Patch by Kenichi Kamiya

Mon Mar 19 00:28:28 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_here_document): an escaped newline is not an
	  actual newline, and the rest part should not be dedented.
	  [ruby-core:72855] [Bug #11989]

Mon Mar 19 00:27:06 2018  Koichi Sasada  <ko1@atdot.net>

	thread_pthread: do not corrupt stack

	This fixes stuck test/ruby/test_io.rb with FIBER_USE_NATIVE=0 on
	GNU/Linux because linked-list pointers used by glibc get
	corrupted when fiber stacks are copied.

	Thanks to wanabe for finding the bug and original patch.

	* thread_pthread (native_thread_init_stack): fix stack corruption
	  [Bug #13387]

Mon Mar 19 00:22:52 2018  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	TracePoint#enable, #disable: Don't yield any argument. [Bug #14057]

Mon Mar 19 00:21:00 2018  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	Clarify the behavior of IO.write without offset in write mode.

	https://github.com/ruby/ruby/pull/1571

	Patch by takanabe (Takayuki Watanabe) [fix GH-1571]
	[Bug #11638]

Mon Mar 19 00:16:28 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	parse.y: token info with BOM

	* parse.y (parser_prepare): set token_info_enabled flag first, before
	  returning at BOM. [Bug #13998]

Mon Mar 19 00:06:43 2018  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	io.c: fix segfault with closing socket on Windows

	* io.c (fptr_finalize_flush): add an argument to keep GVL.

	* io.c (fptr_finalize): adjust for above change.

	* io.c (io_close_fptr): closing without GVL causes another exception
	  while raising exception in another thread. This causes segfault on
	  Windows. Keep GVL while closing when another thread raises.
	  [Bug #13856]

Mon Mar 19 00:04:08 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/forwardable.rb (_delegator_method): leave the backtrace
	  untouched during accessor.  forwardable.rb does not appear in
	  the backtrace during delegated method because of tail-call
	  optimization.

Sun Mar 18 23:59:32 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	dup String#partition return value

	* string.c (rb_str_partition): return duplicated receiver, when no
	  splits. [Bug#13925]

	Author: Seiei Miyagi hanachin@gmail.com

	dup String#rpartition return value

	* string.c (rb_str_rpartition): return duplicated receiver, when no
	  splits. [Bug#13925]

	Author: Seiei Miyagi hanachin@gmail.com

	dup String#split return value

	* string.c (rb_str_split): return duplicated receiver, when no splits.
	  patched by tompng (tomoya ishida) in , and the test case by Seiei
	  Miyagi hanachin@gmail.com. [Bug#13925] [Fix GH-1705]

Sun Mar 18 23:57:32 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	ruby.c: paragraph mode by -00

	* ruby.c (proc_options): set to paragraph mode, if -00 is given, as
	  well as perl and -R0 option in 0.49. [Bug #13736]

Sun Mar 18 23:55:23 2018  Eric Wong  <normalperson@yhbt.net>

	process: block/unblock signals around fork

	As with forking for execve(2) in spawn', we must block signals
	to ensure they are handled correctly in a freshlyfork'-ed child.

	* process.c (retry_fork_ruby): block/unblock signals around fork
	  (rb_fork_ruby): re-enable signals in forked child

	* test/ruby/test_process.rb (test_forked_child_signal): new test
	  [Bug #13916]

	Thanks to Russell Davis for the bug report and test case.

Sun Mar 18 23:52:37 2018  Kazuki Tsujimoto  <kazuki@callcc.net>

	vm.c: fix `cfp consistency error' which occurs when raising exception
	in bmethod call event

	* vm.c (invoke_bmethod): set FINISH flag just before calling vm_exec.
	  [Bug #13705]

Sun Mar 18 23:36:24 2018  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	added workaround for APFS file format.

	* TestFileExhaustive#test_atime: It fails with nano-sec precise. I
	  changed to use unixtime for this assertion for APFS.

	* TestFileExhaustive#test_expand_path: skip assertion when given
	  invalid charactor on APFS.

	[Bug #13816]

Sun Mar 18 23:36:04 2018  NARUSE, Yui  <naruse@ruby-lang.org>

	High Sierra's APFS cannot use invalid filenames [Bug #13816]

Sun Mar 18 23:31:44 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	test_framework.rb: for case-sensitive filesystem

	* test/mkmf/test_framework.rb (test_single_framework): fix header
	  file name for case-sensitive filesystem. it may not be same as
	  the framework name, but should be the actual file name.
	  [Bug #13489]

	* test/mkmf/test_framework.rb (test_multi_frameworks): ditto.

	test_file_exhaustive.rb: check case-sensitive fs

	* test/ruby/test_file_exhaustive.rb (test_expand_path): dump expanded
	  file name, not only appended char, for case-sensitive filesystem.
	  [Bug #13489]

Sun Mar 18 23:29:14 2018  Masaki Suketa <masaki.suketa@nifty.ne.jp>

	* test/win32ole/test_word.rb: word quit without confirmation dialog to
	  save files. [Bug #13894] Thanks to h.shirosaki.

Sun Mar 18 23:26:20 2018  NARUSE, Yui  <naruse@ruby-lang.org>

	fix the case High Sierra's mincore(2) may return -128 [Bug #13895]

Sun Mar 18 23:23:48 2018  Koichi Sasada  <ko1@atdot.net>

	skip unless PLATFORM is darwin.

Sun Mar 18 23:23:48 2018  NARUSE, Yui  <naruse@ruby-lang.org>

	Treat NULL reference case [Bug #13566]

	Fix C level backtrace on Darwin
	SEGV caused by invalid instruction call.

Sun Mar 18 23:11:29 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (ARFLAGS): check if deterministic mode flag is
	  effective, which is on by default on Ubuntu.

	* configure.in: use libtool on macOS to suppress a warning against
	  debug_counter.o, which has no symbols unless USE_DEBUG_COUNTER is
	  set to non-zero.

	* configure.in: use newer libtool only

Sat Feb 17 01:21:00 2018  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	Merge RubyGems 2.7.6 from upstream.

	It fixed some security vulnerabilities.

	http://blog.rubygems.org/2018/02/15/2.7.6-released.html

	fix regexp literal warning.

	* test/rubygems/test_gem_server.rb: eliminate duplicated character class warning.
	  [Bug #14481]

Thu Feb  1 04:00:53 2018  NARUSE, Yui  <naruse@ruby-lang.org>

	Remove debug print introduced in r52386

Wed Jan 31 22:57:42 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	configure.in: link Foundation framework

	* configure.in (XLDFLAGS): link against Foundation framework and
	  let __NSPlaceholderDictionary initialize, to get rid of crash
	  after fork on macOS High Sierra.  [ruby-core:83239] [Bug #14009]

Wed Jan 31 22:51:59 2018  Pete Higgins  <pete@peterhiggins.org>

	* thread_sync.c (Init_thread_sync): Remove confusing doc comments,
	  which are picked up by rdoc unexpectedly, from Queue and
	  SizedQueue.  [Fix GH-1450]

Wed Jan 31 22:48:41 2018  Eric Wong  <normalperson@yhbt.net>

	thread_pthread.c: do not wakeup inside child processes

	* thread_pthread.c (rb_thread_wakeup_timer_thread): check
	  ownership before incrementing
	  (rb_thread_wakeup_timer_thread_low): ditto
	  [Bug #13794] [ruby-core:83064]

Wed Jan 31 22:46:36 2018  Rei Odaira  <Rei.Odaira@gmail.com>

	* configure.in (rb_cv_lgamma_r_pm0): check if lgamma_r(+0.0)
	  returns positive infinity, in addition to lgamma_r(-0.0).
	  AIX returns an incorrect result of negative infinity.

	* math.c (ruby_lgamma_r): handle +0.0, in addition to -0.0.

Wed Jan 31 22:32:08 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	ext: check if null byte is contained

	[ruby-dev:50267] [Bug #13953]

Wed Jan 31 22:29:57 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	string.c: fix ASCII-only on succ

	* string.c (str_succ): clear coderange cache when no alpha-numeric
	  character case, carried part may become ASCII-only.
	  [ruby-core:83062] [Bug #13952]

Wed Jan 31 22:28:20 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	pack.c: unpack "M" may be ASCII only

	* pack.c (pack_unpack_internal): set ASCII only properly on "M",
	  may be ASCII only.  [ruby-core:83055] [Bug #13949]

Wed Jan 31 22:26:13 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	string.c: ASCII-incompatible is not ASCII only

	* string.c (tr_trans): ASCII-incompatible encoding strings cannot
	  be ASCII-only even if valid.  [ruby-core:83056] [Bug #13950]

Wed Jan 31 22:24:05 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	vm.c: fetch retval iff necessary

	* vm.c (rb_vm_make_jump_tag_but_local_jump): get rid of fetching
	  retval when it is not used.  it is necessary for local jump
	  state only.

Wed Jan 31 22:16:00 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	compile.c: fix stack consitency error

	* compile.c (iseq_compile_each0): fix stack consitency error on
	  attr-assign with safe navigation operator when the receiver is
	  nil, should pop it too.  [ruby-core:83078] [Bug #13964]

	test_call.rb: refine test_safe_call

	* test/ruby/test_call.rb (test_safe_call): rhs should not be
	  evaluated when the receiver is nil.  simplified the assertion
	  for  [Bug #13964].

Wed Jan 31 22:12:48 2018  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	adjust indent

	* vm_insnhelper.c (vm_call_method_each_type): adjust indent of a
	  block in switch.

	visibility of inherited method

	* vm_insnhelper.c (vm_call_method_each_type): honor the original
	  visibility of inherited methods when a refinement is defined but
	  not activated.  [ruby-core:82209] [Bug #13776]

	Author:    Mon_Ouie (Mon ouie) <mon.ouie@gmail.com>

Wed Jan 31 20:47:07 2018  NARUSE, Yui  <naruse@ruby-lang.org>

	HTTPHeader#add_field should allow binary [Bug #13926]

Wed Jan 31 20:42:11 2018  Marcus Stollsteimer  <sto.mar@web.de>

	ri.1: rewrite ri man page

	* man/ri.1: update the (very outdated) ri man page:
	  * update document date
	  * fix document title formatting and volume name
	  * update descriptions and options to current ri --help text
	  * fix some mdoc formatting errors (missing escaping of `\',
	    wrong macro for bullet list items)
	  * various rewordings and other improvements

	improve man pages

	* man/ruby.1, man/erb.1, man/goruby.1, man/irb.1:
	  fix document title formatting and volume name,
	  improve "REPORTING BUGS" section: fix mdoc formatting error
	  (wrong macro for bullet list items), small rewordings.

Wed Jan 31 20:25:09 2018  Shugo Maeda  <shugo@ruby-lang.org>

	lib/net/imap.rb: Ignore trailing space for Microsoft Exchange Server

	Based on the patch by keysen (Jeremy Carlier).
	[ruby-core:81641] [Bug #13649]

Wed Jan 31 20:23:49 2018  sorah (Shota Fukumori)  <her@sorah.jp>

	Add documents on Process::CLOCK_* constants

	* process.c: Add documents on Process::CLOCK_* constants.
	  Patch by Sunao Komuro <sunao-komuro@cookpad.com>.
	  Closes [GH-1567] [Bug #13386]

Wed Jan 31 20:11:20 2018  Marcus Stollsteimer  <sto.mar@web.de>

	ri.1: fix errors in ri man page

	* man/ri.1: fix some errors in ri man page (add missing options,
	  remove options that do not exist, fix formatter list).

	  Reported by Josh Cheek.  [ruby-core:68065] [Bug #10838]

Wed Jan 31 20:09:50 2018  Marcus Stollsteimer  <sto.mar@web.de>

	date_core.c: fix error in DateTime docs

	* ext/date/date_core.c: [DOC] fix format string for DateTime#rfc3339.
	  Reported by Andreas Rayo Kniep.  [ruby-core:68418] [Bug #10936]

	* ext/date/date_core.c: [DOC] ditto for DateTime#iso8601 and
	  DateTime#xmlschema; other small improvements.

Wed Jan 31 20:04:47 2018  Marcus Stollsteimer  <sto.mar@web.de>

	lib/ostruct.rb: [DOC] revise docs for OpenStruct

	* update paragraph on implementation:
	  define_singleton_method is used, not define_method
	* add call-seq with return values for each_pair
	* adopt description of dig from Array and Hash
	* fix description of the hash method
	* :nodoc: initialize_copy, respond_to_missing?
	* other small improvements, e.g. use the term `attribute' in the docs
	  (instead of `member'), which is clearer for users of the class
	* improve code examples: e.g. use more consistent style (always use
	  double quotes, drop `p' and `puts', ...), update inspect output,
	  use example data that is not prone to change (like population)
	* add more code examples
	* fix some small errors and grammar

	[ruby-core:79265] [Bug #13159]

Wed Jan 31 20:02:29 2018  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	rational.c: fix rdoc

	* rational.c: [DOC] fix wrong indentations and comment out some lines
	  in code examples to make them valid Ruby code and syntax highlighted
	  on the rendered page.

	[ci skip] [Bug #13233]
	Author: Marcus Stollsteimer sto.mar@web.de

Wed Jan 31 19:57:09 2018  Eric Wong  <normalperson@yhbt.net>

	doc: Add example for Symbol#to_s

	* string.c: add example for Symbol#to_s.

	The docs for Symbol#to_s only include an example for
	Symbol#id2name, but not for #to_s which is an alias;
	the docs should include examples for both methods.

	From: Marcus Stollsteimer <sto.mar@web.de>

Wed Jan 31 19:49:44 2018  Reiner Herrmann  <reiner@reiner-h.de>

	* lib/mkmf.rb (create_makefile): sort lists of source and object
	  files in generated Makefile, unless given by extconf.rb.
	  [Fix GH-1367]

Fri Dec 15 03:48:55 2017  NAKAMURA Usaku  <usa@ruby-lang.org>

	* version.h: Bump version to 2.3.7

Thu Dec 14 23:53:41 2017  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/net/ftp/test_ftp.rb (process_port_or_eprt): merge a part of
	  r56973 to pass the test introduced at previous commit.

Thu Dec 14 22:55:05 2017  Shugo Maeda  <shugo@ruby-lang.org>

	Fix a command injection vulnerability in Net::FTP.

Thu Dec 14 22:35:19 2017  Eric Wong  <normalperson@yhbt.net>

	webrick: compile RE correctly for beginning and end match

	Using ^ and $ in regexps means we can accidentally get fooled
	by "%0a" in HTTP request paths being decoded to newline
	characters.  Use \A and \z to match beginning and end-of-string
	respectively, instead.

	Thanks to mame and hsbt for reporting.

	* lib/webrick/httpserver.rb (MountTable#compile):
	  use \A and \z instead of ^ and $
	* lib/webrick/httpserver.rb (MountTable#normalize): use \z instead of $
	* test/webrick/test_httpserver.rb (test_cntrl_in_path): new test

Thu Dec 14 22:29:04 2017  Eric Wong  <normalperson@yhbt.net>

	webrick: do not hang acceptor on slow TLS connections

	OpenSSL::SSL::SSLSocket#accept may block indefinitely on clients
	which negotiate the TCP connection, but fail (or are slow) to
	negotiate the subsequent TLS handshake.  This prevents the
	multi-threaded WEBrick server from accepting other connections.

	Since the TLS handshake (via OpenSSL::SSL::SSLSocket#accept)
	consists of normal read/write traffic over TCP, handle it in the
	per-client thread, instead.

	Furthermore, using non-blocking accept() is useful for non-TLS
	sockets anyways because spurious wakeups are possible from
	select(2).

	* lib/webrick/server.rb (accept_client): use TCPServer#accept_nonblock
	  and remove OpenSSL::SSL::SSLSocket#accept call
	* lib/webrick/server.rb (start_thread): call OpenSSL::SSL::SSLSocket#acc
ept
	* test/webrick/test_ssl_server.rb (test_slow_connect): new test
	  [ruby-core:83221] [Bug #14005]

	webrick: fix up r60172

	By making the socket non-blocking in r60172, TLS/SSL negotiation
	via the SSL_accept function must handle non-blocking sockets
	properly and retry on SSL_ERROR_WANT_READ/SSL_ERROR_WANT_WRITE.
	OpenSSL::SSL::SSLSocket#accept cannot do that properly with a
	non-blocking socket, so it must use non-blocking logic of
	OpenSSL::SSL::SSLSocket#accept_nonblock.

	Thanks to MSP-Greg (Greg L) for finding this.

	* lib/webrick/server.rb (start_thread): use SSL_accept properly
	  with non-blocking socket.
	  [Bug #14013] [Bug #14005]

	webrick: fix up r60172 and revert r60189

	Thanks to MSP-Greg (Greg L) for helping with this.

	* lib/webrick/server.rb (start_thread): ignore ECONNRESET, ECONNABORTED,
	  EPROTO, and EINVAL on TLS negotiation errors the same way they
	  were ignored before r60172 in the accept_client method of the
	  main acceptor thread.
	  [Bug #14013] [Bug #14005]

	webrick: fix up r60172 and r60208

	Thanks to MSP-Greg (Greg L) for helping with this.

	* lib/webrick/server.rb (start_thread): fix non-local return
	  introduced in r60208

	webrick: fix up r60172 and r60210

	Thanks to MSP-Greg (Greg L) for helping with this.

	* lib/webrick/server.rb (start_thread): properly fix non-local return
	  introduced in r60208 and r60210

Thu Nov 30 23:37:08 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	parse.y: fix line in rescue

	* parse.y (set_line_body, primary): fix line number of bodystmt as the
	  beginning of the block. [Bug #13181]

Thu Nov 30 23:29:00 2017  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	Merge rubygems-2.6.14 changes.

	It fixed http://blog.rubygems.org/2017/10/09/unsafe-object-deserialization-vulnerability.html

Fri Sep 15 05:40:40 2017  URABE Shyouhei  <shyouhei@ruby-lang.org>

	fix --with-gmp (broken by r57490)

	Looking at the generated shell script (also the autoconf manual), it
	seems AC_SEARCH_LIBS() m4 macro does not define HAVE_LIBsomething C
	preprocessor macros, unlike AC_CHECK_LIB() which does define them.
	This previous change effectively killed building with GMP because
	building that mode depends on existence of HAVE_LIBGMP. [Bug #13402]

Thu Sep 14 20:25:55 2017  Yusuke Endoh  <mame@ruby-lang.org>

	lib/webrick/log.rb: sanitize any type of logs

	It had failed to sanitize some type of exception messages.  Reported and
	patched by Yusuke Endoh (mame) at https://hackerone.com/reports/223363

Thu Sep 14 13:32:39 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	parse.y: empty hash in defined

	* parse.y (command): NODE_ARRAY with NULL is invalid.  traversal
	  in defined_expr0 is simplified than iseq_compile_each0.
	  [ruby-core:82113] [Bug #13756]

Thu Sep 14 13:26:31 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	string.c: fix false coderange

	* string.c (rb_enc_str_scrub): enc can differ from the actual encoding
	  of the string, the cached coderange is useless then. [Bug #13874]

Thu Sep 14 13:24:51 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	parse.y: primary should not be 0

	* parse.y (primary): should not be 0, since it can be a receiver.
	  [ruby-core:82447] [Bug #13836]

Thu Sep 14 13:19:30 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	vm_method.c: alias warning at refined method

	* vm_method.c (rb_method_entry_make): suppress a warning at
	  refined method which will not be redefined.
	  [ruby-core:82385] [Bug #13817]

Thu Sep 14 13:14:19 2017  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/bigdecimal/bigdecimal.c (BigDecimal_hash): st_index_t may not be
	  fixable on 64bit mswin/mingw.

	* ext/date/date_core.c (d_lite_hash): ditto.
	  [Backport #13877]

	* ext/openssl/ossl_bn.c (ossl_bn_hash): ditto.

Sat Sep  9 23:05:31 2017  Kazuki Yamaguchi <k@rhe.jp>

	asn1: fix out-of-bounds read in decoding constructed objects

	* OpenSSL::ASN1.{decode,decode_all,traverse}: have a bug of
	  out-of-bounds read. int_ossl_asn1_decode0_cons() does not give the
	  correct available length to ossl_asn1_decode() when decoding the
	  inner components of a constructed object. This can cause
	  out-of-bounds read if a crafted input given.

	Reference: https://hackerone.com/reports/170316
	https://github.com/ruby/openssl/commit/1648afef33c1d97fb203c82291b8a61269e85d3b

Sat Sep  9 22:57:24 2017  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* ext/json: bump to version 1.8.3.1. [Backport #13853]

Sat Sep  9 22:50:10 2017  NARUSE, Yui  <naruse@ruby-lang.org>

	A HTTP Header value must not contain CR or LF.
	to_str -> to_s

	* lib/net/http/header.rb (set_field): `val` can not have `to_str`.

Sat Sep  9 22:42:22 2017  Kouhei Sutou  <kou@cozmixng.org>

	* REXML: Fix a bug that unexpected methods can be called as a XPath
	  function. [HackerOne:249295] Reported by Andrea Jegher. Thanks!!!

Sat Sep  9 22:16:01 2017  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/rubygems: fix several vulnerabilities in RubyGems; bump to version
	  2.5.2.1. [Backport #13842]

Wed Aug  9 22:27:23 2017  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_syntax.rb (test_invalid_{break,next}): use
	  assert_in_out_err instead of assert_syntax_error because on ruby_2_3
	  assert_syntax_error uses eval.

Wed Aug  9 22:27:23 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_compile_each0): turned dregx context in "once"
	  into "guarded" type from "block" type, to disallow `next`,
	  `break`, `redo` as well as outside "once".
	  [Bug #13690]

Wed Aug  9 21:28:34 2017  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_process.rb (test_rlimit_{name,value}): test in UTF-8
	  encoding.  fix test failures introduced at r59531 on some platforms.

Wed Aug  9 21:16:22 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* marshal.c (rb_marshal_dump_limited): do not free dump_arg, which
	  may be dereferenced in check_dump_arg due to continuation, and
	  get rid of dangling pointers.

	* marshal.c (rb_marshal_load_with_proc): ditto for load_arg.

Wed Aug  9 21:13:24 2017  NAKAMURA Usaku  <usa@ruby-lang.org>

	* compile.c (iseq_compile_each): remove unused definition of unused
	  variable derived from original patch.

Wed Aug  9 19:45:16 2017  sorah (Shota Fukumori)  <her@sorah.jp>

	Init_frozen_strings definition is removed in r51511.
	https://bugs.ruby-lang.org/issues/11423

	Patch by Kohei Suzuki <eagletmt@gmail.com>

	* internal.h: Remove declaration of unexist function
	  [Fix GH-1558]

Wed Aug  9 19:34:17 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* internal.h (THROW_DATA_P): parenthesize the argument which is
	  casted.

Wed Aug  9 19:34:17 2017  Koichi Sasada  <ko1@atdot.net>

	* vm.c: get return_value from imemo_throw_data object (THROW_DATA_VAL()).
	  imemo_throw_data (TAG_BREAK) contains returned value.
	  However, imemo_throw_data (TAG_BREAK) can skip several frames so that
	  we need to use it only once (at most internal frame). To record it,
	  we introduced THROW_DATA_CONSUMED and check it.

	* internal.h: define THROW_DATA_CONSUMED flag.

	* test/ruby/test_settracefunc.rb: add tests for [Bug #13369]

	* vm_insnhelper.h: add THROW_DATA_CONSUMED_P() and
	  THROW_DATA_CONSUMED_SET().

Wed Aug  9 19:32:17 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* random.c (get_rnd, try_get_rnd): ensure initialized to get rid
	  of crash in forked processes. [Bug #13753]

Wed Aug  9 19:30:34 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/strscan/strscan.c (strscan_aref): fix segfault after
	  get_byte or getch which do not apply regexp.
	  [Bug #13759]

Wed Aug  9 19:28:40 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in: add rpath flags which is needed for OPTDIR as well
	  as -L options, when it is given. [Bug #13411]

Wed Aug  9 19:14:07 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (vm_throw_start): size of catch table has been
	  included in iseq_catch_table struct, which could be NULL, since
	  2.2. e.g., proc-closure in `once'. 

Wed Aug  9 19:09:20 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* node.h (nd_line): should sign-extend.  shifting `VALUE` extends
	  with zero bits if `sizeof(VALUE)` equals to `sizeof(int)`.  the
	  zero bits are truncated if `sizeof(VALUE)` is bigger enough.
	  [ruby-core:80920] [Bug #13523]

Wed Aug  9 17:53:09 2017  NAKAMURA Usaku  <usa@ruby-lang.org>

	* compile.c (iseq_compile_each): the lifetime of new_opt have to be
	  until this case block is end.  this is a part of r57971.
	  [Backport #13766]

Wed Aug  9 17:35:47 2017  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	this patch contains r54158, r57410, r57631 and r57954.

	Prevent GC by volatile [Bug #13150]

	test/ruby/test_marshal.rb test_context_switch (load) and test_gc (dump)
	are failed on FreeBSD 10.3 and gcc7 (FreeBSD Ports Collection) 7.0.0
	20170115 (experimental); RB_GC_GUARD looks not worked well.

	* include/ruby/ruby.h (RB_GC_GUARD): prevent guarded pointer from
	  optimization by using as an input to inline asm.

	* ruby.h: remove comment

	* include/ruby/ruby.h (RB_GC_GUARD): remove comment unsupported by
	  Solaris AS.

	Hidden objects (klass == 0) are not visible to Ruby code invoked
	from other threads or signal handlers, so they can never be
	accessed from other contexts.  This makes it safe to call
	rb_gc_force_recycle on the object slot after releasing malloc
	memory.

	* marshal.c (rb_marshal_dump_limited): hide dump_arg and recycle when
	  done (rb_marshal_load_with_proc): hide load_arg and recycle when done
	  [ruby-core:79518]

	* marshal.c (rb_marshal_dump_limited): do not free dump_arg, which
	  may be dereferenced in check_dump_arg due to continuation, and
	  get rid of dangling pointers.

	* marshal.c (rb_marshal_load_with_proc): ditto for load_arg.

Wed Aug  9 17:28:35 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (setup_exception): make unfrozen copy of special
	  exception before setting up a cause.

Wed Aug  9 17:22:29 2017  TAKANO `takano32' Mitsuhiro  <tak@no32.tk>

	a64: fix crash on register stack mark/sweep pass

	* thread_pthread.c: move 'register_stack_start' earlier.
	  [ruby-core:79928] [Bug #13284] [Fix GH-1625]

	Author:    Sergei Trofimovich <slyfox@gentoo.org>

Wed Aug  9 17:10:27 2017  Shugo Maeda  <shugo@ruby-lang.org>

	* test/net/smtp/test_smtp.rb (test_tls_connect, test_tls_connect):
	  use Socket.tcp_server_sockets in case localhost is resolved to ::1.

Wed Aug  9 17:10:27 2017  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/smtp.rb (tlsconnect): support timeout for TLS handshake.
	  [ruby-core:76893] [Bug #12678]

	* lib/net/protocol.rb (ssl_socket_connect): new method to implement
	  timeout for TLS handshake.

	* lib/net/http.rb (connect): use Net::Protocol#ssl_socket_connect.

Wed Aug  9 17:08:01 2017  NARUSE, Yui  <naruse@ruby-lang.org>

	Zlib::GzipReader#pos underflows after calling #ungetbyte or #ungetc at start of file [Bug #13616]

	patched by Andrew Haines <andrew@haines.org.nz> [ruby-core:81488]
	zlib.c: fix unnormalized Fixnum

	* ext/zlib/zlib.c (rb_gzfile_total_out): cast to long not to
	  result in an unsigned long to normalized to Fixnum on LLP64
	  platforms.  [ruby-core:81488]

Wed Aug  9 17:03:00 2017  Eric Wong  <normalperson@yhbt.net>

	process.c: handle dynamic :rlimit_* symbols in spawn execopts

	* process.c (rb_execarg_addopt_rlimit): hoist out of rb_execarg_addopt
	  (rlimit_type_by_sym): new wrapper for dynamic symbol
	  (rb_execarg_addopt): check for dsym via rlimit_type_by_sym
	* test/ruby/test_process.rb (test_execopts_rlimit): check dsym w/o pindown
	  Add extra check for bogus rlimit args, too.
	  [ruby-core:82033] [Bug #13744]
	process.c: null bytes

	* process.c (rlimit_type_by_sym): prohibit null bytes in key
	  names.  [ruby-core:82033] [Bug #13744]

Wed Aug  9 16:56:52 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	optparse.rb: get rid of eval

	* lib/optparse.rb: try Float() and Integer() instead of eval,
	  which does too much things.


Fri Jul  7 10:58:10 2017  Eric Wong  <e@80x24.org>

	This backport of r58812 is necessary to ease backporting r59028,
	which fixes a real bug.

	* thread.c (struct waiting_fd): declare
	  (rb_thread_io_blocking_region): use on-stack list waiter
	  (rb_notify_fd_close): walk vm->waiting_fds instead
	  (call_without_gvl): remove old field setting
	  (th_init): ditto
	  [Feature #9632]

	* vm_core.h (typedef struct rb_vm_struct): add waiting_fds list

	* (typedef struct rb_thread_struct): remove waiting_fd field
	  (rb_vm_living_threads_init): initialize waiting_fds list

	This should fix bad interactions with test_race_gets_and_close
	in test/ruby/test_io.rb since we ensure rb_notify_fd_close
	continues returning the busy flag after enqueuing the interrupt.

	* thread.c (rb_notify_fd_close): do not enqueue multiple interrupts
	  [ruby-core:81581] [Bug #13632]

	* test/ruby/test_io.rb (test_single_exception_on_close):
	  new test based on script from Nikolay

Wed Jul  5 15:55:35 2017  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/openssl/ossl_cipher.c: remove the encryption key initialization
	  from Cipher#initialize. This is effectively a revert of r32723
	  ("Avoid possible SEGV from AES encryption/decryption", 2011-07-28).
	  the patch is derived from https://github.com/ruby/openssl/commit/8108e0a6db133f3375608303fdd2083eb5115062,
	  written by Kazuki Yamaguchi.
	  [Backport #8221]

Sat Jul  1 00:28:22 2017  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* ext/psych/yaml: update libyaml to 0.1.7.

	* ext/psych/psych.gemspec: bump version to 2.1.0.1.

Fri Jun 30 22:05:39 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_precise_mbclen): check invalid multibyte char at
	  skipping strings following ?x literal string, not to stuck in a
	  infinite loop. [Bug #13672]

Fri Jun 30 22:00:56 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/pathname/lib/pathname.rb (Pathname#plus): UNC root pathname needs
	  a separator. File.basename returns "/" on UNC root, as well as sole
	  drive letter, even if it does not end with a separator. [Bug #13515]

Fri Jun 30 21:57:27 2017  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rexml/parsers/streamparser.rb: add close tag check on end of
	  document to StreamParser [Bug #13636]
	  Reported by Anton Sivakov. Thanks!!!

Fri Jun 30 21:54:01 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (rb_ary_insert): check position to insert even if no elements
	  to be inserted. [Bug #13558]

Fri Jun 30 21:51:40 2017  Marcus Stollsteimer  <sto.mar@web.de>

	* ext/date/date_core.c: [DOC] fix documentation for %Z format of
	  {Date,DateTime}.strftime.
	  Reported by Damon Timm. Based on a patch by nano.
	  [Bug #13231] [Fix GH-1565]

Fri Jun 30 21:46:50 2017  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rss/rss.rb: Accept empty text element as valid element
	  Parser has been accepted it but XML serializer wasn't accepted.
	  Reported by stefano frabetti. Thanks!!!
	  [Bug #13531]

Fri Jun 30 21:40:42 2017  Kazuki Yamaguchi <k@rhe.jp>

	* ext/openssl/ossl_x509store.c: clear error queue after calling
	  X509_LOOKUP_load_file()

	  X509_LOOKUP_load_file(), which ends up calling
	  X509_load_cert_crl_file()
	  internally, may leave error entries in the queue even when it returns
	  non-zero value (which indicates success).

	  This will be fixed by OpenSSL 1.1.1, but can be worked around by
	  clearing the error queue ourselves.

	  Fixes: [Backport #11033]

Fri Jun 30 21:35:16 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gc.c (heap_page_allocate): expand sorted pages before inserting
	  allocated new page. [Bug #12670]

Fri Jun 30 21:33:39 2017  Koichi Sasada  <ko1@atdot.net>

	* gc.c (heap_page_resurrect): do not return tomb_pages when
	  page->freelist == NULL.
	  [Bug #12670]

Fri Jun 30 21:23:20 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vsnprintf.c (BSD_vfprintf): sign and hex-prefix should not be counted
	  in precision. [Bug #8916]

Fri Jun 30 21:20:14 2017  Koichi Sasada  <ko1@atdot.net>

	* thread.c (ruby_thread_stack_overflow): disable VM events when stack
	  overflow occurred; it causes another stack overflow again in making
	  backtrace object, and crashes. [Bug #13425]

	* vm.c (hook_before_rewind): skip rewind hooks if err is
	  SystemStackError because rewind hooks can cause stack overflow again
	  and again.

	* thread.c (ruby_thread_stack_overflow): do not disable all hooks.
	  Additionally, clearing ruby_vm_event_flags is not suitable way
	  to disable hooks.

Fri Jun 30 21:13:25 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (method_super_method): skip prepended modules and continue from
	  the super class of the original class. [Bug #13656]

Fri Jun 30 21:10:48 2017  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/smtp.rb (getok, get_response): raise an ArgumentError when
	  CR or LF is included in a line, because they are not allowed in
	  RFC5321.  Thanks, Jeremy Daer.

Fri Jun 30 21:07:56 2017  NAKAMURA Usaku  <usa@ruby-lang.org>

	* eval.c (exc_setup_cause): need to unfreeze(=dup) the exception before
	  setting cause if its frozen.

Fri Jun 30 21:07:14 2017  Eric Wong  <e@80x24.org>

	thread.c: avoid busy looping on rb_thread_fd_close

	We no longer use it this function, but extensions do, and
	we need to ensure it continues to work for them.

	* thread.c (rb_thread_fd_close): schedule other threads in loop

	* ext/-test-/thread_fd_close/thread_fd_close.c: new file

	* ext/-test-/thread_fd_close/depend: ditto

	* ext/-test-/thread_fd_close/extconf.rb: ditto

	* test/-ext-/thread_fd_close/test_thread_fd_close.rb: new test

Fri Jun 30 20:34:49 2017  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* sample/pty/shl.rb: update sample
	  * Specify frozen_string_literal: true.
	  * Fix TypeError of raise.
	  * Use a character literal instead of Integer.

Fri Jun 30 20:31:59 2017  Marcus Stollsteimer  <sto.mar@web.de>

	* string.c: [DOC] clarify docs for String#split when called with limit
	  and capture groups. Reported by Cichol Tsai. [Bug #13621]

Fri Jun 30 20:23:31 2017  Takashi Kokubun  <takashikkbn@gmail.com>

	* lib/erb.rb: Allow explicit trimming carriage return when trim_mode is
	  "-", for Windows environments. [Bug #5339]

	* lib/erb.rb: Allow trimming CR in all trim_modes to unify a behavior
	  with r58823 and r58825.

Fri Jun 30 20:16:15 2017  Takashi Kokubun  <takashikkbn@gmail.com>

	* lib/erb.rb: Allow trimming carriage return when trim_mode is "<>", for
	  Windows environments. [Bug #11464]

Fri Jun 30 20:07:37 2017  NARUSE, Yui  <naruse@ruby-lang.org>

	* util.c (ruby_strtod) Merge latest dtoa.c [Bug #13545]
	  Apply some part of http://www.netlib.org/fp/dtoa.c with my eyes...

Fri Jun 30 20:00:18 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dir.c (is_case_sensitive): use getattrlist() if fgetattrlist() is
	  unavailable, on OSX 10.5. [Bug #11054]

Fri Jun 30 19:58:16 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* tool/mkconfig.rb (RbConfig): prefix SDKROOT to oldincludedir
	  not includedir, the latter is outside the ruby installation.
	  [ruby-core:72496] [Bug #11881]

Fri Jun 30 19:56:06 2017  Eric Wong  <e@80x24.org>

	* variable.c (check_autoload_required): do not assume a provided feature
	  means autoload is complete, always wait if autoload is being performed
	  by another thread. [Bug #11384] Thanks to s.wanabe@gmail.com

Fri Jun 30 19:53:30 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* process.c (obj2uid, obj2gid): use temporary string as the buffer
	  instead of rb_alloc_tmp_buffer, which is NODE_ALLOCA since r51492.
	  [Bug #13554]

Fri Jun 30 19:50:25 2017  Eric Wong  <e@80x24.org>

	* variable.c (autoload_reset): use idempotent list_del_init

	* variable.c (autoload_sleep): moved code from rb_autoload_load

	* variable.c (autoload_sleep_done): cleanup for use with rb_ensure

	* variable.c (rb_autoload_load): ensure list delete happens in case the
	  thread dies during sleep

	* test/ruby/bug-13526.rb: new script for separate execution

	* test/ruby/test_autoload.rb (test_bug_13526): new test [Bug #13526]

Fri Jun 30 19:46:46 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* sprintf.c (rb_str_format): while "% 2f" and "% 4f" result in " Inf"
	  and " Inf" respectively, "% 3f" results in "Inf" (no space).

	* sprintf.c (rb_str_format): as for non-finite float, calculate the
	  exact needed size with the space flag.

Fri Jun 30 19:41:48 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread_win32.c (w32_wait_events): do not acquire GVL, to fix deadlock
	  at read/close race condition. instead, just ignore interrupt_event if
	  it is closed.

	* thread_win32.c (w32_wait_events): fix wait object index in the case of
	  interrupt_event is not usable.

Fri Jun 30 19:37:47 2017  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* io.c (nogvl_wait_for_single_fd): nogvl_wait_for_single_fd must wait
	  as its name.
	  poll(fds, n, 0) mean no timeout and immediately return. If you want to
	  wait something, you need to use -1 instead.

Fri Jun 30 19:35:31 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* class.c (Init_class_hierarchy): prevent rb_cObject which is the class
	  tree root, from GC. [Bug #12492]

Fri Jun 30 19:32:52 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* class.c (Init_class_hierarchy): prevent rb_cObject which is the
	  class tree root, from GC.  [ruby-dev:49666] [Bug #12492]

Fri Jun 30 19:29:45 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/ripper/lib/ripper/lexer.rb (on_heredoc_dedent): fix for nested
	  indedented here documents, where Elems are nested too. [Bug #13536]

	* ext/ripper/lib/ripper/lexer.rb (on_heredoc_dedent): insert stripped
	  leading spaces as on_ignored_sp elements, so that the original source
	  can be reconsructed. [Bug #13536]

Mon May  1 06:36:57 2017  NAKAMURA Usaku  <usa@ruby-lang.org>

	* parse.y (parser_parse_string): set the mark of term to `nd_func`
	  because in this version `u2.id` is not used for this purpose.
	  fixed failure of ruby/spec introduced at r58518.
	  see also [Backport #13363]

Sun Apr 30 23:01:00 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	class.c: ensure_includable

	* class.c (ensure_includable): extract checks to include and
	  prepend.

	class.c: prohibit refinement module

	* class.c (ensure_includable): cannot include refinement
	  module, or the type and the class do not match.
	  [ruby-core:79632] [Bug #13236]

Sun Apr 30 22:55:41 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	keep line number after unterminated string literal

	* parse.y (parser_parse_string): keep line number even after an
	  unterminated string literal.  it does not matter in the parser,
	  ripper needs this value after this error.

	parse.y: unterminated content token

	* parse.y (parser_parse_string): defer the end token to next
	  reading, to yield tSTRING_CONTENT with the unterminated content.
	  [Bug #13363]

Sun Apr 30 22:52:38 2017  Marcus Stollsteimer  <sto.mar@web.de>

	* io.c: [DOC] expand docs for IO#puts
	  [Bug #13306]

Sun Apr 30 22:38:44 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	sample/pty/shl.rb: update [ci skip]

	* sample/pty/shl.rb: stop writer loop when the child exited.
	  PTY::ChildExited no longer raises asynchronously since r20298.
	  [ruby-dev:49974] [Bug #13191]

	* sample/pty/shl.rb: use io/console instead of stty.
	  [ruby-dev:49974] [Bug #13191]

	* sample/pty/shl.rb: do not manage array length separately.
	  [ruby-dev:49974] [Bug #13191]

	* sample/pty/shl.rb: leap exited child process.
	  [ruby-dev:49974] [Bug #13191]

Sun Apr 30 22:35:10 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	configure.in: use AC_SEARCH_LIBS

	* configure.in (--with-gmp, --with-jemalloc): use AC_SEARCH_LIBS
	  to check if no library is required, instead of AC_CHECK_LIB.
	  [ruby-core:79368] [Bug #13175]

Sun Apr 30 22:24:25 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* numeric.c (flo_round): [EXPERIMENTAL] adjust the case that the
	  receiver is close to the exact but unrepresentable middle value
	  of two values in the given precision.
	  http://d.hatena.ne.jp/hnw/20160702

Sun Apr  9 22:21:23 2017  NAKAMURA Usaku  <usa@ruby-lang.org>

	thread.c: rb_thread_fd_close [ci skip]

	* thread.c (rb_thread_fd_close): re-define because of a couple of
	  external libraries used it.

Wed Mar 29 23:47:31 2017  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* hash.c (any_hash): fix CI failure on L32LLP64 architecture.
	  The patch was provided by usa. [ruby-core:80484] [Bug #13376]

Wed Mar 29 06:22:27 2017  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* hash.c (any_hash): fix Symbol#hash to be nondeterministic.
	  The patch was provided by Eric Wong. [ruby-core:80433] [Bug #13376]

	* test/ruby/test_symbol.rb: add test for above.

Tue Mar 28 00:38:39 2017  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (poll_child_status): rb_w32_wait_events_blocking() sets
	  errno internally, then should not set it here.

Mon Mar 27 20:15:17 2017  Kazuki Tsujimoto  <kazuki@callcc.net>

	* eval.c, method.h, proc.c, vm.c, vm_eval.c, vm_insnhelper.c, vm_method.c:
	  TracePoint#method_id should return method_id, not callee_id.
	  [ruby-core:77241] [Feature #12747]

	* test/ruby/test_settracefunc.rb: change accordingly.

Mon Mar 27 20:12:23 2017  Anton Davydov  <mail@davydovanton.com>

	* lib/uri/mailto.rb: Removed needless `return` and use `.`` instead of `::`
	  with class method.
	* test/uri/test_mailto.rb: Added tests for coverage.

Mon Mar 20 06:35:08 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby.c (process_options): convert -e script to the encoding
	  given by a command line option on Windows.  assume it is the
	  expected encoding.  [ruby-dev:49461] [Bug #11900]

Mon Mar 20 05:47:49 2017  Koichi Sasada  <ko1@atdot.net>

	* test/ruby/test_exception.rb: fix thread issues.
	  * use Queue instead of a local variable for synchronization.
	  * join created thread to soleve leaking threads warning.

Mon Mar 20 05:47:49 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (rb_threadptr_raise): set cause from the called thread,
	  but not from the thread to be interrupted.
	  [ruby-core:77222] [Bug #12741]

Wed Feb  8 02:17:02 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/forwardable.rb (Forwardable._delegator_method): extract
	  method generator and deal with non-module objects.
	  [ruby-dev:49656] [Bug #12478]

Wed Feb  8 02:17:02 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/forwardable.rb (def_instance_delegator): adjust backtrace of
	  method body by tail call optimization.  adjusting the delegated
	  target is still done by deleting backtrace.

	* lib/forwardable.rb (def_single_delegator): ditto.

Tue Jan 17 03:51:48 2017  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (setup_args): duplicate splatting array if more
	  arguments present to obey left-to-right execution order.
	  [ruby-core:77701] [Bug# 12860]

Thu Nov 24 05:47:18 2016  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* test/fileutils/test_fileutils.rb (TestFileUtils#setup): Use primary
	  group as well as supplementary groups.
	  based on the patch by Vit Ondruch at [Bug #12910]

Thu Nov 24 05:44:04 2016  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* test/ruby/test_dir_m17n.rb: Don't encode to UTF-8 if it's unnecessary.
	  If the file system encoding is ISO-8851-1 or if the encoding of the
	  target string is invalid, don't encode to UTF-8. [Bug#12972]

Mon Nov 21 16:55:15 2016  boshan  <boshan@subsplash.com>

	* lib/tempfile.rb (Tempfile#initialize): [DOC] the first parameter
	  `basename` is optional and defaulted to an empty string since
	  [GH-523].  [Fix GH-1225]

Sat Nov 19 14:06:07 2016  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* iseq.c (proc_dup): don't duplicate sym_procs.  [Fix GH-1479]
	  [ruby-core:78100] [Bug #12927]
	  Based on the patch provided by Emiliano Ritiro.

Sat Nov 19 11:48:47 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* iseq.c (iseqw_s_compile_file): deal with syntax error as well as
	  compile, and should not abort when rescued.

Wed Nov 16 23:40:29 2016  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* vm_eval.c (vm_call0_body): refined module should not be skipped as
	  prepended. [Bug #12920]

Tue Nov 15 03:14:02 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/-test/file/fs.c (get_atime_p): Updating of file access times
	  is enabled or not.

Tue Nov 15 03:14:02 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/ruby/test_file.rb (TestFile#test_stat): fix noatime case.
	  [ruby-core:77943] [Bug #12903]

Tue Nov 15 03:09:39 2016  Shugo Maeda  <shugo@ruby-lang.org>

	* test/rinda/test_rinda.rb (test_make_socket_ipv6_multicast,
	  test_make_socket_ipv6_multicast_hops): skip if IPv6 multicast 
	  address is not available.

Tue Nov 15 02:49:30 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_eval.c (vm_call0_body): follow the original class, not to
	  loop the prepended module.  [ruby-core:77784] [Bug #12876]

Tue Nov 15 02:45:44 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/net/http.rb (transport_request): other than HTTPContinue
	  in 1xx (HTTPInformation) also needs to continue. [Bug #12890]

Sat Nov 12 01:05:45 2016  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* object.c: Improve documentation for Float conversion.
	  [ruby-core:71661][Bug #11736][ci skip]

Sat Nov 12 00:50:35 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (mnew_internal): follow the original class, not to loop
	  the prepended module.  [ruby-core:77591] [Bug #12832]

Sat Nov 12 00:46:50 2016  Shugo Maeda  <shugo@ruby-lang.org>

	* cont.c (cont_new): disable optimization if clang's version is
	  3.8.0.  [ruby-core:77894] [Bug #12893]

Sat Nov 12 00:27:24 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_peephole_optimize): enable tail call
	  optimization inside a conditional block.

Sat Nov  5 11:53:17 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (copy_stream_body): use IO to write to copy to duplex IO.
	  http://twitter.com/knu/status/786505317974585344

Sat Nov  5 11:49:41 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* sprintf.c (rb_str_format): format exact number more exactly.

Sat Nov  5 11:45:32 2016  Kazuki Yamaguchi  <k@rhe.jp>

	* ext/openssl/ossl.c (Init_openssl): register an ex_data index for
	  X509_STORE and X509_STORE_CTX respectively. Since they don't share
	  the ex_data index registry, we can't use the same index.
	  (ossl_verify_cb): use the the correct index.

	* ext/openssl/ossl_ssl.c (ossl_ssl_verify_callback): ditto.

	* ext/openssl/ossl_x509store.c (ossl_x509store_set_vfy_cb): ditto.
	  (ossl_x509stctx_verify): ditto.

	* ext/openssl/ossl.h (void ossl_clear_error): add extern declarations
	  of ossl_store_{ctx_,}ex_verify_cb_idx.

	* ext/openssl/openssl_missing.c: remove X509_STORE_set_ex_data and
	  X509_STORE_get_ex_data.

	* ext/openssl/openssl_missing.h: implement X509_STORE_get_ex_data,
	  X509_STORE_set_ex_data and X509_STORE_get_ex_new_index as macros.

Sat Nov  5 11:35:58 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (rb_thread_pending_interrupt_p): no pending interrupt
	  before initialization.

	* thread.c (thread_raise_m, rb_thread_kill): uninitialized thread
	  cannot interrupt.  [ruby-core:72732] [Bug #11959]

Sat Nov  5 11:16:58 2016  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c: Import changes from ruby/bigdecimal
	  repository.

Tue Oct 18 02:58:22 2016  Kazuki Yamaguchi  <k@rhe.jp>

	* eval_intern.h (TH_PUSH_TAG): Initialize struct rb_vm_tag::tag with
	  Qundef rather than 0 which is equal to Qfalse. Since Kernel#throw(obj)
	  searches a tag with rb_vm_tag::tag == obj, throw(false) can
	  accidentally find an unrelated tag which is not created by
	  Kernel#catch.  [ruby-core:77229] [Bug #12743]

	* test/ruby/test_exception.rb (test_throw_false): Add a test case for
	  this.

Tue Oct 18 02:24:29 2016  Aurelien Jacobs  <aurel@gnuage.org>

	* lib/logger.rb (Logger::Period#next_rotate_time): fix monthly log
	  rotate when DST is applied during a month of 31 days.
	  [Fix GH-1458]

Wed Oct 12 22:31:09 2016  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* tool/downloader.rb: Removed verification of gem certification.
	  Because signed gem is not working on rubygems ecosystem.
	* tool/gem-unpack.rb: ditto.

Fri Oct  7 02:48:06 2016  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* lib/rubygems/ssl_certs/GlobalSignRootCA.pem: add for RugyGems.org.

Mon Sep 26 23:51:31 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* variable.c (rb_const_search): raise with the actual class/module
	  name which defines the private constant.

Mon Sep 26 23:34:09 2016  Kazuki Yamaguchi  <k@rhe.jp>

	* ext/openssl/ossl_pkcs12.c (ossl_pkcs12_initialize): pop errors
	  leaked by PKCS12_parse(). This is a bug in OpenSSL, which exists
	  in the versions before the version 1.0.0t, 1.0.1p, 1.0.2d.

Mon Sep 26 23:10:43 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* vm_dump.c (backtrace): use rip in the saved context for the case
	  the SIGSEGV is received when the process is in userland.
	  Note that ip in the stack should be used if the signal is received
	  when it is in kernel (when it is calling syscall) [Bug #12711]

Mon Sep 26 20:23:32 2016  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* gems/bundled_gems: update minitest to 5.8.5.

	* tool/downloader.rb: revert workarounds.

	* tool/gem-unpack.rb: ditto.

Mon Sep 26 07:26:44 2016  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* tool/gem-unpack.rb: don't set security policy.
	  workaround for certificate expiration of minitest-5.8.3.gem.

Mon Sep 26 06:33:16 2016  Aaron Patterson <tenderlove@ruby-lang.org>

	* lib/uri/generic.rb (def check_password): don't include bad password
	  in URI exception output

	* test/uri/test_generic.rb (def test_set_component): test for behavior

Mon Sep 26 06:20:58 2016  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* tool/downloader.rb: comment out gem package verification.
	  workaround for certificate expiration of minitest-5.8.3.gem.

Sun Sep 25 16:37:22 2016  NAKAMURA Usaku  <usa@ruby-lang.org>

	* io.c (nogvl_fsync, nogvl_fdatasync): on Windows, just ignore if the
	  fd is associated to non-disk device.  if call fsync and/or fdatasync
	  with such fds, it causes Errno::EBADF exception and the behavior is
	  incompatible with ruby 2.1 and earlier unintentionally introduced.

Sun Sep 25 15:09:04 2016  Kazuki Tsujimoto  <kazuki@callcc.net>

	* array.c (flatten): use rb_obj_class instead of rb_class_of
	  because rb_class_of may return a singleton class.
	  [ruby-dev:49781] [Bug #12738]

Sun Sep 25 15:07:19 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* man/irb.1: remove useless -width option.
	  [ruby-dev:49767] [Bug #12692]

Tue Aug 30 05:24:33 2016  Kazuki Yamaguchi  <k@rhe.jp>

	* ext/openssl/ossl_x509ext.c: additional fix memory leak.
	  [ruby-core:76922] [Bug #12680]

	* text/openssl/test_x509ext.rb: test for above.

Sun Aug 28 00:26:58 2016  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* vm_method.c: revert r55869. it breaks Integer#days with
	  ActiveSupport-4.1.x. [ruby-core:76949] [Bug #12353]

	* test/ruby/test_marshal.rb: ditto.

Sat Aug 27 03:51:23 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* id_table.c (hash_table_extend): should not shrink the table than
	  the previous capacity.  [ruby-core:76534] [Bug #12614]

Sat Aug 27 03:37:49 2016  Kazuki Yamaguchi  <k@rhe.jp>

	* ext/openssl/ossl_config.c: fix memory leak.
	  [ruby-core:76922] [Bug #12680]

	* ext/openssl/ossl_ocsp.c: ditto.

	* ext/openssl/ossl_pkcs12.c: ditto.

	* ext/openssl/ossl_pkcs7.c: ditto.

	* ext/openssl/ossl_pkey_ec.c: ditto.

	* ext/openssl/ossl_x509.h: ditto.

	* ext/openssl/ossl_x509attr.c: ditto.

	* ext/openssl/ossl_x509crl.c: ditto.

	* ext/openssl/ossl_x509ext.c: ditto.

	* ext/openssl/ossl_x509req.c: ditto.

	* ext/openssl/ossl_x509revoked.c: ditto.

Thu Aug 25 00:19:24 2016  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/rubygems/specification.rb: `coding` is affect only first line except
	  shebang.
	* lib/rubygems/package.rb, lib/rubygems/package/*: ditto.

Thu Aug 25 00:19:24 2016  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/rubygems.rb, lib/rubygems/*, test/rubygems/*: Update rubygems-2.5.2.
	  It supports to enable frozen string literal and add `--norc` option for
	  disable to `.gemrc` configuration.
	  See 2.5.2 release notes for other fixes and enhancements.
	  https://github.com/rubygems/rubygems/blob/a8aa3bac723f045c52471c7b9328310a048561e0/History.txt#L3

Wed Aug 24 23:54:40 2016  Charles Oliver Nutter  <headius@headius.com>

	* test/ruby/test_array.rb: split out the test for no stack error
	  on large input for test_permutation, test_repeated_permutation,
	  and test_repeated_combination, and make them all timeout:30.

Tue Aug 23 03:22:34 2016  Naohisa Goto  <ngotogenome@gmail.com>

	* test/fiddle/test_pointer.rb (test_to_str, test_to_s, test_aref_aset):
	  Attempt to use independent strings for destructive tests that
	  directly modify values on memory by using Fiddle::Pointer.
	  [Bug #12537] [ruby-dev:49700]

Tue Aug 23 03:14:22 2016  Naohisa Goto  <ngotogenome@gmail.com>

	* string.c (str_buf_cat): Fix capa size for embed string.
	  Fix bug in r55547. [Bug #12536]

Tue Aug 23 03:14:22 2016  Naohisa Goto  <ngotogenome@gmail.com>

	* string.c (rb_str_change_terminator_length): New function to change
	  termlen and resize heap for the terminator. This is split from
	  rb_str_fill_terminator (str_fill_term) because filling terminator
	  and changing terminator length are different things. [Bug #12536]

	* internal.h: declaration for rb_str_change_terminator_length.

	* string.c (str_fill_term): Simplify only to zero-fill the terminator.
	  For non-shared strings, it assumes that (capa + termlen) bytes of
	  heap is allocated. This partially reverts r55557.

	* encoding.c (rb_enc_associate_index): rb_str_change_terminator_length
	  is used, and it should be called whenever the termlen is changed.

	* string.c (str_capacity): New static function to return capacity
	  of a string with the given termlen, because the termlen may
	  sometimes be different from TERM_LEN(str) especially during
	  changing termlen or filling terminator with specific termlen.

	* string.c (rb_str_capacity): Use str_capacity.

Tue Aug 23 03:14:22 2016  Naohisa Goto  <ngotogenome@gmail.com>

	* string.c: Partially reverts r55547 and r55555.
	  ChangeLog about the reverted changes are also deleted in this file.
	  [Bug #12536] [ruby-dev:49699] [ruby-dev:49702]

Tue Aug 23 03:14:22 2016  Naohisa Goto  <ngotogenome@gmail.com>

	* string.c (str_fill_term): When termlen increases, re-allocation
	  of memory for termlen should always be needed.
	  In this fix, if possible, decrease capa instead of realloc.
	  [Bug #12536] [ruby-dev:49699]

Tue Aug 23 03:14:22 2016  Naohisa Goto  <ngotogenome@gmail.com>

	* string.c: Specify termlen as far as possible.
	  Additional fix for [Bug #12536] [ruby-dev:49699].

	* string.c (str_new_static): Specify termlen from the given encoding
	  when creating a new String object is needed.

	* string.c (rb_tainted_str_new_with_enc): New function to create a
	  tainted String object with the given encoding. This means that
	  the termlen is correctly specified. Currently static function.
	  The function name might be renamed to rb_tainted_enc_str_new
	  or rb_enc_tainted_str_new.

	* string.c (rb_external_str_new_with_enc): Use encoding by using the
	  above rb_tainted_str_new_with_enc().

Tue Aug 23 03:14:22 2016  Naohisa Goto  <ngotogenome@gmail.com>

	* string.c (rb_str_subseq, str_substr): When RSTRING_EMBED_LEN_MAX
	  is used, TERM_LEN(str) should be considered with it because
	  embedded strings are also processed by TERM_FILL.
	  Additional fix for [Bug #12536] [ruby-dev:49699].

Tue Aug 23 03:14:22 2016  Naohisa Goto  <ngotogenome@gmail.com>

	* string.c: Fix memory corruptions when using UTF-16/32 strings.
	  [Bug #12536] [ruby-dev:49699]

	* string.c (rb_str_new_with_class): Use TERM_LEN of the "obj".

	* string.c (rb_str_plus, rb_str_justify): Use str_new0 which is aware
	  of termlen.

	* string.c (str_shared_replace): Copy +termlen bytes instead of +1.

	* string.c (rb_str_times): termlen should not be included in capa.

	* string.c (RESIZE_CAPA_TERM): When using RSTRING_EMBED_LEN_MAX,
	  termlen should be counted with it because embedded strings are
	  also processed by TERM_FILL.

	* string.c (rb_str_capacity, str_shared_replace, str_buf_cat): ditto.

	* string.c (rb_str_drop_bytes, rb_str_setbyte, str_byte_substr): ditto.

Thu Aug 18 23:43:33 2016  Eric Wong  <e@80x24.org>

	* ext/openssl/ossl_ssl.c (ossl_ssl_write_internal):
	  avoid undefined behavior
	* test/openssl/test_pair.rb (test_write_zero): new test
	  [ruby-core:76751] [Bug #12660]

Thu Aug 18 23:18:17 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/socket/option.c, ext/socket/rubysocket.h (inet_ntop): share
	  the fallback definition.  [ruby-core:76646] [Bug #12645]

Thu Aug 18 23:07:29 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm.c (vm_set_main_stack): remove unnecessary check.  toplevel
	  binding must be initialized.  [Bug #12611] (N1)

	* win32/win32.c (w32_symlink): fix return type.  [Bug #12611] (N3)

	* string.c (rb_str_split_m): simplify the condition.
	  [Bug #12611](N4)

Thu Aug 18 23:06:20 2016  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rexml/attribute.rb (REXML::Attribute#to_string): Fix wrong
	  entry reference name of double quote.
	  [Bug #12609][ruby-core:76509]
	  Patch by Joseph Marrero. Thanks!!!

Thu Aug 18 23:04:59 2016  Naohisa Goto  <ngotogenome@gmail.com>

	* thread.c (rb_wait_for_single_fd): Clean up fds.revents every time
	  before calling ppoll(2). [Bug #12575] [ruby-dev:49725]

Thu Aug 18 22:52:19 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* vm_args.c (setup_parameters_complex): don't raise ArgumentError
	  if an array is given for instance_exec with optional argument.
	  [ruby-core:76300] [Bug #12568]
	  https://github.com/rails/rails/pull/25699

Tue Aug 16 12:27:48 2016  Koichi Sasada  <ko1@atdot.net>

	* gc.c (gc_mark_roots): should mark the VM object itself to mark
	  singleton class of the VM object.
	  Before this patch, we only set mark bit for the VM object and
	  invoke mark function separately.
	  [Bug #12583]

	* test/ruby/test_gc.rb: add a test.

Tue Aug 16 12:01:35 2016  Naohisa Goto  <ngotogenome@gmail.com>

	* ext/digest/md5/md5ossl.h: Remove excess semicolons.
	  Suppress warning on Solaris with Oracle Solaris Studio 12.
	  [ruby-dev:49692] [Bug #12524]

	* ext/digest/md5/md5cc.h: ditto.
	* ext/digest/sha1/sha1cc.h: ditto.
	* ext/digest/sha1/sha1ossl.h: ditto.
	* ext/digest/sha2/sha2cc.h: ditto.
	* ext/digest/sha2/sha2ossl.h: ditto.

Tue Aug 16 11:51:52 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (ADD_TRACE): ignore trace instruction on non-positive
	  line.

	* parse.y (coverage): get rid of ArgumentError when the starting
	  line number is not positive.  [ruby-core:76141] [Bug #12517]

Tue Aug 16 11:51:52 2016  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* test/coverage/test_coverage.rb: ignored test when enabled to coverage.
	  It lead to crash with `make test-all`.

Tue Aug 16 11:46:07 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/uri/mailto.rb (initialize): RFC3986_Parser#split sets opaque
	  only if the URI has path-rootless, not path-empty.
	  [ruby-core:76055] [Bug #12498]
	  patched by Chris Heisterkamp <cheister@squareup.com>

Tue Aug 16 04:57:28 2016  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/http/generic_request.rb (write_header): A Request-Line must
	  not contain CR or LF.

Tue Aug 16 04:54:12 2016  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/ftp.rb (putline): raise an ArgumentError when
	  CR or LF is included in a line.

Tue Aug 16 04:38:48 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/date/date_strftime.c (date_strftime_with_tmx): reject too
	  large precision to get rid of buffer overflow.
	  reported by Guido Vranken <guido AT guidovranken.nl>.

Tue Aug 16 04:28:22 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (append_fspath): normalize directory name to be appended
	  on OS X.  [ruby-core:75957] [Ruby trunk Bug#12483]
	  https://github.com/rails/rails/issues/25303#issuecomment-224834804

Tue Aug 16 04:16:14 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* regcomp.c (noname_disable_map): don't optimize out group 0
	  Ruby's Regexp doesn't allow normal numbered groups if the regexp
	  has named groups. On such case it optimizes out related NT_ENCLOSE.
	  But even on the case it can use \g<0>.
	  This fix not to remove NT_ENCLOSE whose regnum is 0.
	  [ruby-core:75828] [Bug #12454]

Tue Aug 16 04:06:52 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* missing/crypt.c: fix size macros to use configured values
	  for platforms long is larger than 32bit.
	  [ruby-core:75792] [Bug #12446]

Tue Aug 16 04:03:25 2016  Kazuki Yamaguchi  <k@rhe.jp>

	* ext/openssl/ossl_bn.c (try_convert_to_bnptr): Extracted from
	  GetBNPtr(). This doesn't raise exception but returns NULL on error.
	  (GetBNPtr): Raise TypeError if conversion fails.
	  (ossl_bn_eq): Implement BN#==.
	  (ossl_bn_eql): #eql? should not raise TypeError even if the argument
	  is not compatible with BN.
	  (ossl_bn_hash): Implement BN#hash.

	* ext/openssl/ossl_bn.c (Init_ossl_bn): Define #== and #hash.

	* test/openssl/test_bn.rb: Test BN#eql?, #== and #hash

Tue Aug 16 03:51:59 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* transcode.c (str_transcode0): scrub in the given encoding when
	  the source encoding is given, not in the encoding of the
	  receiver.  [ruby-core:75732] [Bug #12431]

Tue Aug 16 03:41:21 2016  Kazuki Yamaguchi  <k@rhe.jp>

	* ext/openssl/ossl_pkey_dh.c (ossl_dh_compute_key): Check that the DH
	  has 'p' (the prime) before calling DH_size(). We can create a DH with
	  no parameter but DH_size() does not check and dereferences NULL.
	  [ruby-core:75720] [Bug #12428]

	* ext/openssl/ossl_pkey_dsa.c (ossl_dsa_sign): Ditto. DSA_size() does
	  not check dsa->q.

	* ext/openssl/ossl_pkey_rsa.c (ossl_rsa_public_encrypt,
	  ossl_rsa_public_decrypt, ossl_rsa_private_encrypt,
	  ossl_rsa_private_decrypt): Ditto. RSA_size() does not check rsa->n.

Tue Aug 16 03:10:42 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* transcode.c (enc_arg, str_transcode_enc_args, econv_args):
	  remove volatile, and add GC guards in callers.
	  [ruby-core:75664] [Bug #12411]

Tue Aug 16 02:45:52 2016  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* ext/psych/*, test/psych/*: Update psych 2.1.0
	  This version fixed [Bug #11988][ruby-core:72850]

Fri Aug 12 04:15:10 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (build-ext), ext/extmk.rb: use variable EXTENCS
	  different than ENCOBJS, to get rid of circular dependency.
	  build libencs when linking encodings statically.
	  [ruby-core:75618] [Bug #12401]

Fri Aug 12 04:04:23 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* process.c (rb_execarg_commandline): build command line string
	  from argument vector in rb_execarg.
	  [ruby-core:75611] [Bug #12398]

Fri Aug 12 03:30:59 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* variable.c (rb_local_constants_i): exclude private constants
	  when excluding inherited constants too.  [Bug #12345]

Fri Aug 12 03:00:05 2016  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/drb/timeridconv.rb: don't use keeper thread. [Bug #12342]

	* test/drb/ut_timerholder.rb: ditto.

Fri Aug 12 02:46:37 2016  Kazuki Yamaguchi  <k@rhe.jp>

	* ext/openssl/ossl_ssl.c (ossl_ssl_stop): Don't free the SSL struct
	  here. Since some methods such as SSLSocket#connect releases GVL,
	  there is a chance of use after free if we free the SSL from another
	  thread. SSLSocket#stop was documented as "prepares it for another
	  connection" so this is a slightly incompatible change. However when
	  this sentence was added (r30090, Add toplevel documentation for
	  OpenSSL, 2010-12-06), it didn't actually. The current behavior is
	  from r40304 (Correct shutdown behavior w.r.t GC., 2013-04-15).
	  [ruby-core:74978] [Bug #12292]

	* ext/openssl/lib/openssl/ssl.rb (sysclose): Update doc.

	* test/openssl/test_ssl.rb: Test this.

Thu Aug 11 01:30:29 2016  Marcus Stollsteimer  <sto.mar@web.de>

	* ext/json/lib/*.rb: Removed some comments. Because these are unnecessary
	  class description. [ci skip][Bug #12255][ruby-core:74835]

Thu Aug 11 01:09:43 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* pack.c (pack_pack): use union instead of bare variable to ease
	  optimizations and avoid assigning x87 floating point number.
	  [ruby-core:74496] [Bug #12209]

	* pack.c (pack_unpack): ditto.

Tue Aug  2 01:34:12 2016  Eric Wong  <e@80x24.org>

	* lib/webrick/httpservlet/cgihandler.rb (do_GET): delete HTTP_PROXY
	* test/webrick/test_cgi.rb (test_cgi_env): new test
	* test/webrick/webrick.cgi (do_GET): new endpoint to dump env
	  [ruby-core:76511] [Bug #12610]

Tue Aug  2 01:33:11 2016  Shugo Maeda  <shugo@ruby-lang.org>

	* test/ruby/test_refinement.rb: skip
	  test_prepend_after_refine_wb_miss on ARM or MIPS.
	  [ruby-core:76031] [Bug #12491]

Sat Jul 30 12:23:29 2016  Shugo Maeda  <shugo@ruby-lang.org>

	* vm_args.c (vm_caller_setup_arg_block): disable symbol block
	  argument optimization when tail call optimization is enabled,
	  in order to avoid SEGV.  [ruby-core:76288] [Bug #12565]

Sat Jul 30 12:10:51 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (passed_block): convert passed block symbol to proc.
	  based on the patch by Daisuke Sato in [ruby-dev:49695].
	  [Bug #12531]

Sat Jul 30 10:58:49 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (vm_throw_start): check if the iseq is symbol
	  proc, class definition should not be a symbol proc.
	  [ruby-core:75856] [Bug #12462]

Mon Jul 11 22:35:00 2016  Kenta Murata  <mrkn@mrkn.jp>

	* bignum.c (rb_big_hash): make it public function to be available in
	  other source files, and remove documentation comment for Bignum#hash.

	* bignum.c (Bignum#hash): remove its definition because it is unified
	  with Object#hash.

	* include/ruby/intern.h (rb_big_hash): add a prototype declaration.

	* hash.c (any_hash): treat Bignum values directly.

Sat Jul  2 04:00:50 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (tr_trans): consider terminator length and fix heap
	  overflow.  reported by Guido Vranken <guido AT guidovranken.nl>.

Sat Jul  2 03:33:28 2016  Shugo Maeda  <shugo@ruby-lang.org>

	* vm.c (invoke_bmethod, invoke_block_from_c_0): revert r52104
	  partially to avoid "self has wrong type to call super in this
	  context" errors.
	  [ruby-core:72724] [Bug #11954]

Mon Jun 20 02:38:29 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/optparse.rb (OptionParser::Completion.candidate): get rid of
	  nil as key names.  [ruby-core:75773] [Bug #12438]

	* lib/optparse.rb (OptionParser#make_switch): char class option
	  cannot be NoArgument, default to RequiredArgument.

Mon Jun 20 02:25:44 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* re.c (unescape_nonascii): scan hex up to only 3 characters.
	  [Bug #12420] [Bug #12423]

Mon Jun 20 02:25:44 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* regparse.c (fetch_token_in_cc): raise error if given octal escaped
	  character is too big. [Bug #12420] [Bug #12423]

Sun Jun 19 04:29:13 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/missing.h (isfinite): move from numeric.c.

Sun Jun 19 04:29:13 2016  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/bigdecimal/bigdecimal.c (isfinite): get rid of a warning on
	  cygwin. [Bug #12417][ruby-core:75691]

Sun Jun 19 04:29:13 2016  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/bigdecimal/bigdecimal.c (isfinite): isfinite does not always
	  exist.  fixed build error on Windows introduced at r55123.

Sun Jun 19 04:29:13 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/bigdecimal/bigdecimal.c (GetVpValueWithPrec): consider
	  non-finite float values not to raise FloatDomainError.
	  [ruby-core:75682] [Bug #12414]

Thu Jun 16 00:42:56 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_modify_expand): check integer overflow.
	  [ruby-core:75592] [Bug #12390]

Thu Jun 16 00:29:29 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (vm_get_ev_const): warn deprecated constant even
	  in the class context.  [ruby-core:75505] [Bug #12382]

Tue Jun 14 03:49:28 2016  Eric Wong  <e@80x24.org>

	* dir.c (dir_close): update RDoc for 2.3 #close change
	  [ruby-core:75679] [Bug #12413]

Tue Jun 14 03:47:29 2016  Eric Wong  <e@80x24.org>

	* proc.c: fix RDoc of Proc#===/call/yield/[]
	  [Bug #12332]

Tue Jun 14 03:34:27 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* variable.c (rb_local_constants_i): exclude hidden constants.
	  [ruby-core:75575] [Bug #12389]

Tue Jun 14 03:25:14 2016  Benoit Daloze  <eregontp@gmail.com>

	* insns.def (defineclass): Also raise an error when redeclaring the
	  superclass of a class as Object and it has another superclass.
	  [Bug #12367] [ruby-core:75446]

	* test/ruby/test_class.rb: test for above.

Tue Jun 14 03:15:54 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* process.c (rb_exec_getargs): honor the expected argument types
	  over the conversion method.  the basic language functionality
	  should be robust.  [ruby-core:75388] [Bug #12355]

Tue Jun 14 03:02:38 2016  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c, include/ruby/win32.h (rb_w32_utruncate): implements new
	  truncate alternative which accepts UTF-8 path.

	* file.c (truncate): use above function.
	  [Bug #12340]

Tue Jun 14 02:58:41 2016  Marcus Stollsteimer  <sto.mar@web.de>

	* ext/date/date_core.c (Init_date_core): [DOC] Convert DateTime
	  documentation to RDoc from Markdown.
	  [ruby-core:75136] [Bug #12311]

Sun Jun 12 02:36:52 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* regcomp.c (compile_length_tree): return error code immediately
	  if compile_length_tree raised error [Bug #12418]

Sun Jun 12 02:27:07 2016  NAKAMURA Usaku  <usa@ruby-lang.org>

	* thread.c (recursive_list_access): a object id may be a Bignum.  so,
	  the list must be a objhash, instead of a identhash.
	  this fixes many test errors on mswin64 CI.

Sun Jun 12 01:59:33 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (new_if_gen): set newline flag to NODE_IF to trace all
	  if/elsif statements.  [ruby-core:67720] [Bug #10763]

Sun May 15 02:33:52 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (pkg_config): use xsystem consistently to set up
	  library path environment variable as well as latter pkg-config
	  calls.  [ruby-dev:49619] [Bug #12379]

Fri May  6 02:30:32 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/optparse.rb: [DOC] fix example code.  base on the code by
	  Semyon Gaivoronskiy in [ruby-core:75224].  [Bug #12323]

Fri May  6 02:28:31 2016  Masaki Suketa <masaki.suketa@nifty.ne.jp>

	* ext/win32ole/win32ole.c (ole_vstr2wc, ole_variant2val): fix blank
	  string conversion.
	  [Bug #11880]
	  Thanks Akio Tajima for the patch!

Fri May  6 02:24:13 2016  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* bignum.c: [DOC] Update result of 123456789 ** -2.
	  [ruby-dev:49606] [Bug #12339]

Wed May  4 02:38:08 2016  Yuichiro Kaneko  <yui-knk@ruby-lang.org>

	* internal.h (RCOMPLEX_SET_IMAG): undef RCOMPLEX_SET_IMAG
	  instead of duplicated undef RCOMPLEX_SET_REAL.

Wed May  4 02:38:08 2016  Yuichiro Kaneko  <yui-knk@ruby-lang.org>

	* complex.c (rb_complex_set_imag): Fix to properly set imag
	  of complex.

Tue Apr 26 23:34:45 2016  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* version.h: Bump versionto 2.3.2.

Tue Apr 26 02:58:51 2016  Marcus Stollsteimer  <sto.mar@web.de>

	* doc/extension.rdoc: Improvements to english grammers.
	  [Bug #12246][ruby-core:74792][ci skip]

Tue Apr 26 02:58:51 2016  craft4coder  <yooobuntu@163.com>

	* doc/extension.rdoc: [DOC] `nul` should be uppercase.
	  change 'nul' => 'NUL'.  [Fix GH-1172]

Tue Apr 26 02:54:57 2016  Marcus Stollsteimer  <sto.mar@web.de>

	* encoding.c: Fix return value of `Encoding::ISO8859_1.name`
	  [Bug #12313][ruby-core:75147][ci skip]
	* ext/bigdecimal/bigdecimal.c: Fix code sample of `BigDecimal.new`

Mon Apr 25 02:29:07 2016  Rei Odaira  <Rei.Odaira@gmail.com>

	* configure.in: add missing -lm for AIX.

Mon Apr 25 02:29:07 2016  Rei Odaira  <Rei.Odaira@gmail.com>

	* configure.in: don't use the system-provided round(3) on AIX.
	  In AIX, round(0.49999999999999994) returns 1.0.
	  Use round() in numeric.c instead.

Sun Apr 24 03:05:47 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby.c: cygwin does not use w32_cmdvector, command line can be
	  other than UTF-8.  [ruby-dev:49519] [Bug #12184]

Sat Apr 23 01:01:13 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval_jump.c (exec_end_procs_chain): restore previous error info
	  for each end procs.  [ruby-core:75038] [Bug #12302]

Sat Apr 23 00:51:51 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (new_label_body): initialize bit fields, since
	  compile_data_alloc does not clear the memory.  [Bug #12082]

Sat Apr 23 00:51:51 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_optimize): disable tail call optimization in
	  rescued, rescue, and ensure blocks.
	  [ruby-core:73871] [Bug #12082]

Sat Apr 23 00:33:04 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/nkf/nkf-utf8/nkf.c (mime_putc): fix typo.
	  [Bug #12202] [ruby-core:74802]

Sat Apr 23 00:33:04 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/nkf/nkf-utf8/nkf.c: Merge upstream 4f3edf80a0.
	  patched by Anton Sivakov [Bug #12201] [Bug #12202]

Sat Apr 23 00:29:15 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/securerandom.rb (gen_random): to avoid blocking on Windows.
	  On Windows OpenSSL RAND_bytes (underlying implementation is
	  RAND_poll in crypto/rand/rand_win.c) may be blocked at
	  NetStatisticsGet.
	  https://wiki.openssl.org/index.php/Random_Numbers#Windows_Issues
	  Instead of this, use Random.raw_seed directly (whose implementation
	  CryptGenRandom is one of the source of
	  entropy of RAND_poll on Windows).
	  https://wiki.openssl.org/index.php/Random_Numbers
	  Note: CryptGenRandom function is PRNG and doesn't check its entropy,
	  so it won't block. [Bug #12139]
	  https://msdn.microsoft.com/ja-jp/library/windows/desktop/aa379942.aspx
	  https://tools.ietf.org/html/rfc4086#section-7.1.3
	  https://eprint.iacr.org/2007/419.pdf
	  http://www.cs.huji.ac.il/~dolev/pubs/thesis/msc-thesis-leo.pdf

Sat Apr 23 00:25:26 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* miniinit.c (Init_enc): add some common aliases of built-in
	  encodings.  [ruby-core:72481] [Bug #11872]

Sat Apr 23 00:13:50 2016  sorah (Shota Fukumori)  <her@sorah.jp>

	* lib/forwardable.rb: Convert given accessors to String.

	  r53381 changed to accept only Symbol or String for accessors, but
	  there are several rubygems that pass classes (e.g. Array,
	  Hash, ...) as accessors. Prior r53381, it was accepted because Class#to_s
	  returns its class name. After r53381 given accessors are checked
	  with define_method, but it accepts only Symbol or String, otherwise
	  raises TypeError.

	      def_delegator Foo, :some_method

	  This change is to revert unexpected incompatibility. But this behavior
	  may change in the future.

Sat Apr 23 00:02:09 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in: check if succeeded in creating config.h.

	* tool/ifchange: ignore failures when TEST_COLORS unmatched. just
	  use the default value if expected name is not contained in it.
	  [ruby-core:75046] [Bug #12303]

Fri Apr 22 23:47:05 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* doc/regexp.rdoc (comments): [DOC] terminators cannot appear in
	  comments.  [ruby-core:74838] [Bug #12256]

Fri Apr 22 23:44:07 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* extension.rdoc, extension.ja.rdoc: [DOC] Fix some errors.
	  Renamed files, wrong method names or argument types; the example
	  GetDBM macro is now updated to the current version of the actual
	  code.  patch by Marcus Stollsteimer in [ruby-core:74690].
	  [Bug #12228]

Fri Apr 22 23:32:19 2016  Tanaka Akira  <akr@fsij.org>

	* test/ruby/test_time_tz.rb: Tests depends on Europe/Moscow removed
	  to avoid test failures due to the tzdata change.
	  https://github.com/eggert/tz/commit/8ee11a301cf173afb0c76e0315b9f9ec8ebb9d95
	  Found by naruse.

Tue Apr 19 02:32:50 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (rb_cv_lgamma_r_m0): fix the condition for
	  lgamma_r(-0.0).  [Bug #12249]

Tue Apr 19 02:32:50 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (rb_cv_lgamma_r_m0): check if lgamma_r(-0.0)
	  returns negative infinity.  [Bug #12249]

	* math.c (ruby_lgamma_r): define by the configured result.

Tue Apr 19 02:32:50 2016  cremno phobia  <cremno@mail.ru>

	* math.c (ruby_lgamma_r): missing/lgamma_r.c is used on Windows,
	  since msvcrt does not provide it.

	* missing/lgamma_r.c (lgamma_r): fix lgamma(-0.0).
	  [ruby-core:74823] [Bug #12249]

Tue Apr 19 02:32:50 2016  NAKAMURA Usaku  <usa@ruby-lang.org>

	* math.c (ruby_lgamma_r): mswin's lgamma_r also seems to be wrong.
	  cf. [Bug #12249]

Tue Apr 19 02:32:50 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* math.c (ruby_tgamma): fix tgamma(-0.0) on mingw.
	  [ruby-core:74817] [Bug #12249]

Tue Apr 19 01:53:32 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* defs/keywords (alias, undef): symbol literals are allowed.

	* parse.y (parse_percent): should parse symbol literals for alias
	  and undef.  [ruby-dev:47681] [Bug #8851]

Mon Apr 18 18:05:29 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* struct.c (struct_make_members_list, rb_struct_s_def): member
	  names should be unique. [ruby-core:74971] [Bug #12291]

	* struct.c (struct_make_members_list): extract making member name
	  list from char* va_list, with creating symbols without
	  intermediate IDs.

Mon Apr 18 17:54:40 2016  Joe Swatosh  <joe.swatosh@gmail.com>

	* ext/win32/lib/win32/registry.rb (DeleteValue, DeleteKey): fix
	  API names.  [ruby-core:74863] [Bug #12264]

Mon Apr 18 17:27:30 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_peephole_optimize): should not replace the
	  current target INSN, not to follow the replaced dangling link in
	  the caller.  [ruby-core:74993] [Bug #11816]

Mon Apr 18 17:18:25 2016  cremno phobia  <cremno@mail.ru>

	* cont.c (fiber_initialize_machine_stack_context): fix wrong
	  _MSC_VER check, should be decimal but not hexadecimal.
	  [ruby-core:74936] [Bug #12279]

Mon Apr 18 17:18:25 2016  cremno phobia  <cremno@mail.ru>

	* cont.c (fiber_initialize_machine_stack_context): fix wrong
	  _MSC_VER check, should be decimal but not hexadecimal.
	  [ruby-core:74936] [Bug #12279]

Mon Apr 18 17:08:10 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_core.h (rb_vm_struct): make at_exit a single linked list but
	  not RArray, not to mark the registered functions by the write
	  barrier.  based on the patches by Evan Phoenix.
	  [ruby-core:73908] [Bug #12095]

Mon Apr 18 16:56:31 2016  Benoit Daloze  <eregontp@gmail.com>

	* thread.c (update_coverage): Do not track coverage in loaded files
	  after Coverage.result. Avoids out-of-bounds access. [Bug #12237]

	* ext/coverage/coverage.c (coverage_clear_result_i): document.

Mon Apr 18 16:33:50 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/date/date_core.c (Init_date_core): [DOC] fix misplaced doc
	  of DateTime.  [ruby-core:74729] [Bug #12233]

Mon Apr 18 13:48:05 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* cygwin/GNUmakefile.in (MSYS2_ARG_CONV_EXCL_PARAM):
	  * add missing parentheses and remove double quotes.
	  * rename to get rid of recursive references.
	  * as --excludes-dir option is for a path name, its argument
	    should be converted.
	  [ruby-dev:49526] [Bug #12199]

Mon Apr 18 13:48:05 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (TEST_EXCLUDES, EXCLUDE_TESTFRAMEWORK): use full spell
	  long option.

	* cygwin/GNUmakefile.in (MSYS2_ARG_CONV_EXCL): suppress path name
	  conversions by msys2.  [ruby-dev:49525] [Bug #12199]

Mon Apr 18 13:48:05 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/lib/test/unit.rb (Options#non_options): make regexp name
	  options prefixed with "!" negative filters.

	* common.mk (TEST_EXCLUDES): use negative filter to exclude memory
	  leak tests.  -x option excludes test files, not test methods.

Sun Apr 17 04:30:13 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parse_ident): allow keyword arguments just after a
	  method where the same name local variable is defined.
	  [ruby-core:73816] [Bug#12073]

Sun Apr 17 04:20:40 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (setup_exception): set the cause only if it is explicitly
	  given or not set yet.  [Bug #12068]

Sat Apr 16 00:56:45 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (rb_thread_setname): defer setting native thread name
	  set in initialize until the native thread is created.
	  [ruby-core:74963] [Bug #12290]

Fri Apr 15 21:10:00 2016  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/irb/ext/save-history.rb: Fix NoMethodError when method is not defined.

Fri Apr 15 14:52:06 2016  Elliot Winkler  <elliot.winkler@gmail.com>

	* lib/forwardable.rb (def_instance_delegator) fix delegating to
	  'args' and 'block', clashing with local variables in generated
	  methods.  [ruby-core:72579] [Bug #11916]

	* lib/forwardable.rb (def_single_delegator): ditto.

Fri Apr 15 14:27:48 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/irb/ext/save-history.rb: suppress warning: method redefined;
	  discarding old save_history=.

Tue Apr 12 16:15:39 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* configure.in: improve ICC (Intel C Compiler) support.

	* configure.in (CXX): The name of icc's c++ compiler is `icpc`.

	* configure.in (warnings): Add `-diag-disable=2259` to suppress
	  noisy warnings: "non-pointer conversion from "..." to "..." may
	  lose significant bits".

	* configure.in (optflags): Add `-fp-model precise` like -fno-fast-math.

	* lib/mkmf.rb: icc supports -Werror=division-by-zero
	  and -Werror=deprecated-declarations, but doesn't support
	  -Wdivision-by-zero and -Wdeprecated-declarations.

Tue Apr 12 14:29:01 2016  Kazuki Yamaguchi  <k@rhe.jp>

	* ext/openssl/extconf.rb: check SSL_CTX_set_next_proto_select_cb
	  function rather than OPENSSL_NPN_NEGOTIATED macro. it exists
	  even if it is disabled by OpenSSL configuration.
	  [ruby-core:74384] [Bug #12182]

	* ext/openssl/ossl_ssl.c: update #ifdef(s) as above.

	* test/openssl/test_ssl.rb: skip NPN tests if NPN is disabled.

Tue Apr 12 14:27:04 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/uri/http.rb (URI::HTTP#initialize): [DOC] fix example,
	  missing mandatory arguments.  [ruby-core:74540] [Bug #12215]

Thu Apr  7 01:07:02 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* sprintf.c (rb_str_format): fix buffer overflow, length must be
	  greater than precision.  reported by William Bowling <will AT
	  wbowling.info>.

Wed Apr  6 00:33:45 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/rubygems/security.rb (DIGEST_ALGORITHM, KEY_ALGORITHM):
	  should check same name as the used constants.
	  [ruby-core:72674] [Bug #11940]

Mon Apr  4 00:31:51 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (compile_massign_lhs): when index ends with splat,
	  append rhs value to it like POSTARG, since VM_CALL_ARGS_SPLAT
	  splats the last argument only.  [ruby-core:72777] [Bug #11970]

Sat Apr  2 02:07:29 2016  Seiei Miyagi  <hanachin@gmail.com>

	* ext/ripper/lib/ripper/lexer.rb (on_heredoc_dedent): Fix
	  Ripper.lex error in dedenting squiggly heredoc.  heredoc tree is
	  also an array of Elem in the outer tree.  [Fix GH-1234]

Wed Mar 30 02:28:13 2016  Eric Wong  <e@80x24.org>

	* thread_pthread.c (setup_communication_pipe): delay setting owner
	  (rb_thread_create_timer_thread): until thread creation succeeds
	  [ruby-core:72590] [Bug #11922]

Wed Mar 30 02:20:06 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* localeinit.c (rb_locale_charmap_index): fix prototype.
	  patched by Andreas Schwab [Bug #12218]

Wed Mar 30 02:20:06 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* thread_pthread.c (reserve_stack): fix reserving position where
	  the stack growing bottom to top. [Bug #12118]

Wed Mar 30 02:17:33 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/file.c (rb_readlink): drop garbage after the substitute
	  name, as rb_w32_read_reparse_point returns the expected buffer
	  size but "\??\" prefix is dropped from the result.

	* win32/win32.c (w32_readlink): ditto, including NUL-terminator.

Wed Mar 30 02:17:33 2016  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (fileattr_to_unixmode, rb_w32_reparse_symlink_p): volume
	  mount point should be treated as directory, not symlink.
	  [ruby-core:72483] [Bug #11874]

	* win32/win32.c (rb_w32_read_reparse_point): check the reparse point is
	  a volume mount point or not.

	* win32/file.c (rb_readlink): follow above change (but this pass won't
	  be used).

Wed Mar 30 01:32:14 2016  Rei Odaira  <Rei.Odaira@gmail.com>

	* test/-ext-/time/test_new.rb (test_timespec_new): change a gmtoff
	  test to a better one that does not depend on whether the current
	  time is in summer time or not.

Wed Mar 30 01:32:14 2016  Rei Odaira  <Rei.Odaira@gmail.com>

	* test/-ext-/time/test_new.rb (test_timespec_new): Time#gmtoff values
	  are the same only when both or neither of the Time objects are in
	  summer time (daylight-saving time).

Wed Mar 30 01:30:54 2016  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* lib/rubygems/test_case.rb: Fix test on Windows for inconsistent temp path.
	  https://github.com/rubygems/rubygems/pull/1554
	  [Bug #12193][ruby-core:74431]

Wed Mar 30 01:25:46 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* string.c (str_new_frozen): if the given string is embeddedable
	  but not embedded, embed a new copied string. [Bug #11946]

Wed Mar 30 01:23:57 2016  Marcus Stollsteimer  <sto.mar@web.de>

	* doc/extension.ja.rdoc: Fix RDoc markup in doc/extension*.rdoc.
	  [ci skip][Bug #12143][ruby-core:74143]
	* doc/extension.rdoc: ditto.

Wed Mar 30 01:00:30 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (proc_binding): proc from symbol can not make a binding.
	  [ruby-core:74100] [Bug #12137]

Wed Mar 30 00:54:38 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/win32.h (O_SHARE_DELETE): change to fit Fixnum
	  limit.  [ruby-core:74285] [Bug #12171]

Wed Mar 30 00:52:47 2016  Rei Odaira  <Rei.Odaira@gmail.com>

	* test/net/imap/test_imap.rb (test_idle_timeout): Because of the
	  timeout specified in "imap.idle(0.2)", there is no gurantee that
	  the server thread has done all the work before the client thread
	  performs the assertions. It depends on the thread scheduling.
	  Add checks to avoid false positives (on AIX, particularly).

Wed Mar 30 00:41:42 2016  Rei Odaira  <Rei.Odaira@gmail.com>

	* test/socket/test_socket.rb (test_udp_recvmsg_truncation):
	  AIX does not set the MSG_TRUNC flag for a message partially read
	  by recvmsg(2) with the MSG_PEEK flag set.

Wed Mar 30 00:00:47 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* doc/extension.rdoc, doc/extension.ja.rdoc: add editor local
	  variables, with commenting out by :enddoc: directives which are
	  just ignored unless code object mode.  [Bug #12111]

Wed Mar 30 00:00:47 2016  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* doc/extension.ja.rdoc: removed rendering error caused by editor specific
	  configuration on http://docs.ruby-lang.org/en/trunk/extension_rdoc.html .
	  [Bug #12111][ruby-core:73990]

Tue Mar 29 23:54:31 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* object.c (rb_mod_const_get): make error message at uninterned
	  string consistent with symbols.  [ruby-dev:49498] [Bug #12089]

Tue Mar 29 23:45:24 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dir.c (push_pattern, push_glob): deal with read paths as UTF-8
	  to stat later, on Windows as well as OS X.
	  [ruby-core:73868] [Bug #12081]

Tue Mar 29 23:36:49 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/extmk.rb: add cygwin case, nothing excluded.
	  [ruby-core:73806] [Bug#12071]

Tue Mar 29 23:10:47 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* iseq.c (rb_iseq_mark): mark parent iseq to prevent dynamically
	  generated iseq by eval from GC.  [ruby-core:72620] [Bug #11928]

Tue Mar 29 22:56:44 2016  Eric Wong  <e@80x24.org>

	* lib/resolv.rb (Resolv::IPv6.create): avoid modifying frozen
	* test/resolv/test_dns.rb (test_ipv6_create): test for above
	  [Bug #11910] [ruby-core:72559]

Tue Mar 29 22:31:48 2016  Shugo Maeda  <shugo@ruby-lang.org>

	* range.c (range_eqq): revert r11113 because rb_call_super() is
	  called in range_include() and thus r11113 doesn't work when the
	  receiver Range object consists of non linear objects such as Date
	  objects.
	  [ruby-core:72908] [Bug #12003]

Tue Mar 29 22:26:55 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_eval.c (rb_check_funcall_with_hook): also should call the
	  given hook before returning Qundef when overridden respond_to?
	  method returned false.  [ruby-core:73556] [Bug #12030]

Tue Mar 29 22:08:36 2016  Kazuki Yamaguchi  <k@rhe.jp>

	* compile.c (iseq_peephole_optimize): don't apply tailcall
	  optimization to send/invokesuper instructions with blockiseq.
	  This is a follow-up to the changes in r51903; blockiseq is now
	  the third operand of send/invokesuper instructions.
	  [ruby-core:73413] [Bug #12018]

Tue Mar 29 21:22:22 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (xstring): reset heredoc indent after dedenting,
	  so that following string literal would not be dedented.
	  [ruby-core:72857] [Bug #11990]

Tue Mar 29 21:22:22 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (string1): reset heredoc indent fore each string leteral
	  so that concatenated string would not be dedented.
	  [ruby-core:72857] [Bug #11990]

Tue Mar 29 21:18:09 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_here_document): update indent for each line in
	  indented here document with single-quotes.
	  [ruby-core:72479] [Bug #11871]

Tue Mar 29 21:03:40 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* symbol.h (is_attrset_id): ASET is an attrset ID.  fix
	  unexpected safe call instead of an ordinary ASET.

Tue Mar 29 21:01:07 2016  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* doc/syntax/calling_methods.rdoc: fix old operator for safe navigation
	  operator. [ci skip][fix GH-1182] Patch by @dougo

Tue Mar 29 18:49:54 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/ostruct.rb (freeze): define deferred accessors before
	  freezing to get rid of an error when just reading frozen
	  OpenStruct.

Tue Mar 29 18:49:54 2016  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/ostruct.rb: Fix new_ostruct_member to correctly avoid
	  redefinition [#11901]

Tue Mar 29 17:54:17 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/ostruct.rb (OpenStruct): make respond_to? working on
	  just-allocated objects for workaround of Psych.
	  [ruby-core:72501] [Bug #11884]

Tue Mar 29 17:04:35 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_eval.c (rb_f_catch): [DOC] fix malformed RDoc syntax, "+...+"
	  cannot enclose non-identifier characters.
	  a patch by Sebastian S in [ruby-core:74278].  [Bug#12170]

Tue Mar 29 17:03:28 2016  Rei Odaira  <Rei.Odaira@gmail.com>

	* test/-ext-/float/test_nextafter.rb: In AIX,
	  nextafter(+0.0,-0.0)=+0.0, and nextafter(-0.0,+0.0)=-0.0,
	  but they should return -0.0 and +0.0, respectively. This is
	  a known bug in nextafter(3) on AIX, so skip related tests.

Tue Mar 29 16:54:14 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (enc_succ_alnum_char): try to skip an invalid character
	  gap between GREEK CAPITAL RHO and SIGMA.
	  [ruby-core:74478] [Bug #12204]

Tue Mar 29 16:45:58 2016  Victor Nawothnig  <Victor.Nawothnig@gmail.com>

	* parse.y (parse_numvar): NTH_REF must be less than a half of
	  INT_MAX, as it is left-shifted to be ORed with back-ref flag.
	  [ruby-core:74444] [Bug#12192] [Fix GH-1296]

Tue Mar 29 16:44:54 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* enc/trans/JIS: update Unicode's notice. [Bug #11844]

Tue Mar 29 16:41:27 2016  Eric Hodel  <drbrain@segment7.net>

	* marshal.c (r_object0):  raise ArgumentError when linking to undefined
	  object.

Tue Mar 29 16:41:27 2016  Eric Hodel  <drbrain@segment7.net>

	* marshal.c (r_object0): Fix Marshal crash for corrupt extended object.

Tue Mar 29 16:40:48 2016  Eric Wong  <e@80x24.org>

	* ext/openssl/ossl_ssl.c (ossl_sslctx_setup): document as MT-unsafe
	  [ruby-core:73803] [Bug #12069]

Tue Mar 29 16:29:44 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* insns.def (opt_mod): show its method name on ZeroDivisionError.
	  [Bug #12158]

Tue Mar 29 16:25:27 2016  Anthony Dmitriyev  <antstorm@gmail.com>

	* net/ftp.rb: add NullSocket#closed? to fix closing not opened
	  connection.  [Fix GH-1232]

Tue Mar 29 16:12:08 2016  Koichi ITO  <koic.ito@gmail.com>

	* variable.c: Added documentation about order of `Module#constants`
	  [ci skip][Bug #12121][ruby-dev:49505][fix GH-1301]

Tue Mar 29 16:02:26 2016  Rei Odaira  <Rei.Odaira@gmail.com>

	* test/ruby/test_process.rb (test_execopts_gid): Skip a test
	  that is known to fail on AIX. AIX allows setgid to
	  a supplementary group, but Ruby does not allow the "-e"
	  option when setgid'ed, so the test does not work as intended.

Tue Mar 29 15:58:18 2016  Rei Odaira  <Rei.Odaira@gmail.com>

	* test/socket/test_addrinfo.rb (test_ipv6_address_predicates):
	  IN6_IS_ADDR_V4COMPAT and IN6_IS_ADDR_V4MAPPED are broken
	  on AIX, so skip related tests.

Tue Mar 29 15:31:06 2016  Rei Odaira  <Rei.Odaira@gmail.com>

	* test/rinda/test_rinda.rb (test_make_socket_ipv4_multicast):
	  The fifth argument to getsockopt(2) should be modified to
	  indicate the actual size of the value on return,
	  but not in AIX. This is a know bug. Skip related tests.
	* test/rinda/test_rinda.rb (test_ring_server_ipv4_multicast):
	  ditto.
	* test/rinda/test_rinda.rb (test_make_socket_unicast): ditto.
	* test/socket/test_basicsocket.rb (test_getsockopt): ditto.
	* test/socket/test_sockopt.rb (test_bool): ditto.

Tue Mar 29 15:27:14 2016  Rei Odaira  <Rei.Odaira@gmail.com>

	* test/zlib/test_zlib.rb (test_adler32_combine, test_crc32_combine):
	  Skip two tests on AIX because zconf.h in zlib does not correctly
	  recognize _LARGE_FILES in AIX. The problem was already reported
	  to zlib, and skip these tests until it is fixed.

Tue Mar 29 15:10:31 2016  Rei Odaira  <Rei.Odaira@gmail.com>

	* thread_pthread.c (getstack): __pi_stacksize returned by
	  pthread_getthrds_np() is wrong on AIX. Use
	  __pi_stackend - __pi_stackaddr instead.

Tue Mar 29 15:10:05 2016  Alex Boyd  <alex@opengroove.org>

	* lib/irb.rb: avoid to needless truncation when using back_trace_limit option.
	  [fix GH-1205][ruby-core:72773][Bug #11969]

Tue Mar 29 15:05:16 2016  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* ext/tk/lib/tkextlib/tcllib/tablelist_tile.rb: fix method name typo.
	  [ruby-core:72513] [Bug #11893] The patch provided by Akira Matsuda.


Tue Mar 29 15:05:02 2016  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* ext/tk/lib/tkextlib/tcllib/toolbar.rb: fix method name typo.
	  [ruby-core:72511] [Bug #11891] The patch provided by Akira Matsuda.


Tue Mar 29 15:04:42 2016  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* ext/tk/lib/tkextlib/blt/tree.rb: fix method name typo.
	  [ruby-core:72510] [Bug #11890] The patch provided by Akira Matsuda.


Tue Mar 29 15:04:19 2016  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* ext/tk/lib/tk/menubar.rb: fix a typo in font name. [ruby-core:72505]
	  [Bug #11886] The patch provided by Akira Matsuda.

	* ext/tk/sample/*.rb: ditto.

Tue Mar 29 15:03:03 2016  Kenta Murata  <mrkn@mrkn.jp>

	* ruby.h: undef HAVE_BUILTIN___BUILTIN_CHOOSE_EXPR_CONSTANT_P
	  and HAVE_BUILTIN___BUILTIN_TYPES_COMPATIBLE_P on C++.
	  [ruby-core:72736] [Bug #11962]

Tue Mar 29 14:58:56 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/socket/option.c (inspect_tcpi_msec): more accurate condition
	  for TCPI msec member inspection function.
	  [ruby-core:74388] [Bug #12185]

Tue Mar 29 14:53:58 2016  Naotoshi Seo  <sonots@gmail.com>

	* lib/logger.rb: Remove block from Logger.add as it's not needed
	  patch provided by Daniel Lobato Garcia [fix GH-1240] [Bug #12054]

Tue Mar 29 14:52:20 2016  Zachary Scott  <zzak@ruby-lang.org>

	* re.c: Remove deprecated kcode argument from Regexp.new and compile
	  patch provided by Dylan Pulliam [Bug #11495]

Tue Mar 29 14:44:02 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/socket/socket.c (sock_gethostname): support unlimited size
	  hostname.

Tue Mar 29 14:35:06 2016  Kouhei Sutou  <kou@cozmixng.org>

	* lib/xmlrpc/client.rb: Support SSL options in async methods of
	  XMLRPC::Client.
	  [Bug #11489]
	  Reported by Aleksandar Kostadinov. Thanks!!!

Tue Mar 29 14:22:57 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* marshal.c (r_object0): honor Marshal.load post proc
	  value for TYPE_LINK.  by Hiroshi Nakamura <nahi@ruby-lang.org>
	  https://github.com/ruby/ruby/pull/1204 fix GH-1204

Tue Mar 29 14:18:26 2016  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* .travis.yml: removed commented-out code.

Tue Mar 29 14:18:26 2016  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* .travis.yml: removed osx code. follow up with r53517

Tue Mar 29 14:12:22 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/socket/option.c (sockopt_bool): relax boolean size to be one
	  too not only sizeof(int).  Winsock getsockopt() returns a single
	  byte as a boolean socket option.  [ruby-core:72730] [Bug #11958]

Tue Mar 29 14:12:22 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/socket/option.c (check_size): extract a macro to check
	  binary data size, with a consistent message.

	* ext/socket/option.c (sockopt_byte): fix error message,
	  sizeof(int) differs from sizeof(unsigned char) in general.

Tue Mar 29 14:01:14 2016  NAKAMURA Usaku  <usa@ruby-lang.org>

	* process.c (rb_execarg_parent_start1): need to convert the encoding to
	  ospath's one.

Tue Mar 29 14:01:14 2016  NAKAMURA Usaku  <usa@ruby-lang.org>

	* process.c: use rb_w32_uchdir() instead of plain chdir() on Windows.
	  reported by naruse via twitter.

	* process.c (rb_execarg_addopt): need to convert the encoding to
	  ospath's one.

Tue Mar 29 13:56:36 2016  Eric Wong  <e@80x24.org>

	* ext/stringio/stringio.c (strio_binmode): implement to set encoding
	* test/stringio/test_stringio.rb (test_binmode): new test
	  [ruby-core:72699] [Bug #11945]

Tue Mar 29 13:50:30 2016  Eric Wong  <e@80x24.org>

	* io.c (io_getpartial): remove unused kwarg from template
	* test/ruby/test_io.rb (test_readpartial_bad_args): new
	  [Bug #11885]

Tue Mar 29 13:41:03 2016  Tadashi Saito  <tad.a.digger@gmail.com>

	* compile.c, cont.c, doc, man: fix common misspelling.
	  [ruby-core:72466] [Bug #11870]

Tue Mar 29 13:31:34 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (regexp): set_yylval_num sets u1, should use nd_tag
	  instead of nd_state.  [ruby-core:72638] [Bug #11932]

Tue Mar 29 13:31:34 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (set_yylval_num): should be used as nd_state, set to u3.
	  [ruby-core:72638] [Bug #11932]

Tue Mar 29 13:26:15 2016  Joseph Tibbertsma  <josephtibbertsma@gmail.com>

	* gc.c (RVALUE_PAGE_WB_UNPROTECTED): fix a typo of argument name.
	  [Fix GH-1221]

Thu Jan 21 16:39:55 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* Makefile.in (update-rubyspec): fix r53208 like r53451.

Fri Jan 15 00:05:57 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/uri/generic.rb (URI::Generic#to_s): change encoding to
	  UTF-8 as Ruby 2.2/ by Koichi ITO <koic.ito@gmail.com>
	  https://github.com/ruby/ruby/pull/1188 fix GH-1188

Tue Jan 12 17:23:39 2016  NAKAMURA Usaku  <usa@ruby-lang.org>

	* process.c (rb_execarg_parent_start1): need to convert the encoding to
	  ospath's one.

Tue Jan 12 17:23:39 2016  NAKAMURA Usaku  <usa@ruby-lang.org>

	* process.c: use rb_w32_uchdir() instead of plain chdir() on Windows.
	  reported by naruse via twitter.

	* process.c (rb_execarg_addopt): need to convert the encoding to
	  ospath's one.

Tue Jan 12 15:21:00 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/missing.h (explicit_bzero_by_memset_s): remove
	  inline implementation by memset_s, which needs a macro before
	  including headers and can cause problems in extension libraries
	  by the order of the macro and headers.

Thu Dec 24 23:01:57 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* NEWS: added entry for CGI.escapeHTML optimization.

Thu Dec 24 18:43:19 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* error.c (rb_compile_error_with_enc, rb_compile_error),
	  (rb_compile_bug): deprecate internal functions.

	* parse.y (parser_yyerror): construct exception message with
	  source code and caret.

Thu Dec 24 17:25:42 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (append_compile_error), parse.y (compile_error):
	  preserve encoding of source file name in exceptions.

	* error.c (rb_compile_error_str, rb_compile_bug_str): add.

Thu Dec 24 16:17:47 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* common.mk (fake.rb): $(arch)-fake.rb must depend on miniruby because
	  it may depend on miniruby.

Thu Dec 24 16:13:05 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* common.mk (ripper.c): r50045 wrongly replace $(PWD) with ../..
	  It is the top of build directory, not topsrcdir.

Thu Dec 24 15:02:42 2015  sorah (Shota Fukumori)  <her@sorah.jp>

	* tool/vcs.rb (IO.popen): Refactor. Avoid assigning in condition.

Thu Dec 24 15:01:38 2015  sorah (Shota Fukumori)  <her@sorah.jp>

	* tool/file2lastrev.rb: Fix ArgumentError to work on Ruby 1.8.7.

Thu Dec 24 14:44:08 2015  sorah (Shota Fukumori)  <her@sorah.jp>

	* tool/vcs.rb (IO.popen): Enable on Ruby 1.9 where chdir option is not
	  supported on IO.popen

	* tool/vcs.rb (IO.popen): Fix NoMethodError. I guess r49705 was not
	  tested... :/

Thu Dec 24 14:57:03 2015  Koichi Sasada  <ko1@atdot.net>

	* NEWS: rename
	  "Implementation changes" section to
	  "Supported platform changes" section.

	* NEWS: add "Implementation improvements" and add several entries.

	* NEWS: add NEWS entries by Eric Wong. [ruby-core:72450]

Thu Dec 24 00:26:05 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/io/console/extconf.rb: fix gem build failure on Windows.
	  only win32_vk.inc is included in the gem and no dependencies for
	  the header, so that gperf will not be mandatory.
	  [ruby-core:72453] [Bug #11866]

	* ext/io/console/io-console.gemspec: include depend file and
	  win32_vk header.

Wed Dec 23 23:58:44 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_readwrite_syserr_fail): works with the given errno than
	  thread local errno.

Wed Dec 23 17:57:45 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c, io.c, util.c: prefer rb_syserr_fail with saved errno
	  over setting errno then call rb_sys_fail, not to be clobbered
	  potentially and to reduce thread local errno accesses.

Wed Dec 23 11:58:52 2015  Yuichiro Kaneko  <yui-knk@ruby-lang.org>

	* string.c: Fix document. Default value of the first
	  argument of `String#split` is not `$;` but `nil`.
	  When `nil` is passed as first argument, `$;` is used.
	  [ci skip] [Bug #11729] [ruby-dev:49378]

Wed Dec 23 07:15:17 2015  Eric Wong  <e@80x24.org>

	* ext/socket/init.c (rsock_init_sock): reject reserved FDs
	  [ruby-core:72445] [Bug #11862]

Wed Dec 23 02:59:26 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (__STDC_WANT_LIB_EXT1__): necessary to use memset_s
	  in strict C99 mode.

Wed Dec 23 02:34:36 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* regexec.c (match_at): move direct threaded VM code to get rid of
	  mixed declarations and code, and enable it only for gcc since it
	  depends on a gcc extension.

Wed Dec 23 02:23:19 2015  Yuki Nishijima  <mail@yukinishijima.net>

	* gems/bundled_gems: Upgrade the did_you_mean gem to 1.0.0

	* NEWS: Add news about the did_you_mean gem

Wed Dec 23 02:18:57 2015  Jake Worth  <jakeworth82@gmail.com>

	* doc/contributing.rdoc: [DOC] remove an extra word "here".
	  [Fix GH-1169]

Wed Dec 23 01:58:20 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* regexec.c (USE_DIRECT_THREADED_VM): enable direct threaded VM by
	  the default.

Tue Dec 22 22:15:53 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gc.c (internal_object_p): should not expose singleton classes
	  without a metaclass.  based on patches by ko1 and shugo.
	  [Bug #11740]

	* class.c (rb_singleton_class_object_p): added.

Tue Dec 22 22:15:08 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/io/console/io-console.gemspec: bump up to 0.4.4.

Tue Dec 22 22:11:06 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* NEWS: Added news entry of Psych 2.0.17

Tue Dec 22 22:09:01 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* NEWS: Added news entry of RDoc 4.2.1

Tue Dec 22 21:20:00 2015  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.gemspec: bump version to 1.2.8.

Tue Dec 22 21:08:05 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/rdoc.rb: bump version to 4.2.1. It contains following fixes.
	  https://github.com/rdoc/rdoc/pull/340
	  https://github.com/rdoc/rdoc/pull/341
	  https://github.com/rdoc/rdoc/pull/367
	  https://github.com/rdoc/rdoc/pull/368
	* lib/rdoc/*: ditto.
	* test/rdoc/*: ditto.

Tue Dec 22 20:25:33 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* ext/psych/lib/psych.rb: bump version to 2.0.17
	* ext/psych/psych.gemspec: ditto.

Tue Dec 22 20:14:47 2015  Koichi Sasada  <ko1@atdot.net>

	* vm_insnhelper.c: move vm_callee_setup_block_arg() (and related
	  functions) to the latter location.
	  This moving recovers performance a little.
	  [Bug #11829]

Tue Dec 22 15:21:11 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (str_compat_and_valid): as scrub does nothing for dummy
	  encoding string now, incompatible encoding is not a matter.

Tue Dec 22 14:31:28 2015  Toru Iwase  <tietew@tietew.net>

	* ext/cgi/escape/escape.c (optimized_escape_html): CGI.escapeHTML
	  should return unfrozen new string.
	  [ruby-core:72426] [Bug #11858]

Tue Dec 22 05:39:58 2015  Takashi Kokubun  <takashikkbn@gmail.com>

	* ext/cgi/escape/escape.c (preserve_original_state): Preserve
	  original state for tainted and frozen.  [Fix GH-1166]
	  [ruby-dev:49451] [Bug #11855]

Tue Dec 22 03:57:20 2015  Eric Wong  <e@80x24.org>

	* ext/socket/init.c (rsock_init_sock): check FD after validating
	* test/socket/test_basicsocket.rb (test_for_fd): new
	  [ruby-core:72418] [Bug #11854]

Mon Dec 21 21:29:45 2015  Naohisa Goto  <ngotogenome@gmail.com>

	* variable.c (struct ivar_update): rename "extended" to "iv_extended"
	  to avoid name conflict with /usr/include/floatingpoint.h on
	  Solaris. [Bug #11853] [ruby-dev:49448]

Mon Dec 21 12:15:32 2015  Kimura Wataru  <kimuraw@i.nifty.jp>

	* test/ruby/test_io.rb: handled rlimit value same as r52277
	  [Bug #11852][ruby-dev:49446]

Mon Dec 21 10:21:22 2015  Ilya Vassilevsky <vassilevsky@gmail.com>

	* lib/net/http.rb (open_timeout): update default value in RDoc
	  [ruby-core:72413]

Mon Dec 21 10:18:46 2015  Kazuki Yamaguchi  <k@rhe.jp>

	* vm_backtrace.c (rb_profile_frames): ignore ifunc frames as it
	  did before.  [ruby-core:72409] [Bug #11851]

Mon Dec 21 09:33:17 2015  Karol Bucek  <kares@users.noreply.github.com>

	* ext/openssl/lib/openssl/ssl.rb (OpenSSL::SSL::SSLSocket): fix
	  NotImplementedError typo.  [Fix GH-1165]

Sun Dec 20 20:54:51 2015  Takashi Kokubun  <takashikkbn@gmail.com>

	* cgi/escape/escape.c: Optimize CGI.escapeHTML for
	  ASCII-compatible encodings.  [Fix GH-1164]

Sun Dec 20 15:36:46 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/erb.rb: revert r53123. It breaks compatibility like thor and
	  rspec-rails.
	  We should try with Ruby 2.4 or 3.0.
	  [Bug #11842][ruby-core:72374]
	* lib/rdoc/erb_partial.rb: ditto.
	* template/verconf.h.tmpl: ditto.

Sun Dec 20 11:43:31 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_yylex): allow here documents in labeled
	  argument.  [ruby-core:72396] [Bug #11849]

Sun Dec 20 11:14:11 2015  Koichi Sasada  <ko1@atdot.net>

	* proc.c (rb_mod_define_method): should check Symbol or not.
	  [Bug #11850]

	* test/ruby/test_method.rb: add a test.

Sun Dec 20 11:01:57 2015  Koichi Sasada  <ko1@atdot.net>

	* proc.c (rb_mod_define_method): fix notation.

Sun Dec 20 10:54:15 2015  Koichi Sasada  <ko1@atdot.net>

	* proc.c (proc_new): fix notation.

Sun Dec 20 00:29:00 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (rb_proc_get_iseq): proc made from symbol does not have
	  iseq.  fix infinite loop.  [ruby-core:72381] [Bug #11845]

Sat Dec 19 20:06:10 2015  Naohisa Goto  <ngotogenome@gmail.com>

	* enc/windows_1250.c: Should not use C++ style comments (C99 feature).
	  [Bug #11843]

Sat Dec 19 17:17:04 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/webrick/utils.rb (WEBrick::Utils::TimeoutHandler#initialize):
	  use WEBrick::Utils::TimeoutHandler::Thread, which is ignored by
	  LeakChecker#find_threads, instead of ::Thread to get rid of
	  thread leak checker.  since this TimeoutHandler is resident
	  during tests because of Singleton, it waits for the next timeout
	  if it has any schedules.  in the case of nested timeouts, inner
	  timeout does not cancel outer timeouts and then those schedules
	  still remain.

Sat Dec 19 14:28:01 2015  Jake Worth  <jakeworth82@gmail.com>

	* ext/zlib/zlib.c (Init_zlib): [DOC] Fix double-word typo and
	  grammatical error.  [Fix GH-1162]

Sat Dec 19 14:23:59 2015  Jake Worth  <jakeworth82@gmail.com>

	* lib/csv.rb (CSV#initialize): [DOC] Fix double-word typo.
	  [Fix GH-1161]

Sat Dec 19 10:33:33 2015  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* enc/iso_8859_2.c, enc/windows_1250.c: separate Windows-1250
	  from ISO-8859-2 to fix 0x80..0x9e range (from Kimihito Matsui)

Fri Dec 18 21:26:54 2015  Naohisa Goto  <ngotogenome@gmail.com>

	* lib/webrick/utils.rb (WEBrick::Utils::TimeoutHandler): To prevent
	  potential deadlocks, Queue is used to tell update of @timeout_info
	  instead of sleep and wakeup. [Bug #11742] [ruby-dev:49387]

Fri Dec 18 17:24:09 2015  Koichi Sasada  <ko1@atdot.net>

	* compile.c (ibf_load_object_string): use fstring if frozen string.

Fri Dec 18 16:54:38 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/stringio/stringio.c (strio_set_encoding): add StringIO's own
	  encoding and separate it from the buffer string to override the
	  encoding of string when reading.  [ruby-core:72189] [Bug #11827]
	  note that setting the encoding of its buffer string directly
	  without StringIO#set_encoding may cause unpredictable behavior.

Fri Dec 18 16:50:35 2015  Koichi Sasada  <ko1@atdot.net>

	* compile.c (ibf_load_setup): check tainted string argument.

Fri Dec 18 16:12:13 2015  Koichi Sasada  <ko1@atdot.net>

	* vm_core.h: define USE_LAZY_LOAD if it is not defined.

Fri Dec 18 15:40:06 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/stringio/stringio.c (strio_unget_bytes): extract from
	  strio_ungetbyte to share with strio_ungetc.

Fri Dec 18 12:39:42 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* doc/syntax/*.rdoc: separated modifier at sentence.
	  [ci skip][fix GH-1121] Patch by @clandry94

Fri Dec 18 12:09:21 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/stringio/stringio.c (strio_ungetbyte): pad with \000 when
	  the current position is after the end.

Fri Dec 18 11:24:48 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* vm_method.c (rb_method_entry_make, check_override_opt_method):
	  should check whether a newly created method overrides an optimize
	  method in case the method is defined in a prepended module of a
	  built-in class.
	  [ruby-core:72226] [Bug #11836]

Fri Dec 18 11:09:38 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* vm.c (vm_exec): call RUBY_DTRACE_CMETHOD_RETURN_HOOK instead of
	  RUBY_DTRACE_METHOD_RETURN_HOOK.

Fri Dec 18 10:24:44 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/irb/ruby-lex.rb: fixed parse error for striped heredocument syntax.
	  [fix GH-1127] Patch by @koic

Fri Dec 18 09:44:47 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* ext/pty/pty.c: fix double words typo.
	  [ci skip][fix GH-1157] Patch by @jwworth

Fri Dec 18 09:42:45 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* ext/nkf/nkf-utf8/utf8tbl.c: fix a typo.
	  [ci skip][fix GH-1159] Patch by @akshay-vishnoi
	* ext/nkf/nkf-utf8/utf8tbl.h: ditto.

Fri Dec 18 07:39:01 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* vm.c (rb_vm_check_redefinition_opt_method): should check the real
	  class instead of the origin iclass.
	  [ruby-core:72188] [Bug #11826]

Thu Dec 17 22:13:10 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* vm_args.c (vm_caller_setup_arg_block): remove code for ifunc
	  because it was made unnecessary by r52138.

Thu Dec 17 16:13:10 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* proc.c (rb_block_arity): should not call GetProcPtr() for symbols.
	  [ruby-core:72205] [Bug #11830]

Thu Dec 17 14:16:29 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_scrub): the result should be infected by the
	  original string.

Thu Dec 17 13:35:27 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* transcode.c (rb_econv_substr_append, econv_primitive_convert):
	  the result should be infected by the original string.

Thu Dec 17 09:46:08 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* re.c (reg_names_iter): should consider encoding of regexp.
	  [ruby-core:72185] [Bug #11825]

Thu Dec 17 03:52:10 2015  Koichi Sasada  <ko1@atdot.net>

	* vm.c (vm_make_env_each): should not compare with Qfalse and FALSE.
	  Pointed at http://d.hatena.ne.jp/nagachika/20151216/ruby_trunk_changes_53128_53163

Thu Dec 17 03:15:25 2015  Koichi Sasada  <ko1@atdot.net>

	* vm_insnhelper.c (vm_call_method_each_type): should not set fastpath
	  with keyword arguments for VM_METHOD_TYPE_ATTRSET type methods.

	  Normally, we can not use keyword arguments for this kind of methods,
	  (obj.foo = 1), but we can set alias names for them.
	  [Bug #11657]

	* test/ruby/test_keyword.rb: add a test for this fix.

Wed Dec 16 20:32:43 2015  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* ext/fiddle/handle.c: check tainted string arguments.
	  Patch provided by tenderlove and nobu.

	* test/fiddle/test_handle.rb (class TestHandle): add test for above.


Wed Dec 16 19:30:56 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* vm.c (vm_make_proc_from_block): should convert a Symbol to a Proc.
	  [ruby-core:72083] [Bug #11811]

Wed Dec 16 16:17:34 2015  Eric Wong  <e@80x24.org>

	* test/ruby/test_io.rb: fix spelling errors

Wed Dec 16 16:04:49 2015  Eric Wong  <e@80x24.org>

	* NEWS: note IO#advise change [ruby-core:72168]

Wed Dec 16 15:35:13 2015  Koichi Sasada  <ko1@atdot.net>

	* vm.c: fix mark miss for proc given as passed block.
	  [Bug #11750]

	* vm.c (vm_make_proc_from_block): should return a Proc object
	  if block is given. Previous implementation returns
	  a Proc object only when corresponding Proc object is not
	  available.

	* vm.c (vm_make_env_each): ditto.

	* test/ruby/test_proc.rb: add a test for this bug.

Wed Dec 16 12:24:59 2015  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* test_struct.rb: Test that initialize is overridable [#11708]

Wed Dec 16 10:49:51 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (block_command, block_call): fix `&.` calls after
	  block_call.  [Feature #11537]

Wed Dec 16 00:53:45 2015  Naohisa Goto  <ngotogenome@gmail.com>

	* lib/webrick/utils.rb (WEBrick::Utils::TimeoutHandler): Acquire
	  TimeoutMutex only when accessing @timeout_info for avoiding
	  potential deadlock. [Bug #11742] [ruby-dev:49387]

Wed Dec 16 00:39:27 2015  Jake Worth  <jakeworth82@gmail.com>

	* doc/extension.rdoc: [DOC] fix double-word typo.  [Fix GH-1153]

Wed Dec 16 00:25:41 2015  Naohisa Goto  <ngotogenome@gmail.com>

	* lib/webrick/utils.rb (WEBrick::Utils::TimeoutHandler#initialize):
	  TimeoutMutex should be acquired when accessing @timeout_info.
	  To avoid deadlock, interrupt() calls are delayed.
	  Due to the mutex, it is safe to treat ary without ary.dup.
	  [Bug #11742] [ruby-dev:49387]

Tue Dec 15 23:13:10 2015  Naohisa Goto  <ngotogenome@gmail.com>

	* gc.c: Delete excess semicolon after RUBY_ALIAS_FUNCTION().
	  Suppress "syntax error:  empty declaration" warnings by
	  Oracle Solaris Studio 12.x on Solaris. [Bug #11821]

	* hash.c: ditto, after NOINSERT_UPDATE_CALLBACK().

Tue Dec 15 18:04:04 2015  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* NEWS: added news about EBCDIC encoding

Tue Dec 15 17:57:57 2015  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* enc/ebcdic.h, enc/trans/ebcdic.trans,
	  test/ruby/test_transcode.rb: Fixed encoding name
	  to the correct one in the IANA registry (IBM037)
	  and added an alias (ebcdic-cp-us)

Tue Dec 15 16:19:26 2015  Takashi Kokubun  <takashikkbn@gmail.com>

	* lib/erb.rb: Render erb with array buffer for function call optimization.
	  [fix GH-1143]
	* lib/rdoc/erb_partial.rb: ditto.
	* template/verconf.h.tmpl: ditto.

Tue Dec 15 13:50:05 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_oct): [DOC] mention radix indicators.
	  [ruby-core:71310] [Bug #11648]

Tue Dec 15 12:20:30 2015  Takashi Kokubun  <takashikkbn@gmail.com>

	* lib/erb.rb: Simplify regexp to optimize erb scanner.
	  [fix GH-1144]

Tue Dec 15 11:56:24 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/uri/common.rb: make code block for rdoc.
	  [ci skip][fix GH-1152] Patch by @Tonkpils

Tue Dec 15 11:55:08 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* ext/zlib/zlib.c: fix a typo.
	  [ci skip][fix GH-1149] Patch by @crismali

Tue Dec 15 09:14:14 2015  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* tool/transcode_tablegen.rb: detailed documentation
	  for transcode_tblgen function [ci skip]

Mon Dec 14 22:11:11 2015  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* enc/ebcdic.h: new dummy encoding EBCDIC-US
	* enc/trans/ebcdic.trans: transcodings between EBCDIC-US
	  and iso-8859-1 [with code from Andrea Ribuoli]
	* test/ruby/test_transcode.rb: tests for above
	* tool/transcode_tablegen.rb: additional argument for
	  method transcode_tblgen

Mon Dec 14 17:04:14 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* ext/socket/lib/socket.rb: use safe navigation operator.
	  [fix GH-1142] Patch by @mlarraz
	* lib/drb/extservm.rb: ditto.
	* lib/net/http.rb: ditto.
	* lib/net/http/response.rb: ditto.
	* lib/scanf.rb: ditto.
	* lib/uri/generic.rb: ditto.

Mon Dec 14 17:03:05 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* bootstraptest/runner.rb: use safe navigation operator.
	  [fix GH-1142] Patch by @mlarraz
	* test/openssl/test_pair.rb: ditto.
	* test/ruby/test_econv.rb: ditto.
	* test/ruby/test_settracefunc.rb: ditto.
	* test/thread/test_queue.rb: ditto.

Mon Dec 14 14:33:35 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/xmlrpc.rb: added documentation for parser details.
	  [ci skip][fix GH-1124] Patch by @jrafanie

Mon Dec 14 11:46:52 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* enum.c: fix a typo in documentation.
	  [ci skip][fix GH-1140] Patch by @jutaz
	* io.c: ditto.
	* iseq.c: ditto.
	* numeric.c: ditto.
	* process.c: ditto.
	* string.c: ditto.
	* vm_trace.c: ditto.

Mon Dec 14 11:41:59 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/cgi.rb: fix a typo in documentation.
	  [ci skip][fix GH-1140] Patch by @jutaz

Mon Dec 14 11:31:00 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* compile.c: fix typos.
	  [ci skip][fix GH-1140] Patch by @jutaz
	* dir.c: ditto.
	* gc.c: ditto.
	* io.c: ditto.
	* node.h: ditto.
	* thread_pthread.c: ditto.
	* vm_insnhelper.c: ditto.
	* vsnprintf.c: ditto.

Mon Dec 14 11:27:01 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* enc/iso_2022_jp.h: fix typos.
	  [ci skip][fix GH-1140] Patch by @jutaz
	* enc/utf_16_32.h: ditto.
	* enc/utf_7.h: ditto.

Mon Dec 14 11:25:57 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* benchmark/bm_app_aobench.rb: fix typos.
	  [ci skip][fix GH-1140] Patch by @jutaz
	* benchmark/bm_vm_thread_pipe.rb: ditto.

Sun Dec 13 23:46:10 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (trace_lex_state): trace lex_state changes if yydebug is
	  set, and send the messages to rb_stdout.

	* parse.y (rb_parser_printf): store YYPRINTF messages per lines
	  so that lex_state traces do not mix.

	* tool/ytab.sed: add parser argument to yy_stack_print too.

Sun Dec 13 20:41:16 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (build_lex_state_name, trace_lex_state): lex_state is
	  now bit flags and can be set 2 bits or more.

Sun Dec 13 20:26:30 2015  Yuki Yugui Sonoda  <yugui@yugui.jp>

	* test/ruby/test_syntax.rb: fix typo in test

Sun Dec 13 20:12:14 2015  Yuki Yugui Sonoda  <yugui@yugui.jp>

	* parse.y (parse_percent): Allow %-literals in labeled arg as
	  r51624 did for parentheses.
	  Fixes [ruby-core:72084] [Bug #11812].

Sun Dec 13 20:02:15 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* ChangeLog: fix a typo

Sun Dec 13 19:54:26 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* test/lib/envutil.rb: move envutil's assertions under Test::Unit::Assertion.
	* test/lib/test/unit/assertions.rb: ditto.

Sun Dec 13 19:24:20 2015  Yuki Yugui Sonoda  <yugui@yugui.jp>

	* parse.y (lex_state_name): Make it return the correct names.
	  Add new names to follow r51617; Indices ffs(2) returns are 1-origin.

Sun Dec 13 18:40:45 2015  Yuki Yugui Sonoda  <yugui@yugui.jp>

	* parse.y: debug output of lex_state transition if PARSER_DEBUG

Sun Dec 13 18:49:25 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (parse_mode_enc): preserve encoding of mode string in
	  warnings.

	* io.c (io_encname_bom_p): check BOM prefix only, not including
	  UTF prefix.

	* io.c (parse_mode_enc): warn BOM with non-UTF encoding.

	* io.c (parse_mode_enc): fix buffer overflow.

Sun Dec 13 18:35:57 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/fiddle/function.c (initialize): check all arguments first.
	  reported by Marcin 'Icewall' Noga of Cisco Talos.

	* ext/fiddle/conversions.h (PTR2NUM): use signed integer to make
	  Fixnum for negative values.

Sun Dec 13 18:33:41 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* pack.c (pack_pack): always check index range against the
	  receiver array length, which can be shortened by elements
	  conversion.  reported by Marcin 'Icewall' Noga of Cisco Talos.

Sun Dec 13 18:28:52 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/psych/psych_emitter.c (start_document): should not exceed
	  tags array range.

	* ext/psych/psych_emitter.c (start_document): ensure string before
	  encoding conversion.

Sun Dec 13 18:26:31 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/tk/tkutil/tkutil.c (tk_hash_kv): check types of array
	  argument.  reported by Marcin 'Icewall' Noga of Cisco Talos.

	* ext/tk/tkutil/tkutil.c (cbsubst_table_setup): check length of
	  argument arrays for each access, as callback methods can modify
	  them.  reported by Marcin 'Icewall' Noga of Cisco Talos.

	* ext/tk/tkutil/tkutil.c (cbsubst_table_setup): check types of
	  argument elements.  reported by Marcin 'Icewall' Noga of Cisco
	  Talos.

Sun Dec 13 18:19:20 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/win32ole/win32ole.c (ole_vstr2wc): check argument type, vstr
	  must be a String here.  reported by Marcin 'Icewall' Noga of
	  Cisco Talos.

Sun Dec 13 16:41:01 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (BOOTSTRAPRUBY): make BASERUBY full path before
	  building ruby to get rid of unexpectedly invoking built ruby.
	  [ruby-core:72065] [Bug #11807]

	* configure.in (BOOTSTRAPRUBY): use MINIRUBY but not BASERUBY
	  unless cross compiling.  [ruby-core:72065] [Bug #11807]

Sun Dec 13 14:17:19 2015  Akinori MUSHA  <knu@iDaemons.org>

	* test/test_shellwords.rb (TestShellwords): Add many more tests
	  for handling whitespace characters and frozenness.

Sun Dec 13 14:16:09 2015  Akinori MUSHA  <knu@iDaemons.org>

	* lib/shellwords.rb (Shellwords#shellsplit): Document that this
	  method does not treat shell metacharacters as such.

Sun Dec 13 12:17:43 2015  Eric Wong  <e@80x24.org>

	* lib/shellwords.rb (shellescape): duplicate frozen literal
	* test/test_shellwords.rb (test_stringification): new test

Sun Dec 13 11:47:35 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* object.c (rb_inspect): check the default internal encoding as
	  String#inspect do.
	  [ruby-dev:49415] [Bug #11787]

Sun Dec 13 11:38:12 2015  Akinori MUSHA  <knu@iDaemons.org>

	* lib/shellwords.rb: Turn on frozen-string-literal after fixing
	  shellsplit.

Sun Dec 13 10:44:44 2015  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* KNOWNBUGS.rb: Fixed typo, made more explicit [ci skip]

Sun Dec 13 10:26:47 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/openssl/ossl_ssl.c (ssl_npn_select_cb_common): fix parsing
	  protocol list.
	  The protocol list from OpenSSL is not null-terminated.
	  patched by Kazuki Yamaguchi [Bug #11810] [ruby-core:72082]

Sun Dec 13 06:40:30 2015  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/ostruct.rb: Have OpenStruct#dig raise if argument is not a
	  symbol
	  nor a string. See [#11762]

Sun Dec 13 00:05:42 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* vm_insnhelper.c (vm_call_method_missing): method_missing should
	  not be refined.
	  [ruby-core:72080] [Bug #11809]

Sat Dec 12 23:00:17 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/nkf/nkf-utf8/nkf.c: Merge nkf 2.1.4.

Sat Dec 12 18:52:26 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* object.c (rb_obj_dig): raise TypeError if an element does not
	  have #dig method.  [ruby-core:71798] [Bug #11762]

Sat Dec 12 17:59:07 2015  Yuichiro Kaneko  <yui-knk@ruby-lang.org>

	* test/ruby/test_regexp.rb: Add test cases for `$KCODE` and `$=` warning
	  [Misc #11770][ruby-dev:49398]

Sat Dec 12 17:11:57 2015  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* doc/NEWS-0.2.2: add description about incompatible change in Hash
	  duplicated key overriding policy. [Bug #10315] [Bug #11501]

Sat Dec 12 07:44:38 2015  Eric Wong  <e@80x24.org>

	* io.c (do_io_advise): do not raise on ENOSYS
	* test/ruby/test_io.rb (test_advise): do not skip on Errno::ENOSYS
	  (test_advise_pipe): ditto
	  [ruby-core:72066] [Feature #11806]

Sat Dec 12 07:05:29 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* enc/windows_1252.c: separate from ISO-8859-1 to fix 0x80..0x9e
	  range.  [ruby-core:64049] [Bug #10097]

Fri Dec 11 23:33:40 2015  Yusuke Endoh  <mame@ruby-lang.org>

	* sample/trick2015/: added the award-winning entries of TRICK 2015.
	  See https://github.com/tric/trick2015 for the contest outline.

Fri Dec 11 17:59:05 2015  Eric Wong  <e@80x24.org>

	* insns.def (opt_case_dispatch): avoid converting Infinity
	* test/ruby/test_optimization.rb (test_opt_case_dispatch_inf): new
	  [ruby-dev:49423] [Bug #11804]'

Fri Dec 11 16:48:57 2015  Eric Wong  <e@80x24.org>

	* hash.c (rb_num_hash_start): avoid pathological behavior
	  [ruby-core:72028] [Feature #11405]

Fri Dec 11 11:58:46 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* NEWS: Mentioned rubygems-2.5.1

Fri Dec 11 11:52:39 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/rubygems: Update to RubyGems 2.5.1
	* test/rubygems: ditto.

Fri Dec 11 11:38:14 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_compile_each, ibf_load_object_hash): rehash
	  case-dispatch hash to reduce collisions.
	  http://d.hatena.ne.jp/ku-ma-me/20151210

Fri Dec 11 03:44:43 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* object.c (rb_inspect): dump inspected result with rb_str_escape()
	  instead of raising Encoding::CompatibilityError. [Feature #11801]

	* string.c (rb_str_escape): added to dump given string like
	  rb_str_inspect without quotes and always dump in US-ASCII
	  like rb_str_dump.

Thu Dec 10 14:59:59 2015  Koichi Sasada  <ko1@atdot.net>

	* test/ruby/test_gc.rb (test_expand_heap): relax condition (1->2).

Thu Dec 10 14:15:59 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* cont.c: fix a double word typo.
	  [Bug #11313][ruby-core:69749]

Thu Dec 10 14:13:34 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* ext/tk/lib/multi-tk.rb: fix typos.
	  [Bug #11764][ruby-core:71800]

Thu Dec 10 11:33:34 2015  Eric Wong  <e@80x24.org>

	* compile.c (iseq_compile_each): reduce needless rb_str_dup
	  [ruby-core:72018] <5668DB6E.8000101@ruby-lang.org>

Thu Dec 10 09:32:51 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb, lib/shellwords.rb: disable frozen-string-literal.
	  [ruby-core:72011] [Bug #11800]

Thu Dec 10 06:33:39 2015  Eric Wong  <e@80x24.org>

	* marshal.c (memsize_dump_arg): remove NULL check
	  (memsize_load_arg): ditto

Thu Dec 10 05:53:18 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* tool/mkconfig.rb: rbconfig must not be frozen-string-literal to
	  expand CONFIG hash.  [ruby-core:72006] [Bug #11798]

Thu Dec 10 05:03:51 2015  Eric Wong  <e@80x24.org>

	* ext/socket/ifaddr.c (ifaddr_mark): remove empty function
	  (ifaddr_type): pass zero to rb_data_type_t.function.dmark

Thu Dec 10 04:49:16 2015  Eric Wong  <e@80x24.org>

	* proc.c (bm_free): remove, use default free
	  (method_data_type): use RUBY_TYPED_DEFAULT_FREE

Thu Dec 10 02:01:41 2015  Koichi Sasada  <ko1@atdot.net>

	* compile.c (iseq_compile_each): do not add debug information
	  without --debug or --debug=frozen-string-literal option
	  because String#dup slows down with debug information.
	  [Feature #11725]

	* NEWS: apply about it.

	* test/ruby/test_rubyoptions.rb: catch up this fix with refactoring.

Thu Dec 10 00:06:56 2015  Koichi Sasada  <ko1@atdot.net>

	* iseq.c: rename methods
	  RubyVM::InstructionSequence#to_binary_format -> #to_binary
	  RubyVM::InstructionSequence.from_binary_format -> .load_from_binary
	  RubyVM::InstructionSequence.from_binary_format_extra_data ->
	                             .load_from_binary_extra_data

	* iseq.c: fix document of iseq.to_binary.
	  [Fix GH-1134]

	* sample/iseq_loader.rb: catch up this change.

	* test/lib/iseq_loader_checker.rb: ditto.

Wed Dec  9 17:02:03 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* regparse.h (SET_NTYPE): get rid of breaking strict aliasing.
	  patch by Zarko Todorovski in [ruby-core:71953].  [Bug #11790]

Wed Dec  9 16:10:37 2015  Koichi Sasada  <ko1@atdot.net>

	* vm.c (rb_vm_cref_in_context): Module#define_method in non-class
	  expression should be public.
	  [Bug #11754]

	* test/ruby/test_method.rb: add a test.

Wed Dec  9 14:45:27 2015  Koichi Sasada  <ko1@atdot.net>

	* gc.c (gc_mark_stacked_objects): fix typo.
	  reported by XIE Zhibang. [Bug #11763]

Wed Dec  9 14:37:51 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* doc/syntax/refinements.rdoc: remove outdated description.

Wed Dec  9 09:58:09 2015  Koichi Sasada  <ko1@atdot.net>

	* ext/**/*.c (*_memsize): same as r52986 for extensions.

Wed Dec  9 09:46:19 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* .gitignore: ignored ISeq binary format.

Wed Dec  9 09:34:41 2015  Koichi Sasada  <ko1@atdot.net>

	* *.c (*_memsize): do not check ptr.
	  NULL checking is finished Before call of memsize functions.
	  See r52979.

Wed Dec  9 09:25:29 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* test/net/smtp/test_response.rb: use Test::Unit. We should use Test::Unit
	  without rubygems and rdoc.

Wed Dec  9 06:26:23 2015  Colin Kelley <colindkelley@gmail.com>

	* lib/uri/generic.rb: enable frozen_string_literal
	  (split_userinfo): remove explicit .freeze for string literals
	  (check_path): ditto
	  (query): ditto
	  (fragment): ditto
	  (to_s): ditto
	  [ruby-core:71910] [Bug #11759]

Wed Dec  9 06:25:47 2015  Eric Wong  <e@80x24.org>

	* test/uri/test_generic.rb (to_s): new test
	  [ruby-core:71820]

Wed Dec  9 02:18:52 2015  Koichi Sasada  <ko1@atdot.net>

	* compile.c (ibf_dump_memsize): should check NULL.

Wed Dec  9 01:46:35 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* string.c (rb_str_init): now accepts new option parameter `encoding'.
	  [Feature #11785]

Wed Dec  9 00:52:37 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (rb_stat_wr, rb_stat_ww): call get_stat only once and
	  reduce checking struct.  patch by Yuki Kurihara in
	  [ruby-core:71949].  [Misc #11789]

Wed Dec  9 00:24:33 2015  Koichi Sasada  <ko1@atdot.net>

	* compile.c (iseq_ibf_dump): dump extra data just string length.

	* sample/iseq_loader.rb: add using
	  RubyVM::InstructionSequence.from_binary_format_extra_data method
	  (commented out).

Mon Dec  9 00:21:19 2015  Yuki Nishijima  <mail@yukinishijima.net>

	* gems/bundled_gems: Upgrade the did_you_mean gem to 1.0.0.rc1

Wed Dec  9 00:17:49 2015  Koichi Sasada  <ko1@atdot.net>

	* compile.c (ibf_load_setup): cast to int.

Wed Dec  9 00:13:09 2015  Koichi Sasada  <ko1@atdot.net>

	* compile.c (ibf_setup_load): rename to ibf_load_setup().

	* compile.c (iseq_load_setup): check binary format.

Tue Dec  8 23:30:07 2015  Naohisa Goto  <ngotogenome@gmail.com>

	* test/io/console/test_io_console.rb (run_pty): Avoid waiting twice
	  for a process. Fix Errno::ECHILD in TestIO_Console#test_close and
	  TestIO_Console#test_sync.

Tue Dec  8 23:05:47 2015  Koichi Sasada  <ko1@atdot.net>

	* compile.c (iseq_ibf_dump): fix for clang type checker.

Tue Dec  8 23:04:02 2015  Koichi Sasada  <ko1@atdot.net>

	* iseq.c (iseq_s_load): fix mysterious bug.

Tue Dec  8 22:31:58 2015  Koichi Sasada  <ko1@atdot.net>

	* introduce new ISeq binary format serializer/de-serializer
	  and a pre-compilation/runtime loader sample.
	  [Feature #11788]

	* iseq.c: add new methods:
	  * RubyVM::InstructionSequence#to_binary_format(extra_data = nil)
	  * RubyVM::InstructionSequence.from_binary_format(binary)
	  * RubyVM::InstructionSequence.from_binary_format_extra_data(binary)

	* compile.c: implement body of this new feature.

	* load.c (rb_load_internal0), iseq.c (rb_iseq_load_iseq):
	  call RubyVM::InstructionSequence.load_iseq(fname) with
	  loading script name if this method is defined.

	  We can return any ISeq object as a result value.
	  Otherwise loading will be continue as usual.

	  This interface is not matured and is not extensible.
	  So that we don't guarantee the future compatibility of this method.
	  Basically, you shouldn't use this method.

	* iseq.h: move ISEQ_MAJOR/MINOR_VERSION (and some definitions)
	  from iseq.c.

	* encoding.c (rb_data_is_encoding), internal.h: added.

	* vm_core.h: add several supports for lazy load.
	  * add USE_LAZY_LOAD macro to specify enable or disable of
	    this feature.
	  * add several fields to rb_iseq_t.
	  * introduce new macro rb_iseq_check().

	* insns.def: some check for lazy loading feature.

	* vm_insnhelper.c: ditto.

	* proc.c: ditto.

	* vm.c: ditto.

	* test/lib/iseq_loader_checker.rb: enabled iff suitable
	  environment variables are provided.

	* test/runner.rb: enable lib/iseq_loader_checker.rb.

	* sample/iseq_loader.rb: add sample compiler and loader.

	    $ ruby sample/iseq_loader.rb [dir]

	  will compile all ruby scripts in [dir].
	  With default setting, this compile creates *.rb.yarb files
	  in same directory of target .rb scripts.

	    $ ruby -r sample/iseq_loader.rb [app]

	  will run with enable to load compiled binary data.

Tue Dec  8 21:21:16 2015  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* NEWS: mention about Enumerator::Lazy#grep_v.
	  [ruby-core:71845] [Feature #11773]

Tue Dec  8 17:36:36 2015  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* string.c: removed unused variable

Tue Dec  8 16:23:40 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* enumerator.c (lazy_grep_v): add Enumerator::Lazy#grep_v as well
	  as Enumerable, to enumerate lazily.
	  [ruby-core:71845] [Feature #11773]

Tue Dec  8 14:27:07 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* error.c (name_err_local_variables): new method
	  NameError#local_variables for internal use only.
	  [Feature #11777]

Tue Dec  8 14:20:38 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* marshal.c (w_objivar): skip internal instance variables in
	  T_OBJECT too.

Tue Dec  8 12:58:04 2015  Naohisa Goto  <ngotogenome@gmail.com>

	* test/io/console/test_io_console.rb (test_getpass): s.getpass
	  should be tested. Narrow ensure block. This reverts r52911.
	  [Bug #11780] [ruby-dev:49412]

Tue Dec  8 10:40:21 2015  Eric Wong  <e@80x24.org>

	* benchmark/bm_vm2_case_lit.rb: new benchmark
	* compile.c (case_when_optimizable_literal): add nil/true/false
	* insns.def (opt_case_dispatch): ditto
	* vm.c (vm_redefinition_check_flag): ditto
	* vm.c (vm_init_redefined_flag): ditto
	* vm_core.h: ditto
	* object.c (InitVM_Object): define === explicitly for nil/true/false
	* test/ruby/test_case.rb (test_deoptimize_nil): new test
	* test/ruby/test_optimization.rb (test_opt_case_dispatch): update
	  (test_eqq): new test
	  [ruby-core:71923] [Feature #11769]
	  Original patch by Aaron Patterson <tenderlove@ruby-lang.org>

Tue Dec  8 10:19:02 2015  Jake Worth  <jakeworth82@gmail.com>

	* lib/optparse.rb: fix double word typo in the document.
	  [Misc #10608] [Fix GH-1126]

Tue Dec  8 09:03:19 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/date/date_core.c (d_lite_lshift): should check the argument
	  before negation.

Tue Dec  8 08:56:16 2015  Eric Wong  <e@80x24.org>

	* insns.def (opt_case_dispatch): check Float#=== redefinition
	* test/ruby/test_optimization.rb (test_opt_case_dispatch): new
	  [ruby-core:71920] [Bug #11784]

Tue Dec  8 03:56:05 2015  Koichi Sasada  <ko1@atdot.net>

	* test/lib/iseq_loader_checker.rb: add iseq dumper/loader checker.
	  If you enable this checker (remove `#' in test/runner.rb),
	  you can see comparison results between an original iseq disassembed
	  result and dumped and loaded iseq disassembed result.

	  There are several bugs around there, because of inexact stack depth
	  calculation. Now, I leave these bugs because they are not critical
	  and difficult to solve completely.

	* test/runner.rb: require test/lib/iseq_loader_checker.rb but
	  disabled at default (commented out).

Tue Dec  8 03:45:47 2015  Eric Wong  <e@80x24.org>

	* doc/extension.rdoc: warn about kwargs performance in C
	  [Feature #11339] [ci skip]

Tue Dec  8 03:44:51 2015  Koichi Sasada  <ko1@atdot.net>

	* iseq.c (iseq_load): disable peephole optimization option
	  because apply it multiple times change the sequence.
	  (iseq != peephole_optimize(load(iseq.to_a)))

Tue Dec  8 03:43:21 2015  Koichi Sasada  <ko1@atdot.net>

	* compile.c (rb_iseq_build_from_ary): do not allocate table
	  if table_size is 0.

Tue Dec  8 03:30:34 2015  Eric Wong  <e@80x24.org>

	* ext/socket/unixsocket.c (unix_send_io): document args
	  (unix_recv_io): ditto
	* test/socket/test_unix.rb (test_fd_passing_class_mode): added

Tue Dec 08 02:21:35 2015  Koichi Sasada  <ko1@atdot.net>

	* iseq.c (iseq_translate): at the end of constructing an iseq,
	  call RubyVM::InstructionSequence.translate(iseq) if this method
	  is defined. If the return value is also an object of
	  RubyVM::InstructionSequence, then use it instead of created one.

	  For example, this method is useful to test iseq dumper/loader
	  such as RubyVM::InstructionSequence#to_a and rb_iseq_load().

	  Because this method is for such internal experimental usage,
	  the interface is not matured. For example, this interface has
	  no extensibility. Two or more translators can not run
	  simultaneously.

	  So that we don't guarantee future compatibility of this method.
	  Basically, do not use this method.

Tue Dec  8 01:57:13 2015  Aaron Patterson <tenderlove@ruby-lang.org>

	* ext/psych/*: update psych to 2.0.16
	* test/psych/*: ditto

Mon Dec  7 23:45:20 2015  Koichi Sasada  <ko1@atdot.net>

	* string.c: introduce String#+@ and String#-@ to control
	  String mutability.
	  [Feature #11782]

Mon Dec  7 23:39:49 2015  Ben Miller  <bjmllr@gmail.com>

	* parse.y: add heredoc <<~ syntax.  [Feature #9098]

Mon Dec  7 23:06:16 2015  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* prelude.rb (IO#read_nonblock): [DOC] add missing options to
	  call-seq.  [ruby-core:71627] [Bug #11730]

Mon Dec  7 15:50:50 2015  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* .gitignore: added cygruby*.def for Cygwin

Sun Dec  6 19:52:31 2015  Eric Wong  <e@80x24.org>

	* include/ruby/intern.h (rb_autoload): deprecate
	* internal.h (rb_autoload_str): declare
	* load.c (rb_mod_autoload): use rb_autoload_str
	* variable.c (rb_autoload): become compatibility wrapper
	  (rb_autoload_str): hoisted out from old rb_autoload
	  [ruby-core:71369] [Feature #11664]

Sun Dec  6 18:25:22 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/webrick/test_cgi.rb (TestWEBrickCGI#test_cgi): gave up the test
	  of binary path info test on Windows because the test had passed
	  occasionally as the comment said.

Sun Dec  6 15:25:06 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/io/console/console.c (console_getpass): add IO#getpass
	  method.

Sun Dec  6 08:39:05 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* ext/json/json.gemspec: bump version to json 1.8.3. CRuby already contained
	  upstream changes.

	  https://github.com/ruby/ruby/commit/4d059bf9f5f10f3d3088de49fc87e5555db7770d
	  https://github.com/flori/json/commit/d4c99de78905d96c3f301f48b2c789943bb3f098

	* ext/json/lib/json/version.rb: ditto.

Sat Dec  5 17:48:25 2015  Lars Kanis  <lars@greiz-reinsdorf.de>

	* tool/fake.rb: Fix cross build when srcdir is an absolute path.

	* Makefile.in: PREP dependency is needed when cross build too, not
	  "-r$(arch)-fake" to be  used before created.  [Fix GH-1125]

Sat Dec  5 17:26:24 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (env_str_new, env_path_str_new): make default string
	  UTF-8 for the case conversion is not possible.  [Bug #8822]

	* hash.c (get_env_cstr): convert non-ASCII string to UTF-8 string.

	* hash.c (ruby_setenv): use wide char version to put environment
	  variable to deal with non-ASCII value.

Sat Dec  5 09:56:50 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby_atomic.h (ATOMIC_CAS): old value to be swapped should be
	  same as the destination.  immediate value may need type
	  promotion.

	* ruby_atomic.h (ATOMIC_SIZE_CAS): fix the argument order of
	  InterlockedCompareExchange64.  new value and then old value is
	  the last.

Sat Dec  5 09:23:34 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* random.c (fill_random_seed): fix the size to be filled, not the
	  size of element, but the whole size of array.

Sat Dec  5 06:03:54 2015  Eric Wong  <e@80x24.org>

	* vm.c (ruby_vm_verbose_ptr): make static
	  (ruby_vm_debug_ptr): ditto

Sat Dec  5 00:56:29 2015  Naohisa Goto  <ngotogenome@gmail.com>

	* include/ruby/ruby.h (RB_OBJ_TAINT): follow-up of r52881.
	  Turn into void expression not to use unexpected result.
	  Fix "operands have incompatible types" error with
	  Oracle Solaris Studio 12.x on Solaris.

Fri Dec  4 19:52:52 2015  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* enc/iso_8859_13.c: Added three missing lower/upper-case
	  character pairs (from Kimihito Matsui)

Fri Dec  4 18:57:57 2015  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* enc/iso_8859_4.c: Added missing lower/upper-case character
	  pair (U+014A and U+014B, LATIN CAPITAL/SMALL LETTER ENG)
	  (from Kimihito Matsui)

Fri Dec  4 16:48:19 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_obj_as_string): fstring should not be infected.
	  re-apply r52872 and fix a typo.
	  TODO: other frozen strings also may not be.

Fri Dec  4 15:21:45 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/rubygems: Update to RubyGems 2.5.0+ HEAD(fdab4c4).
	  this version includes #1396, #1397, #1398, #1399
	* test/rubygems: ditto.

Fri Dec  4 11:22:40 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (rb_thread_setname): name must be ascii-compatible, as
	  pthread APIs do not accept legacy wide char strings.

Thu Dec  3 15:39:21 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/scanf.rb: fixed double words typo.
	  [ci skip][fix GH-1123] Patch by @jwworth

Thu Dec  3 15:37:56 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* test/ruby/test_mixed_unicode_escapes.rb: fixed typo.
	  [fix GH-1122] Patch by @davydovanton
	* test/ruby/test_object.rb: ditto.
	* test/socket/test_tcp.rb: ditto.

Thu Dec  3 15:33:08 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* sprintf.c (rb_str_format): fix wrong shifting position in
	  Rational conversion when not at the beginning of the result.
	  [ruby-core:71806] [Bug #11766]

Thu Dec  3 14:22:16 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* range.c (range_to_s): should be infected by the receiver.
	  str2 infects by appending.  [ruby-core:71811] [Bug #11767]

Thu Dec  3 11:57:12 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in: separate SET_CURRENT_THREAD_NAME, which can set
	  the name of current thread only, and SET_ANOTHER_THREAD_NAME,
	  which can set the name of other threads.

	* thread.c (rb_thread_setname): use SET_ANOTHER_THREAD_NAME.  OS X
	  is not possible to set another thread name.

	* thread_pthread.c (native_set_thread_name, thread_timer): use
	  SET_CURRENT_THREAD_NAME.

Wed Dec 02 22:57:46 2015  Koichi Sasada  <ko1@atdot.net>

	* vm_core.h, iseq.h: remove rb_iseq_t::variable_body.
	  Fields in rb_iseq_t::variable_body are contained by
	  rb_iseq_t::body::mark_ary (hidden Array object).

	  Index 0 to 2 of mark_ary are reserved by these objects.

	* iseq.c: catch up this fix.

	* compile.c (rb_iseq_original_iseq): trivial rewrite.

Wed Dec  2 17:19:02 2015  Koichi Sasada  <ko1@atdot.net>

	* iseq.h: introduce ISEQ_ORIGINAL_ISEQ() and
	  ISEQ_ORIGINAL_ISEQ_ALLOC() macro.

	* compile.c: use them to access original iseq buffer.

	* iseq.c: ditto.

	* vm_core.h: rename iseq field to support this fix.

Wed Dec  2 17:10:32 2015  Koichi Sasada  <ko1@atdot.net>

	* iseq.h: introduce ISEQ_FLIP_CNT_INCREMENT() macro.

	* compile.c (iseq_compile_each): use it.

	* vm_core.h: rename flip_cnt field to support this fix.

Wed Dec  2 17:05:15 2015  Koichi Sasada  <ko1@atdot.net>

	* iseq.h: introduce ISEQ_COVERAGE() and ISEQ_COVERAGE_SET() macro.

	* compile.c: use them.

	* iseq.c: ditto.

	* iseq.c (rb_iseq_coverage): added.

	* thread.c (update_coverage): use rb_iseq_coverage().

	* vm_core.h: rename coverage field name to support this fix.

Wed Dec  2 17:00:54 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* encoding.c (enc_name, rb_enc_name_list_i, rb_enc_aliases_enc_i):
	  make fstring instead of making each copies.

Wed Dec  2 16:32:08 2015  Koichi Sasada  <ko1@atdot.net>

	* iseq.h: introduce ISEQ_COMPILE_DATA() macro.

	* compile.c, iseq.c: use ISEQ_COMPILE_DATA().

	* vm_core.h: rename compile_data field to support this fix.

Wed Dec  2 16:27:19 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* encoding.c (enc_m_loader): defer finding encoding object not to
	  be infected by marshal source.  [ruby-core:71793] [Bug #11760]

	* marshal.c (r_object0): enable compatible loader on USERDEF
	  class.  the loader function is called with the class itself,
	  instead of an allocated object, and the loaded data.

	* marshal.c (compat_allocator_table): initialize
	  compat_allocator_tbl on demand.

	* object.c (rb_undefined_alloc): extract from rb_obj_alloc.

Wed Dec  2 15:12:43 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* configure.in: Fixed double negative comments.
	  [Bug #11698][ruby-core:71506]

Wed Dec  2 14:55:01 2015  yui-knk  <spiketeika@gmail.com>

	* test/ruby/test_string.rb: removed non executing tests.
	  [Misc #11757][ruby-dev:49397]

Wed Dec  2 11:23:06 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/csv.rb: enable frozen_string_literal.
	  [fix GH-1116] Patch by @marshall-lee

Wed Dec  2 10:36:25 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* ext/bigdecimal/bigdecimal.c: Fix double word typo.
	  [ci skip][fix GH-1120] Patch by @jwworth

Wed Dec  2 07:43:51 2015  Eric Wong  <e@80x24.org>

	* ext/openssl/ossl_ssl.c (mSSLExtConfig): make static
	  (eSSLError): ditto
	  (ID_callback_state): ditto
	  (ossl_ssl_ex_vcb_idx): ditto
	  (ossl_ssl_ex_store_p): ditto
	  (ossl_ssl_ex_ptr_idx): ditto
	* ext/openssl/ossl_ssl.h: remove extern declarations for
	  mSSLExtConfig and eSSLError

Wed Dec  2 07:41:08 2015  Eric Wong  <e@80x24.org>

	* missing/explicit_bzero.c (explicit_bzero): fixup r52839
	  for compilers with "weak" attribute

Wed Dec  2 06:47:25 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* missing/explicit_bzero.c: add ruby_explicit_bzero_hook_unused
	  for preventing optimization. Inspired from OpenBSD.

Tue Dec  1 23:36:39 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (rb_thread_setname): allow to reset thread name.

Tue Dec  1 23:14:04 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (rb_thread_setname): check the argument if valid
	  string.  [ruby-core:71774] [Bug #11756]

Tue Dec  1 17:13:41 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_string_value_cstr): should not raise on frozen
	  string.

Tue Dec  1 09:35:29 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* missing/explicit_bzero.c: add a few comment.

Tue Dec  1 09:31:19 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* missing/explicit_bzero.c: add disabling optimization on gcc.

Tue Dec  1 07:50:33 2015  Eric Wong  <e@80x24.org>

	* missing/explicit_bzero.c: new file. define explicit_bzero.
	  Fixup r52806

Thu Oct 22 12:54:43 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (register_ubf_list): renamed from
	  add_signal_thread_list.
	* thread_pthread.c (unregister_ubf_list): renamed
	  from remove_signal_thread_list.
	* thread_pthread.c (ubf_wakeup_all_threads): renamed from
	  ping_signal_thread_list.
	* thread_pthread.c (ubf_wakeup_thread): renamed from
	  ubf_select_each.
	* thread_pthread.c (ubf_threads_empty): renamed from
	  check_signal_thread_list().
	* thread_pthread.c (ubf_list_lock): renamed from
	  signal_thread_list_lock.

	* thread_pthread.c (register_ubf_list): large simplification
	  by using ccan/list.h.
	  bonus: removed malloc() and exit(EXIT_FAILURE).
	* thread_pthread.c (unregister_ubf_list): ditto.
	* thread_pthread.c (ubf_threads_empty): ditto.
	* thread_pthread.c (ubf_wakeup_all_threads): ditto.

	* thread_pthread.c (print_signal_list): removed.

Thu Oct 22 08:03:49 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/ruby/test_rand.rb (TestRand#test_default_seed): add
	  srand case.

Thu Oct 22 06:33:38 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* random.c (InitVM_Random): move Random::DEFAULT initialization
	  bits to Init_Random_default.
	* random.c (Init_Random_default): renamed from Init_RandomSeed2.
	* random.c (Init_RandomSeedCore): renamed from Init_RandomSeed.

Thu Oct 22 06:20:48 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* random.c (Init_RandomSeed): move all Random::DEFAULT
	  construction bits to Init_RandomSeed2. Random::DEFAULT
	  and Ruby internal hashes are no longer shared their seed.
	* random.c (Init_RandomSeed2): ditto. And, kill evil
	  rb_obj_reveal() stuff.

	* random.c (init_hashseed): add MT argument.
	* random.c: (init_siphash): ditto.

	* test/ruby/test_rand.rb (TestRand#test_default_seed): new
	  test for Random::DEFAULT::seed.

Thu Oct 22 05:23:48 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* random.c (init_hashseed, init_siphash): extract initialize
	  functions.

Thu Oct 22 01:01:34 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* configure.in: sort AC_CHECK_HEADERS() by alphabetical order.

Thu Oct 22 00:19:07 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* random.c (init_randomseed): remove "initial" argument. It never
	  be used from outside of this function.

Thu Oct 22 00:12:33 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* lib/securerandom.rb (SecureRandom::gen_random): use /dev/urandom
	  for initialize OpenSSL's rand.

Wed Oct 21 12:10:04 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* ext/openssl/ossl_rand.c (ossl_rand_bytes): RAND_bytes could
	  be return -1 as an error. Therefore, added error handling.
	* ext/openssl/ossl_pkey_dsa.c (dsa_generate): ditto.

Wed Oct 21 09:04:09 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* include/ruby/util.h: remove a warning suppression C4723
	  (potential divide by zero) for VisualC++. It's meaningless.
	  Before r26197, there is ruby_div0() in this place and it
	  actually made divide by zero. But now it's just garbage.

Wed Oct 21 08:23:36 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* random.c: random_raw_seed don't use GRND_NONBLOCK. GRND_NONBLOCK
	  mean the result might not have an enough cryptic strength and
	  easy predictable. That's no good for SecureRandom.

Sun Oct 18 17:26:53 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* common.mk: add a rule for explicit_bzero.o.
	* configure.in: detect explicit_bzero and memset_s.
	* include/ruby/missing.h: add explicit_bzero.
	* random.c (init_randomseed): use explicit_bzero() instead of
	  memset(). memset could be eliminated by compiler optimization.

Mon Nov 30 18:46:44 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/readline/extconf.rb: call dir_config("libedit")
	  if --enable-libedit is specified. [Bug #11751]
	  patched by John Hein

Mon Nov 30 08:44:29 2015  Eric Wong  <e@80x24.org>

	* variable.c: remove spurious #define for globals
	  [ruby-core:71735] [Feature #11749]

Sun Nov 29 09:13:03 2015  Conor Landry  <clandry94@gmail.com>

	* NEWS: [DOC] Various grammar corrections and clarifications to
	  increase readability.  [Fix GH-1115]

Sat Nov 28 19:33:55 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_here_document): store dispatched result of
	  on_tstring_content at the last fragment of a here document.

Fri Nov 27 19:19:44 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/net/http.rb (connect): detect closed connection and reconnect
	  If the server closes a keep-alive http connection, the client socket
	  reaches EOF. To avoid an EOFError, detect the closed connection and
	  reconnect.
	  Added test to ensure HTTP#post succeeds even if the
	  keep-alive-connection has been closed by the server.
	  by Kristian Hanekamp <kris.hanekamp@gmail.com>
	  https://github.com/ruby/ruby/pull/1089 fix GH-1089

Thu Nov 26 21:36:40 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_peephole_optimize): enable tail call
	  optimization for specialized indexers.

	* compile.c (iseq_compile_each): blockiseq should be NULL, but not
	  Qnil.

Thu Nov 26 17:22:53 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* regcomp.c, regenc.c, regexec.c, regint.h, enc/unicode.c:
	  Merge Onigmo 58fa099ed1a34367de67fb3d06dd48d076839692
	  + https://github.com/k-takata/Onigmo/pull/52

Thu Nov 26 09:50:02 2015  yui-knk  <spiketeika@gmail.com>

	* test/coverage/test_coverage.rb: Added test-case for Coverage.restart.
	  [Misc #11732][ruby-dev:49379]

Thu Nov 26 09:46:36 2015  yui-knk  <spiketeika@gmail.com>

	* test/coverage/test_coverage.rb: Added test-case for Coverage.peek_result
	  without Coverage.start. [Misc #11726][ruby-core:71622]

Thu Nov 26 07:22:55 2015  Eric Wong  <e@80x24.org>

	* test/openssl/test_ssl.rb (test_copy_stream): new test

Wed Nov 25 21:23:39 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (copy_stream_body): try to_io conversion before read,
	  readpartial, and write methods.  [ruby-dev:49008] [Bug #11199]

Wed Nov 25 10:55:21 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* io.c (argf_getpartial): should not resize str if the second
	  argument is not given.
	  [ruby-core:71668] [Bug #11738]

Tue Nov 24 23:56:25 2015  Naohisa Goto  <ngotogenome@gmail.com>

	* configure.in: On Solaris, it is safe to define _LARGEFILE_SOURCE
	  when _FILE_OFFSET_BITS=64 is defined (= when 32-bit compile).

Tue Nov 24 10:00:10 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/rubygems/installer.rb: Fix two double-word typos.
	  [ci skip][fix GH-1108] Patch by @jwworth

Tue Nov 24 09:17:02 2015  Alexander von Gluck IV  <kallisti5@unixzen.com>

	* beos: Drop support for BeOS now that Haiku is stable.
	  [Fix GH-1112]

Tue Nov 24 09:16:35 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* internal.h (rb_gc_for_fd): move to export, as referred by
	  ext/socket.

Tue Nov 24 09:04:29 2015  David Rodriguez  <deivid.rodriguez@gmail.com>

	* file.c: [DOC] add a missing period to File docs, to terminate
	  the sentence and separate from the next sentence.  [Fix GH-1111]

Tue Nov 24 08:30:06 2015  JuanitoFatas  <katehuang0320@gmail.com>

	* NEWS: Fix the issue number of `Struct#dig`, which should be
	  [Feature #11688].  [Fix GH-1110]

Tue Nov 24 07:56:54 2015  Eric Wong  <e@80x24.org>

	* ext/socket/init.c (rsock_s_accept): handle ENOMEM

Tue Nov 24 07:50:15 2015  Eric Wong  <e@80x24.org>

	* dir.c (dir_initialize): use rb_gc_for_fd for ENOMEM
	* ext/socket/init.c (rsock_socket): ditto
	* ext/socket/socket.c (rsock_socketpair): ditto
	* internal.h (rb_gc_for_fd): prototype
	* io.c (rb_gc_for_fd): remove static
	  [ruby-core:71623] [Feature #11727]

Tue Nov 24 06:46:27 2015  Eric Wong  <e@80x24.org>

	* io.c (rb_gc_for_fd): new helper function
	  (ruby_dup): use rb_gc_for_fd
	  (rb_sysopen): ditto
	  (rb_fdopen): ditto
	  (rb_pipe): ditto
	  [ruby-core:71623] [Feature #11727]

Tue Nov 24 05:13:35 2015  Eric Wong  <e@80x24.org>

	* ext/fiddle/function.c (struct nogvl_ffi_call_args):
	  new struct for GVL release
	  (nogvl_ffi_call): new function
	  (function_call): adjust for GVL release
	  [ruby-core:71642] [Feature #11607]
	* ext/fiddle/closure.c (struct callback_args):
	  new struct for GVL acquire
	  (with_gvl_callback): adjusted original callback function
	  (callback): wrapper for conditional GVL acquire
	* ext/fiddle/depend: add dependencies
	* ext/fiddle/extconf.rb: include top_srcdir for internal.h
	* internal.h (ruby_thread_has_gvl_p): expose for fiddle
	* vm_core.h (ruby_thread_has_gvl_p): moved to internal.h
	* test/fiddle/test_function.rb (test_nogvl_poll): new test

Mon Nov 23 19:53:12 2015  Naohisa Goto  <ngotogenome@gmail.com>

	* configure.in: On Solaris, with gcc, "-std=iso9899:1999"
	  in $ansi_options is often also needed in CPPFLAGS,
	  because some feature definitions vary depending on such
	  standards options.

Mon Nov 23 12:54:39 2015  Hamish Morrison  <hamishm53@gmail.com>

	* configure.in: remove obsolete workarounds for Haiku.

	* dln.c, file.c, io.c: remove obsolete Haiku workarounds.

	* thread_pthread.c: add stack bounds detection for Haiku.

	* signal.c: get stack pointer from signal context on Haiku.
	  [ruby-core:67923] [Bug #10811] [Fix GH-1109]

Mon Nov 23 11:44:11 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* gems/bundled_gems: bump version to minitest-5.8.3

Mon Nov 23 08:55:00 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* ChangeLog: fix wrong reference for r52714

Sun Nov 22 22:23:37 2015  Rei Odaira  <Rei.Odaira@gmail.com>

	* gc.c (rb_raw_obj_info): fix compile errors when USE_RGENGC
	  is 0.

Sun Nov 22 21:58:09 2015  Naohisa Goto  <ngotogenome@gmail.com>

	* lib/cmath.rb: methods which has suffix '!' are now deprecated.
	  Re-apply r52469 made by Kazuki Tanaka, with fixing bug about
	  mathn.rb compatibility. [ruby-core:68528] [Feature #10974]

Sun Nov 22 19:36:51 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* ext/openssl/ossl.c: fix brew command for installation of openssl.
	  [ci skip][fix GH-1107] Patch by @arthurnn

Sun Nov 22 17:59:50 2015  Naohisa Goto  <ngotogenome@gmail.com>

	* configure.in: On Solaris, add -D_XOPEN_SOURCE=n only when both
	  AC_TRY_CPP and AC_TRY_COMPILE pass, because some options
	  (e.g. -std=iso9899:1999) are not set when running C preprocessor
	  or building ext.

Sun Nov 22 16:53:34 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_peephole_optimize): remove unreachable code
	  chunk after jump/leave.

	* parse.y: move dead code elimination of logical operation to
	  compile.c.  not to warn logical operation of literal constants.

Sun Nov 22 16:37:10 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_peephole_optimize): eliminate always/never
	  branches after a literal object and when the value is used after
	  the branch.

Sun Nov 22 01:23:43 2015  Naohisa Goto  <ngotogenome@gmail.com>

	* configure.in: Add -D_XOPEN_SOURCE=500 (or 600 or 700) on Solaris
	  if available, mainly for enabling some features in sockets.

Sun Nov 22 00:17:22 2015  Naohisa Goto  <ngotogenome@gmail.com>

	* test/socket/test_socket.rb (test/socket/test_socket.rb): skip
	  the test when Socket::SO_TIMESTAMP is not defined. Fix error
	  on Solaris 10. [Bug #11728] [ruby-dev:49377]

Sat Nov 21 18:57:28 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby.c (need_argument): move frozen-string-literal-debug option
	  from --enable to --debug.  [Feature #11725]

	* ruby.c (proc_options): fix pointer overrun. do not advance argv
	  until it is valid.

Sat Nov 21 13:59:09 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/digest/sha1/extconf.rb: OpenSSL's struct name for SHA1 is
	  SHA_CTX. http://openssl.org/docs/man0.9.8/crypto/SHA1.html

Sat Nov 21 13:31:52 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/digest/*/*.[ch]: include ruby.h before digest.h to avoid
	  including ext/digest/extconf.h. [Bug #3231]
	  https://msdn.microsoft.com/library/36k2cdd4.aspx

	* ext/digest/*/extconf.rb: remove ext/digest from include search path
	  to avoid confusion of cl.exe.

	* ext/digest/*/*.[ch]: explicitly specify def.h's path.

Sat Nov 21 13:05:16 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/openssl/ossl.h: LibreSSL doesn't have and need e_os2.h.

Sat Nov 21 09:18:10 2015  Koichi Sasada  <ko1@atdot.net>

	* thread_sync.c: reduce the specification of Queue#close.
	  * Queue#close accepts no arguments.
	  * deq'ing on closed queue returns nil, always.
	  [Feature #10600]

	* test/thread/test_queue.rb: catch up this fix.

Sat Nov 21 08:44:21 2015  Koichi Sasada  <ko1@atdot.net>

	* compile.c (iseq_compile_each): add debug information to NODE_STR
	  strings as default.
	  [Feature #11725]

	* insns.def (freezestring): add new instruction to support adding
	  debug information for dynamically constructed strings.

	* compile.c (iseq_compile_each): support adding debug information
	  for NODE_DSTR with freezestring instruction.

	* error.c (rb_error_frozen): change the debug information ID name
	  id_debug_created_info and this field should have a 2 element array
	  containing path and line information.

	* defs/id.def: ditto.

	* test/ruby/test_rubyoptions.rb: catch up this fix.

	* test/ruby/test_iseq.rb: now frozen strings are not same.

Sat Nov 21 04:34:16 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* symbol.c (rb_str_intern): should not freeze the receiver itself
	  unexpectedly.  [ruby-core:71611] [Bug #11721]

Fri Nov 20 23:15:18 2015  Naotoshi Seo  <sonots@gmail.com>

	* lib/logger.rb: expose logger mutex
	  [fix GH-541] Patch by @arthurnn

Fri Nov 20 15:05:28 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* Added missing reference of GitHub

Fri Nov 20 14:57:01 2015  Trevor Rowe  <trevorrowe@gmail.com>

	* lib/net/http.rb: Fixed regression for Net::HTTP::PUT with "Expect-100"
	  header. [fix GH-949]
	* test/net/http/test_http.rb: added test.

Fri Nov 20 14:39:56 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/net/http.rb: set hostname before call ossl_ssl_set_session.
	  [Bug #11401][ruby-core:70152][fix GH-964] Patch by @mkarnebeek

Fri Nov 20 12:53:19 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* array.c: clarify docs for take_while/drop_while samples.
	  [ci skip][fix GH-1028] Patch by @leriksen

Fri Nov 20 12:48:04 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* ext/socket/socket.c: remove mention of :UNIX in getaddrinfo().
	  It's typically not a support option.
	  [ci skip][fix GH-990] Patch by @eam

Fri Nov 20 12:44:06 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/rss/syndication.rb: Add nodoc marker for #validate_sy_updatePeriod.
	  [ci skip][fix GH-1105] Patch by @davydovanton

Fri Nov 20 09:05:21 2015  Koichi Sasada  <ko1@atdot.net>

	* vm.c (rb_vm_cref_replace_with_duplicated_cref): added.

	  CREFs should not be shared by methods between `using'.
	  [Bug #11247]

	* vm_insnhelper.c (vm_cref_replace_with_duplicated_cref): ditto.

	* vm.c (vm_cref_dup): should copy refinements correctly.

	* eval.c: use rb_vm_cref_replace_with_duplicated_cref().

	* eval_intern.h: add a decl. of
	  rb_vm_cref_replace_with_duplicated_cref().

	* vm_eval.c (eval_string_with_cref): do not need to pass
	  scope's CREF because VM can find out CREF from stack frames.

	* test/ruby/test_refinement.rb: add a test.

Fri Nov 20 06:52:53 2015  Eric Wong  <e@80x24.org>

	* .gitattributes: new file for git users
	  [ruby-core:71578] [Feature #11713]

Thu Nov 19 22:35:31 2015  Tanaka Akira  <akr@fsij.org>

	* ext/socket/ancdata.c: Check buffer full and ignore MSG_TRUNC flag.
	  buffer fullness is more robust to detect the message is too big for
	  the buffer.
	  AIX 7.1 recvmsg doesn't set MSG_TRUNC for rflags when MSG_PEEK is
	  given.

Thu Nov 19 21:55:11 2015  Koichi Sasada  <ko1@atdot.net>

	* gc.c (gc_start): force to invoke GC by GC.start
	  even if it is GC.disable'd.

	* test/ruby/test_gc.rb: add a test.

Thu Nov 19 20:08:59 2015  Koichi Sasada  <ko1@atdot.net>

	* gc.c: trivial performance improvements.

	    name    modified
	    vm1_gc_short_lived*                1.015
	    vm1_gc_short_with_complex_long*    1.014
	    vm1_gc_short_with_long*            1.000
	    vm1_gc_short_with_symbol*          1.016
	    vm1_gc_wb_ary*                     1.002
	    vm1_gc_wb_ary_promoted*            0.996
	    vm1_gc_wb_obj*                     1.045
	    vm1_gc_wb_obj_promoted*            1.014
	    vm3_gc                             1.021

	* gc.c (gc_writebarrier_generational): reorder parameters to optimize
	  register passing function call.

	* gc.c (gc_writebarrier_incremental): ditto.

	* gc.c (rb_gc_writebarrier): remove LIKELY().
	  LIKELY() seems to move related functions not better places.

Thu Nov 19 19:45:05 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby.c (ruby_prog_init): [DOC] ARGV does not contain the name of
	  the executable.  [ruby-core:71561] [Bug #11711]

Thu Nov 19 15:53:21 2015  Koichi Sasada  <ko1@atdot.net>

	* signal.c: should also clear ruby_disable_gc.
	  [Bug #11692]

Thu Nov 19 15:31:45 2015  Koichi Sasada  <ko1@atdot.net>

	* compile.c (iseq_compile_each): T_IMEMO/iseq objects should be
	  wrap with ISeq wrappers. [Bug #11676]

Thu Nov 19 15:16:12 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/rubygems: Update to RubyGems 2.5.0+ HEAD(c6b4946).
	  this version includes #1114, #1314, #1322, #1375, #1383, #1387
	* test/rubygems: ditto.

Thu Nov 19 14:14:37 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (finish_overlapped_socket): return value of this
	  function should be only 0 or SOCKET_ERROR.

Thu Nov 19 14:12:12 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_tailcall_optimize): apply tail call optimization
	  before conversion to specialized instructions.  when looking
	  back from `leave` instruction, `send` instructions have been
	  translated already.

Thu Nov 19 13:57:58 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (finish_overlapped_socket): ignore EMSGSIZE when input,
	  because POSIX platforms just do so.  fixes test errors revealed by
	  r52647.

Thu Nov 19 02:52:30 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/socket/ancdata.c (bsock_recvmsg_internal): stretch the buffer size
	  only when vmaxdatlen is nil.

Thu Nov 19 02:20:11 2015  Tanaka Akira  <akr@fsij.org>

	* test/socket/test_socket.rb (test_udp_recvmsg_truncation): rflags is
	  nil on Solaris 10 which have no HAVE_STRUCT_MSGHDR_MSG_CONTROL.
	  Reported by Naohisa Goto. [ruby-core:71557] [Bug #11709]

Thu Nov 19 01:48:05 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* configure.in: add -static-libgcc for mingw automatically if available.

Thu Nov 19 00:53:26 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/extmk.rb (--extflags): new option to pass EXTLDFLAGS to children,
	  especially exts.mk.

	* common.mk (EXTMK_ARGS): use above option.

Wed Nov 18 22:50:43 2015  Koichi Sasada  <ko1@atdot.net>

	* vm_method.c (rb_class_clear_method_cache): should clear all
	  RCLASS_CALLABLE_M_TBLs of all sub-classes (T_ICLASS).

	  RCLASS_CALLABLE_M_TBL() caches complemented method entries.
	  It should be cleared when the modules are cleared.
	  On previous version clears only for direct children.
	  It is enough for normal modules because corresponding T_ICLASSes
	  are direct children.

	  However, refinements create complex data structure. So that
	  we need to clear all children (and descendants).
	  [ruby-core:71423] [Bug #11672]

	* vm_method.c (rb_clear_method_cache_by_class): rb_mKernel
	  doesn't call rb_class_clear_method_cache, so that
	  clear child T_ICLASSes.

	* test/ruby/test_refinement.rb: enable disabled test.

Wed Nov 18 21:09:08 2015  Koichi Sasada  <ko1@atdot.net>

	* vm_method.c (prepare_callable_method_entry): use
	  RCLASS_CALLABLE_M_TBL() instead of accessing a filed directly.

Wed Nov 18 17:08:18 2015  Koichi Sasada  <ko1@atdot.net>

	* method.h: introduce the following field and macros.

	  * rb_method_definition_t::complemented_count to count shared method
	    entries because of complemented method entries and separate from
	    alias_count.

	    Shared `def' only by complemented method entries should not prevent
	    method re-definition warning.

	  * METHOD_ENTRY_COMPLEMENTED(me) to represent complemented method entry.
	  * METHOD_ENTRY_COMPLEMENTED_SET(me) to check it as  complemented me.

	* vm_insnhelper.c (aliased_callable_method_entry): should also
	  check me->def->complemented_count.

	* vm_method.c (method_definition_addref_complement): add to count
	  complemented method entries number.

	* vm_method.c (rb_method_definition_release): release `def' iff
	  alias_count == 0 and complemented_count == 0.

	* test/ruby/test_module.rb: add a test.

Wed Nov 18 17:06:19 2015  Koichi Sasada  <ko1@atdot.net>

	* gc.c (rb_raw_obj_info): fix trivial issues.

	  * support SPECIAL_CONSTs.
	  * fix IMEMO/ment outputs.

Wed Nov 18 11:32:15 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_peephole_optimize): eliminate always/never
	  branches after a literal object.  this sequence typically
	  appears by defined? operator for a method call on a local
	  variable.

Wed Nov 18 10:33:06 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/socket/ancdata.c (bsock_recvmsg_internal): stretch the buffer size
	  when EMSGSIZE occurs on non HAVE_STRUCT_MSGHDR_MSG_CONTROL platforms
	  (such as, Windows).  fixes a test error revealed by r52625.

Wed Nov 18 10:12:36 2015  Eric Wong  <e@80x24.org>

	* ext/socket/ancdata.c (bsock_recvmsg_internal): use 4096 as
	  default size to match pre-r52610, which also maps to a common
	  page size.

Wed Nov 18 10:05:25 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* doc/syntax/refinements.rdoc: update documentation to reflect
	  recent changes.
	  [ci skip] [ruby-core:71466] [Misc #11681] Patch by James Adam

Wed Nov 18 09:50:21 2015  Naotoshi Seo  <sonots@gmail.com>

	* test/logger/test_logdevice.rb: Fix tests of logger to make it work on
	  windows (windows can not remove opened file) [Bug #11702]

Wed Nov 18 06:59:52 2015  Eric Wong  <e@80x24.org>

	* ext/socket/ancdata.c (bsock_recvmsg_internal): grow buffer
	  on unspecified maxdatlen
	  [ruby-core:71517] [Bug #11701]
	* ext/socket/lib/socket.rb (Socket#recvmsg): nil default for dlen
	  (Socket#recvmsg_nonblock): ditto
	* test/socket/test_socket.rb (test_recvmsg_udp_no_arg): new test

Tue Nov 17 19:50:06 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (fstat): declare for mingw.

Tue Nov 17 19:02:59 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* configure.in (BASERUBY): use Kernel#print instead of Kernel#p because
	  the baseruby may output CRLF as end of line.

Tue Nov 17 15:34:34 2015  Martin Duerst  <duerst@it.aoyama.ac.jp>
	* NEWS: Added update from Unicode 7.0.0 to 8.0.0 [ci skip]

Tue Nov 17 15:30:30 2015  Martin Duerst  <duerst@it.aoyama.ac.jp>
	* enc/unicode/casefold.h, name2ctype.h: Change Unicode
	  Version for regular expressions from 7.0.0 to
	  8.0.0 (with help from Kimihito Matsui) [Feature #11563]

Tue Nov 17 14:36:00 2015  Kenichi Kamiya  <kachick1@gmail.com>

	* lib/ostruct.rb (dig): Implement OpenStruct#dig
	  [Feature #11688]

Tue Nov 17 14:04:14 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/socket/lib/socket.rb (Socket#recvmsg{,_nonblock}): default values
	  of clen must be nil.

	* ext/socket/ancdata.c (bsock_sendmsg_internal): handle nil of clen.
	  fixes test errors introduced at r52602.

Tue Nov 17 13:43:46 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/socket/lib/socket.rb: UNIXSocket is not always exists.  fixes
	  install error on Windows, introduced at r52601.

Tue Nov 17 11:27:23 2015  Eric Wong  <e@80x24.org>

	* ext/socket/lib/socket.rb (Socket#recvfrom_nonblock):
	  UDPSocket#recvfrom_nonblock):
	  update doc for `exception: false` and destination buffer
	  [ruby-core:69542] [Feature #11229]
	  [ruby-core:69543] [Feature #11242]

Tue Nov 17 11:25:05 2015  Eric Turner  <ericturnerdev@gmail.com>

	* array.c (rb_ary_dig), hash.c (rb_hash_dig): [DOC] Update
	  comments describing dig methods.  [Fix GH-1103]

	* struct.c (rb_struct_dig): [DOC] add rdoc.

Tue Nov 17 11:22:22 2015  Martin Duerst  <duerst@it.aoyama.ac.jp>
	* NEWS: Small grammatical fix [ci skip]

Tue Nov 17 10:12:30 2015  Eric Wong  <e@80x24.org>

	* ext/socket/lib/socket.rb (Socket.accept_loop): avoid exceptions
	  (Socket.udp_server_recv): ditto

Tue Nov 17 09:59:00 2015  Eric Wong  <e@80x24.org>

	* ext/socket/ancdata.c (bsock_sendmsg_internal): avoid arg parsing
	  [ruby-core:71439] [Feature #11339]
	  (rsock_bsock_sendmsg): make private, adjust for above
	  (rsock_bsock_sendmsg_nonblock): ditto
	* ext/socket/rubysocket.h: adjust prototypes
	  (rsock_opt_false_p): remove
	* ext/socket/basicsocket.c (rsock_init_basicsocket):
	  define private methods
	* ext/socket/lib/socket.rb (BasicSocket#sendmsg): new wrapper
	  (BasicSocket#sendmsg_nonblock): ditto

Tue Nov 17 09:45:18 2015  Eric Wong  <e@80x24.org>

	* ext/socket/ancdata.c (bsock_recvmsg_internal): avoid arg parsing
	  (rsock_bsock_recvmsg): adjust for above change
	  (rsock_bsock_recvmsg_nonblock): ditto
	  [ruby-core:71439] [Feature #11339]
	* ext/socket/rubysocket.h: adjust prototypes for above
	* ext/socket/basicsocket.c (rsock_init_basicsocket):
	  adjust private methods
	* ext/socket/lib/socket.rb (BasicSocket#recvmsg): wrapper method
	  (BasicSocket#recvmsg_nonblock): ditto

Tue Nov 17 08:36:34 2015  Eric Wong  <e@80x24.org>

	* ext/socket/init.c (rsock_s_accept_nonblock): avoid parsing args
	  [ruby-core:71439] [Feature #11339]
	* ext/socket/rubysocket.h: adjust prototype
	* ext/socket/socket.c (sock_accept_nonblock): make private
	* ext/socket/tcpserver.c (tcp_accept_nonblock): ditto
	* ext/socket/unixserver.c (unix_accept_nonblock): ditto
	* ext/socket/lib/socket.rb (Socket#accept_nonblock):
	  implement as wrapper, move RDoc
	  (TCPServer#accept_nonblock): ditto
	  (UNIXServer#accept_nonblock): ditto

Tue Nov 17 08:25:57 2015  Eric Wong  <e@80x24.org>

	* ext/socket/socket.c (sock_connect_nonblock):
	  avoid argument parsing in C.
	  [ruby-core:71439] [Feature #11339]
	* ext/socket/lib/socket.rb (Socket#connect_nonblock):
	  new wrapper for private method, move RDoc

Tue Nov 17 08:16:09 2015  Eric Wong  <e@80x24.org>

	* ext/socket/init.c (rsock_s_recvfrom_nonblock):
	  avoid arg parsing with C API
	  [ruby-core:71439] [Feature #11339]
	* ext/socket/basicsocket.c (bsock_recv_nonblock):
	  adjust for above change, make private
	* ext/socket/socket.c (sock_recvfrom_nonblock): ditto
	* ext/socket/udpsocket.c (udp_recvfrom_nonblock): ditto
	* ext/socket/lib/socket.rb (BasicSocket#recv_nonblock):
	  new wrapper for private method, move RDoc
	  (Socket#recvfrom_nonblock): ditto
	  (UDPSocket#recvfrom_nonblock): ditto

Mon Nov 16 21:27:54 2015  Naohisa Goto  <ngotogenome@gmail.com>

	* test/dtrace/helper.rb (Dtrace::TestCase#trap_probe): dtrace buffer
	  size is set as 8m on Solaris (default 4m). [Bug #11697]

Mon Nov 16 20:03:14 2015  Naotoshi Seo  <sonots@gmail.com>

	* lib/logger.rb: Add Logger#reopen

Mon Nov 16 18:21:52 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* object.c (rb_obj_dig): dig in nested structs too.

	* struct.c (rb_struct_dig): new method Struct#dig.
	  [Feature #11688]

Mon Nov 16 17:41:33 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_peephole_optimize): optimize tail calls on aref
	  and aset specialized instructions.

	* compile.c (iseq_peephole_optimize): optimize replaced leave
	  instruction copied to jump instruction too.

Mon Nov 16 16:39:38 2015  Akinori MUSHA  <knu@iDaemons.org>

	* lib/set.rb: Enable frozen_string_literal.

	* lib/set.rb: Move << out of the begin block that ensures pop.

Mon Nov 16 16:28:30 2015  Akinori MUSHA  <knu@iDaemons.org>

	* lib/set.rb (Hash#flatten!, #add?, #delete?, #collect!, #reject!,
	  #select!, #^, #classify): Micro-optimize some methods for
	  performance and readability.

Mon Nov 16 16:17:58 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* ChangeLog: fixed accidentally commit.

Mon Nov 16 16:10:51 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* mkconfig.rb: Add some high-level documentation.
	  [ci skip][fix GH-1081] Patch by @ulfalizer

Mon Nov 16 15:59:14 2015  yui-knk  <spiketeika@gmail.com>

	* proc.c: Add call-seq of `Method#super_method`
	  [ci skip][fix GH-1094]

Mon Nov 16 15:58:39 2015  Kenichi Kamiya  <kachick1@gmail.com>

	* struct.c: Standardize a method signature of Struct#[]=.
	  [ci skip][fix GH-1095]

Mon Nov 16 15:42:36 2015  Akinori MUSHA  <knu@iDaemons.org>

	* lib/set.rb (#>=, #>, #<=, #<): Make use of Hash#>=, #>, #<, and
	  #<= when comparing against an instance of the same kind.

Mon Nov 16 15:37:11 2015  Naotoshi Seo  <sonots@gmail.com>

	* lib/logger.rb: Support symbol and string log level setting

Mon Nov 16 15:33:11 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* tool/rbinstall.rb: fix wrong permission for gem specification without
	  zlib runtime. [Bug #11685][ruby-dev:49343]

Mon Nov 16 12:11:11 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/webrick/httpauth/basicauth.rb: fix a typo.
	  [ci skip][fix GH-1099] Patch by @jwworth
	* lib/webrick/httpauth/digestauth.rb: ditto.

Sun Nov 15 18:28:43 2015  Kenichi Kamiya  <kachick1@gmail.com>

	* vm_method.c (set_method_visibility): should fail if the receiver
	  is frozen.  [ruby-core:71489] [Bug #11687]

Sat Nov 14 22:15:07 2015  Tanaka Akira  <akr@fsij.org>

	* ext/socket/lib/socket.rb: Specify frozen_string_literal: true.

Sat Nov 14 21:44:56 2015  Tanaka Akira  <akr@fsij.org>

	* lib/time.rb: Use "<<" to reduce string allocation.

Sat Nov 14 17:45:49 2015  Tanaka Akira  <akr@fsij.org>

	* lib/tsort.rb: Specify frozen_string_literal: true.

Sat Nov 14 17:25:15 2015  Tanaka Akira  <akr@fsij.org>

	* lib/resolv-replace.rb: Specify frozen_string_literal: true.

Sat Nov 14 17:00:13 2015  Tanaka Akira  <akr@fsij.org>

	* lib/time.rb: Specify frozen_string_literal: true.

Sat Nov 14 16:43:02 2015  Tanaka Akira  <akr@fsij.org>

	* lib/open3.rb: Specify frozen_string_literal: true.

Sat Nov 14 05:04:09 2015  Koichi Sasada  <ko1@atdot.net>

	* node.h: remove old comments.

Sat Nov 14 04:55:36 2015  Koichi Sasada  <ko1@atdot.net>

	* refactoring CREF related code.

	* eval_intern.h: remove unused setter functions.
	  CREF_CLASS_SET()
	  CREF_NEXT_SET()
	  CREF_SCOPE_VISI_COPY()

	* eval_intern.h: rename flags:
	  * NODE_FL_CREF_PUSHED_BY_EVAL_ -> CREF_FL_PUSHED_BY_EVAL
	  * NODE_FL_CREF_OMOD_SHARED_ -> CREF_FL_OMOD_SHARED
	  and use IMEMO_FL_USER1/2.

	* vm.c (vm_cref_new): accept push_by_eval parameter.

	* vm.c (vm_cref_new_use_prev): added for rb_vm_rewrite_cref().

	* vm_insnhelper.c (vm_cref_push): accept pushed_by_eval parameter.

	* vm_insnhelper.h: remove unused macros:
	  COPY_CREF_OMOD() and COPY_CREF().

	* vm_eval.c, insns.def: catch up this fix.

Sat Nov 14 02:58:03 2015  Koichi Sasada  <ko1@atdot.net>

	* vm.c (vm_define_method): refactoring.
	  * get CREF in this function.
	  * cbase is no longer needed (CREF_CLASS(cref) is enough).

	* compile.c: RubyVM::FrozenCore.define_method only accept 2 args.

Sat Nov 14 02:34:43 2015  Koichi Sasada  <ko1@atdot.net>

	* vm.c (vm_define_method): do not use current CREF immediately,
	  but check CREF in environment or methods. Methods defined in methods
	  should be public.
	  [Bug #11571]

	* vm_method.c (rb_scope_module_func_check): check CREF in env or me.
	  if CREF is contained by `me', then return FALSE.

	* test/ruby/test_method.rb: add a test.

Sat Nov 14 02:19:16 2015  Koichi Sasada  <ko1@atdot.net>

	* method.h: constify rb_cref_t::scope_visi;

	* eval_intern.h (CREF_SCOPE_VISI_COPY): catch up this fix.

	* vm_method.c: ditto.

Sat Nov 14 01:53:52 2015  Naohisa Goto  <ngotogenome@gmail.com>

	* pack.c (pack_unpack, AVOID_CC_BUG): Very ugly workaround for
	  optimization bug of Oracle Solaris Studio 12.4 on Solaris
	  with -xO4 optimization option. [Bug #11684]

Fri Nov 13 23:00:23 2015  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* configure.in: unset LD_PRELOAD on mingw. msys2 child processes
	  crash at make test-all with LD_PRELOAD.
	  [ruby-core:71461] [Bug #11680]

Fri Nov 13 14:00:43 2015  Zachary Scott  <zzak@ruby-lang.org>

	* ext/openssl/ossl_pkey.c: Merge ruby/openssl@b9ea8ef [Bug #10735]

Fri Nov 13 13:09:16 2015  Zachary Scott  <zzak@ruby-lang.org>

	* ext/openssl/ossl_ssl.c: Merge ruby/openssl@81e1a30

	* test/openssl/test_ssl.rb: ditto

Fri Nov 13 13:05:37 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* prelude.rb (Thread.exclusive): warn as deprecated.

Fri Nov 13 10:36:39 2015  Victor Nawothnig  <Victor.Nawothnig@gmail.com>

	* parse.y (new_unless): optimize constant condition for `unless`
	  as well as `if`.  [Fix GH-1092]

Fri Nov 13 10:08:41 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* ext/psych/psych.gemspec: bump version to 2.0.15

Thu Nov 12 18:44:26 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_magic_comment): should match exactly.
	  [ruby-core:71460] [Bug #11679]

Thu Nov 12 16:16:20 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* template/prelude.c.tmpl: enable tail call optimization.

Thu Nov 12 14:17:01 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_yylex): ANDDOT at the head of the line denote
	  line continuation from previous one to support fluent interface,
	  as well as single dot.

Thu Nov 12 13:49:50 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/rubygems: Update to RubyGems 2.5.0+ HEAD(db78980).
	  this version includes #1367 , #1373 , #1375
	* test/rubygems: ditto.

Thu Nov 12 10:53:41 2015  Eric Wong  <e@80x24.org>

	* benchmark/bm_io_nonblock_noex2.rb: new benchmark based
	  on bm_io_nonblock_noex.rb
	* io.c (io_read_nonblock): move documentation to prelude.rb
	  (io_write_nonblock): ditto
	  (Init_io): private, internal methods for prelude.rb use only
	* prelude.rb (IO#read_nonblock): wrapper + documentation
	  (IO#write_nonblock): ditto
	  [ruby-core:71439] [Feature #11339]

Wed Nov 11 18:30:28 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* sprintf.c (rb_str_format): look up the key, then get default
	  value and raise KeyError if the returned value is nil.
	  [ruby-dev:49338] [Ruby trunk - Bug #11677]

Wed Nov 11 17:38:24 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_eval.c (local_var_list_add): skip internal local variable
	  name by its type but not if it has a name.  internal local
	  variable names are just unique per frame, not globally.
	  [ruby-core:71437] [Bug #11674]

Wed Nov 11 14:14:33 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* transcode.c: fix a typo
	[ci skip][fix GH-1091] Patch by @jwworth

Wed Nov 11 11:58:38 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/ftp.rb (initialize): Connections are in passive mode per
	  default now.  The default mode can be changed by
	  Net::FTP.default_passive=.
	  [ruby-core:71146] [Feature #11612]

	* lib/net/ftp.rb (default_passive=, default_passive): new methods.

Wed Nov 11 09:03:12 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* sprintf.c (rb_str_format): respect default value of a hash.  no
	  longer raises KeyError unless the default value of the hash is
	  nil.  [ruby-core:71354] [Bug #11661]

Tue Nov 10 20:35:12 2015  Tanaka Akira  <akr@fsij.org>

	* lib/open-uri.rb: Remove indicator for "frozen_string_literal: true".

	* lib/pp.rb: Ditto.

	* lib/prettyprint.rb: Ditto.

	* lib/resolv.rb: Ditto.

	* lib/securerandom.rb: Ditto.

	* lib/tmpdir.rb: Ditto.

	* lib/unicode_normalize/tables.rb: Ditto.

	* test/net/ftp/test_buffered_socket.rb: Ditto.

	* test/net/ftp/test_mlsx_entry.rb: Ditto.

	* test/open-uri/test_open-uri.rb: Ditto.

	* test/open-uri/test_ssl.rb: Ditto.

	* test/pathname/test_pathname.rb: Ditto.

	* test/test_pp.rb: Ditto.

	* test/test_prettyprint.rb: Ditto.

	* tool/transcode-tblgen.rb: Ditto.

	* ext/pathname/lib/pathname.rb: Ditto.

Tue Nov 10 18:42:24 2015  Aleksandrs Ledovskis  <aleksandrs@ledovskis.lv>

	* defs/id.def, parse.y: Switch internal token name to reflect
	  current form of safe-call operator.  [Fix GH-1090]

Tue Nov 10 18:25:56 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (rb_hash_to_proc): use rb_func_proc_new to make light
	  weight proc.  [Feature #11653]

Tue Nov 10 18:23:35 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (cfunc_proc_t): add room for me.

	* proc.c (cfunc_proc_new): generalise for cfunc proc without env.

	* proc.c (rb_func_proc_new, rb_func_lambda_new): new functions to
	  make proc/lambda without env from cfunc.

Tue Nov 10 17:32:35 2015  Naohisa Goto  <ngotogenome@gmail.com>

	* bootstraptest/test_fork.rb ([ruby-dev:37934]): :NPROC (RLIMIT_NPROC)
	  is not supported on some platforms (e.g. Solaris 10).

Tue Nov 10 16:57:14 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (rb_hash_to_proc): new method Hash#to_proc.
	  [Feature #11653]

Tue Nov 10 14:34:09 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* time.c (rb_time_timespec_new): swap utc and localtime
	  to generate gmt flag by INT_MAX - gmtoff.

Tue Nov 10 14:01:59 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (rb_hash_{le,lt,ge,gt}): new methods, Hash#<=, Hash#<,
	  Hash#>=, Hash#>, to test if all elements of a hash are also
	  included in another hash, and vice versa.
	  [ruby-core:68561] [Feature #10984]

Tue Nov 10 11:25:29 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* time.c (rb_timespec_now): added.  [Feature #11558]

	* time.c (rb_time_timespec_new): added.  [Feature #11558]

Tue Nov 10 06:17:17 2015  Eric Wong  <e@80x24.org>

	* variable.c (rb_autoload_load): allow recursive calls
	  [ruby-core:71345] [Bug #11658]
	* test/ruby/test_autoload.rb (test_autoload_while_autoloading):
	  new test by: Hiroshi Shirosaki <h.shirosaki@gmail.com>
	  [ruby-core:71390]

Tue Nov 10 00:36:46 2015  Tanaka Akira  <akr@fsij.org>

	* lib/resolv.rb (Resolv::DNS::Message::MessageEncoder#put_labels):
	  Prevent overflow of pointer to labels.
	  Patch by Hannes Georg.  [ruby-core:71248] [Bug #11632]

Tue Nov 10 00:25:41 2015  Kazuki Tsujimoto  <kazuki@callcc.net>

	* gems/bundled_gems: update to power_assert 0.2.6.

Mon Nov  9 21:48:17 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_eval.c (rb_check_funcall_default): split from
	  rb_check_funcall to return the given fallback value.

	* object.c (rb_obj_dig): use rb_check_funcall_default so that tail
	  call optimization will be possible.  [Feature #11643]

Mon Nov  9 21:27:23 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (rb_ary_dig): new method Array#dig.

	* hash.c (rb_hash_dig): new method Hash#dig.

	* object.c (rb_obj_dig): dig in nested arrays/hashes.
	  [Feature #11643]

Mon Nov  9 18:00:47 2015  Yuki Nishijima  <mail@yukinishijima.net>

	* gems/bundled_gems: Upgrade the did_you_mean gem to 1.0.0.beta3

Mon Nov  9 17:38:14 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* test/runner.rb: use official repository for coverage tool.
	* Makefile.in: ditto.
	* common.mk: ditto.
	* .gitignore: ignored third party repositories.

Mon Nov  9 17:29:09 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* compile.c (iseq_compile_each): Dynamic string literals should be
	  frozen.
	  [ruby-core:57574] [Feature #8976]

Mon Nov  9 15:56:07 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* common.mk: Use ruby organization url for simplecov repository.

Sun Nov  8 16:24:09 2015  Masaki Matsushita <glass.saga@gmail.com>

	* NEWS: describe addition of File::TMPFILE

Sun Nov  8 15:19:17 2015  Masaki Matsushita <glass.saga@gmail.com>

	* file.c: Add O_TMPFILE.

Sun Nov  8 14:24:43 2015  windwiny  <windwiny.ubt@gmail.com>

	* method.h (METHOD_ENTRY_{VISI,BASIC,FLAGS}_SET): suppress
	  shift-op-parentheses warnings.  [Fix GH-1082]

Sun Nov  8 14:01:22 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* ext/psych/psych_emitter.c: backport 5bd7744 from tenderlove/psych.
	  support backward compatibility of Ruby 2.0

Sun Nov  8 10:55:10 2015  Anton Davydov  <antondavydov.o@gmail.com>

	* io.c (rb_io_gets_m): Update IO#gets doc for characters more than
	  1 byte.  [Fix GH-1085]

Sun Nov  8 10:37:58 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/uri/ftp.rb: fix a typo.
	  [fix GH-1084][ci skip] Patch by @windwiny

Sun Nov  8 08:10:31 2015  Koichi Sasada  <ko1@atdot.net>

	* vm_trace.c (exec_hooks_precheck): check need_clean everytime
	  to clean-up unused hooks.

	* vm_trace.c (list->need_clean): use as boolean value.

Sun Nov  8 01:31:27 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/net/http.rb (Net::HTTP#initialize):
	  default value of Net::HTTP#open_timeout is now 60 (was nil).

Sat Nov  7 12:18:05 2015  Eric Wong  <e@80x24.org>

	* string.c (id_to_s): remove redundant variable
	  (rb_obj_as_string): trade id_to_s for idTo_s
	  (rb_str_equal): replace rb_intern(...) with pre-defined ID
	  (rb_str_cmp_m): ditto
	  (rb_str_match): ditto
	  (str_upto_each): ditto
	  (rb_str_sum): ditto
	  (Init_String): remove id_to_s initialization

Sat Nov  7 11:40:05 2015  Eric Wong  <e@80x24.org>

	* thread.c (rb_cThreadShield): make static

Sat Nov  7 09:51:38 2015  Koichi Sasada  <ko1@atdot.net>

	* vm_trace.c (rb_threadptr_exec_event_hooks_orig):
	  maintain trace_running counter on internal events.

	  This patch is made by Takashi Kokubun <takashikkbn@gmail.com>.
	  [Bug #11603] https://github.com/ruby/ruby/pull/1059

Sat Nov  7 03:32:27 2015  Koichi Sasada  <ko1@atdot.net>

	* include/ruby/ruby.h (RSTRUCT_PTR): need a close parenthesis.

Sat Nov  7 01:32:06 2015  Naohisa Goto  <ngotogenome@gmail.com>

	* dir.c (dir_fileno, dirfd): support of Dir#fileno on Solaris 10.
	  Solaris 10 does not have dirfd, but the file descriptor of a
	  directory is stored in the d_fd or dd_fd member in the DIR struct.
	  Note that Solaris 11 has dirfd(3C).

	* configure.in: checks for DIR.d_fd and DIR.dd_fd on Solaris 10.

Fri Nov  6 23:13:53 2015  Kazuki Tanaka  <gogotanaka@ruby-lang.org>

	* array.c: clarifies Array#reject! documentation.
	  [fix GH-894][ci skip] Patch by @GxSplinter

Fri Nov  6 20:18:25 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* test/runner.rb: extracted test helper.
	* test/lib/zombie_hunter.rb: ditto.

Fri Nov  6 18:07:47 2015  Naohisa Goto  <ngotogenome@gmail.com>

	* include/ruby/ruby.h (rb_array_const_ptr, rb_struct_const_ptr):
	  Suppress pointer type mismatch warnings occurred with old version
	  of Fujitsu C Compiler (fcc) on Solaris 10. The warnings cause
	  failure of TestMkmf::TestConvertible. [Bug #11644] [ruby-dev:49326]
	* include/ruby/ruby.h (FIX_CONST_VALUE_PTR): macro for the above,
	  only effective with fcc.

Fri Nov  6 12:39:21 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* defs/id.def (token_ops), parse.y (parser_yylex): change DOTQ
	  from ".?" to "&.".  [ruby-core:71363] [Feature #11537]

Fri Nov  6 09:01:26 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (kwd_append): fix segv after invalid keyword argument,
	  preceding keyword list is NULL when syntax error is there.
	  [ruby-core:71356] [Bug #11663]

Fri Nov  6 06:59:37 2015  Eric Wong  <e@80x24.org>

	* test/ruby/test_autoload: hoist out ruby_impl_require

Thu Nov  5 13:03:58 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* defs/id.def (token_ops): gather associations between IDs,
	  operators, and parser tokens.

Thu Nov  5 10:17:17 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/socket/socket.c (make_addrinfo): use RARRAY_ASET for
	  write-barrier.

	* ext/tk/tcltklib.c ({call,eval,invoke}_queue_handler): ditto.

	* ext/tk/tkutil/tkutil.c (ary2list, ary2list2): ditto.

Thu Nov  5 10:09:12 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/**/*.c: prefer RARRAY_AREF to indexing RARRAY_CONST_PTR.
	  pointed out by hanmac.
	  https://github.com/ruby/ruby/commit/3553a86#commitcomment-14187670

Wed Nov  4 17:33:24 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/debug.rb: Add documentation for #thread_list_all.
	  [Misc #11580][ci skip]

Wed Nov  4 15:45:59 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* class.c: fix documentation for rb_define_class{_id}_under.
	  [fix GH-991][ci skip] Patch by @kachick

Wed Nov  4 15:40:45 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* method.h: fix typo. Patch by @davydovanton
	  [fix GH-1076][ci skip]

Wed Nov  4 15:39:32 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* hash.c: use correct grammar. Patch by @tveastman
	  [fix GH-1079][ci skip]

Wed Nov  4 11:38:23 2015  Jake Worth  <jakeworth82@gmail.com>

	* process.c (proc_getsid): [DOC] Fix double word 'for' and typo.
	  [Fix GH-1080]

Wed Nov  4 06:01:52 2015  Eric Wong  <e@80x24.org>

	* include/ruby/ruby.h (struct RObject): hide iv_index_tbl type
	  [ruby-core:71306] [Feature #11647]

Tue Nov  3 06:48:58 2015  Eric Wong  <e@80x24.org>

	* variable.c (find_class_path): remove cast for rb_class_ivar_set
	  (rb_ivar_set): ditto
	  (rb_cvar_set): ditto

Tue Nov  3 06:18:21 2015  Eric Wong  <e@80x24.org>

	* variable.c (rb_global_tbl): convert to id_table

Tue Nov  3 01:58:46 2015  Naohisa Goto  <ngotogenome@gmail.com>

	* parse.y (NO_QCALL): fix type mismatch of operands that causes
	  compile error with Oracle Solaris Studio on Solaris.
	  [Bug #11645] [ruby-dev:49327]

Sun Nov  1 17:14:36 2015  Koichi Sasada  <ko1@atdot.net>

	* id_table.c (mix_id_table_insert): do not touch list during
	  list->hash transition because GC can run during transition.

Sun Nov  1 11:07:31 2015  Eric Wong  <e@80x24.org>

	* iseq.c (iseq_memsize): account for rb_call_cache entries

Sun Nov  1 09:12:10 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_yylex): ':' separated by a comment and a newline
	  is not valid as symbol.

Sat Oct 31 20:15:48 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* test/openssl/test_pair.rb: skipped tests if openssl doesn't support
	  ECDH cipher.

Sat Oct 31 14:58:10 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* man/ruby.1 (SYNOPSIS): remove extraneous space for -F option as
	  it does not allow spaces before its argument.
	  [ruby-core:71283] [Bug #11641]

Sat Oct 31 14:58:01 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* man/ruby.1 (SYNOPSIS): remove extraneous space for -F option as
	  it does not allow spaces before its argument.
	  [ruby-core:71283] [Bug #11641]

Sat Oct 31 10:22:49 2015  yui-knk  <spiketeika@gmail.com>

	* eval_error.c (undef_mesg_for): fix typo.  Before this commit
	  `ArgumentError: malformed format string - %$` was raised when
	  `NameError#message` is called.  [ruby-core:71282] [Bug #11640]
	  [Fix GH-1077]

Fri Oct 30 21:12:45 2015  Kazuki Tsujimoto  <kazuki@callcc.net>

	* gems/bundled_gems: update to power_assert 0.2.5.

Fri Oct 30 19:29:52 2015  Koichi Sasada  <ko1@atdot.net>

	* gc.c (newobj_slowpath): do not need to use flags hack (commit miss).

Fri Oct 30 19:08:48 2015  Koichi Sasada  <ko1@atdot.net>

	* gc.c (heap_get_freeobj_from_next_freepage): not so UNLIKELY.

Fri Oct 30 18:09:51 2015  Koichi Sasada  <ko1@atdot.net>

	* gc.c (newobj_slowpath): reduce 1 parameter to use only registers
	  for performance.

	  On my laptop, 'N.times{x = []}' (where N = 29_000_000) is
	  1.86 sec -> 1.74 sec.

Fri Oct 30 12:53:21 2015  yui-knk  <spiketeika@gmail.com>

	* test/ruby/test_call.rb: added test for safe navigation operator.
	  [fix GH-1066]

Fri Oct 30 12:47:34 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* ChangeLog: fix wrong commit name.

Fri Oct 30 12:36:16 2015  yui-knk  <spiketeika@gmail.com>

	* vm_method.c: added documentation of protected/private methods.
	  [fix GH-1072]
	* test/ruby/test_module.rb: added testcase for method_defined?
	  [fix GH-1071]

Fri Oct 30 12:06:59 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* variable.c (rb_class_ivar_set): rename as class specific ivar
	  setter, and st_table is no longer involved.

Fri Oct 30 11:36:33 2015  Eric Wong  <e@80x24.org>

	* variable.c (generic_ivar_remove): adjust type, set valp
	  (rb_obj_remove_instance_variable): simplify call
	* test/ruby/test_object.rb (test_remove_instance_variable):
	  expand for implementation details

Fri Oct 30 10:37:56 2015  Eric Wong  <e@80x24.org>

	* internal.h (rb_st_insert_id_and_value): update prototype
	* variable.c (rb_st_insert_id_and_value): reduce args
	  (find_class_path): adjust call for less args
	  (rb_ivar_set): ditto
	  (rb_cvar_set): ditto
	* class.c (rb_singleton_class_attached): ditto

Fri Oct 30 09:57:22 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* gems/bundled_gems: update latest gems.
	  test-unit-3.1.5 and minitest-5.8.2

Fri Oct 30 09:54:05 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/rubygems: Update to RubyGems HEAD(60d7972).
	  this version contains pull requests number of #1343, #1356, #1357, #1363
	  at https://github.com/rubygems/rubygems/pulls
	* test/rubygems: ditto.

Fri Oct 30 07:38:29 2015  Koichi Sasada  <ko1@atdot.net>

	* insns.def (getinlinecache/setinlinecache): compare ic->ic_cref and
	  current cref only when cached CREF list includes singleton class.

	  Singleton classes have own namespaces, so that we need to check
	  cref as a key (#10943).

	  However, if current CREF list does not include singleton class,
	  no need to check CREF because it should be same name space.

	* vm_insnhelper.c (vm_get_const_key_cref): add a function returns
	  CREF only when it includes singleton class.

	* vm_core.h: constify iseq_inline_cache_entry::ic_cref.

Fri Oct 30 06:43:50 2015  Koichi Sasada  <ko1@atdot.net>

	* vm_insnhelper.c (vm_env_cref): make it inline for performance.

	* vm_insnhelper.c (rb_vm_get_cref): use NULL instead of 0.

Fri Oct 30 06:20:40 2015  Koichi Sasada  <ko1@atdot.net>

	* insns.def: nobody set ic->ic_value.value to Qundef.

Fri Oct 30 06:15:50 2015  Koichi Sasada  <ko1@atdot.net>

	* vm.c: add ifndef guard for VM_CHECK_MODE.

Fri Oct 30 06:13:10 2015  Koichi Sasada  <ko1@atdot.net>

	* vm_insnhelper.c (vm_check_frame_detail): should require me for
	  VM_FRAME_FLAG_BMETHOD type frame.

Thu Oct 29 18:42:30 2015  Koichi Sasada  <ko1@atdot.net>

	* gc.c (gc_mark_ptr): specify NOINLINE so that gc_mark() can return
	  immediately when obj is not a markable object.

Thu Oct 29 18:05:22 2015  Koichi Sasada  <ko1@atdot.net>

	* encoding.c (rb_enc_check_str): add for performance.
	  This function only accepts T_STRING (and T_REGEXP).

	  This patch improves performance of a tiny_segmenter benchmark
	  (num=2) 2.54sec -> 2.42sec on my machine.
	  https://github.com/chezou/TinySegmenter.jl/blob/master/benchmark/benchmark.rb

	* encoding.c: add ENC_DEBUG and ENC_ASSERT() macros.

	* internal.h: add a decl. of rb_enc_check_str().

	* string.c (rb_str_plus): use rb_enc_check_str().

	* string.c (rb_str_subpat_set): ditto.

Thu Oct 29 17:16:40 2015  Koichi Sasada  <ko1@atdot.net>

	* internal.h: export rb_wb_(un)protected_newobj_of()
	  because some extensions include internal.h.

Thu Oct 29 16:42:19 2015  Koichi Sasada  <ko1@atdot.net>

	* gc.c (rb_imemo_new): should not pass FL_WB_PROTECTED flag.

	* gc.c (rb_wb_protected_newobj_of): add more assertions.

	* gc.c (rb_wb_unprotected_newobj_of): ditto.

Thu Oct 29 16:20:26 2015  Koichi Sasada  <ko1@atdot.net>

	* gc.c: introduce rb_wb_unprotected_newobj_of() and
	  rb_wb_protected_newobj_of(), pass the WB_PROTECTED
	  information explicitly.

	* internal.h: use introduced functions by NEWOBJ_OF().
	  `flag' is immediate value, so that C compilers can
	  solve them at compile time.

	* include/ruby/ruby.h: add a comment about that.

Thu Oct 29 14:52:03 2015  Koichi Sasada  <ko1@atdot.net>

	* gc.c: add rb_objspace::flags::has_hook to represent hook availability.

	* gc.c: add gc_event_hook_available_p(objspace) to check that flag.

	* gc.c (newobj_of): use gc_event_hook_available_p() instead of
	  checking gc_event_hook_needed_p(objspace, RUBY_INTERNAL_EVENT_NEWOBJ).
	  for performance.

	* gc.c (newobj_init): add UNLIKELY() for FL_WB_PROTECTED flag.

	* gc.c (newobj_init): change parameters order (trivial change).

Thu Oct 29 14:45:15 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_core.h (rb_thread_struct): move forward declarations before
	  used.

Thu Oct 29 14:07:54 2015  Koichi Sasada  <ko1@atdot.net>

	* gc.c (gc_mark_ptr): remove debug code for #11244.

Thu Oct 29 10:08:33 2015  Eric Wong  <e@80x24.org>

	* variable.c (struct autoload_state): usable as wait-queue head
	  (struct autoload_data_i): remove 2 words of overhead
	  (autoload_i_mark): remove marking for thread
	  (autoload_reset): adjust for struct changes
	  (rb_autoload): ditto
	  (rb_autoloading_value): ditto
	  (rb_autoload_load): ditto
	  (const_update): ditto

Thu Oct 29 08:48:05 2015  Eric Wong  <e@80x24.org>

	* variable.c (struct autoload_data_i): add waitq_head
	  (struct autoload_state): new struct
	  (autoload_require): save result in autoload_state for use
	    in autoload_reset
	  (autoload_reset): wake up other waiters with open-coded
	    wait-queues
	  (rb_autoload_load): add ensure autoload_const_set happens
	    atomically w.r.t. autoload-triggered "require"
	  [ruby-core:70075] [ruby-core:71239] [Bug #11384]

Wed Oct 29 00:39:50 2015  Naohisa Goto  <ngotogenome@gmail.com>

	* test/rubygems/test_gem_commands_server_command.rb
	  (test_handle_options_port): change port from http to discard.
	  Solaris does not include "http 80/tcp" in its default
	  /etc/inet/services. AFAIK, discard (9/tcp) is older than http
	  and it is expected that all OS can resolve the service name.
	  [Bug #10004] [ruby-core:63518]

Wed Oct 28 23:52:48 2015  Naohisa Goto  <ngotogenome@gmail.com>

	* probes_helper.h (RUBY_DTRACE_HOOK): add RB_GC_GUARD, though paranoic.

Wed Oct 28 15:36:11 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* error.c (rb_name_err_new): store the receiver directly.

	* error.c (name_err_receiver): return directly stored receiver.
	  [Feature #10881]

	* error.c (name_err_mesg_to_str): quote the name if unprintable.

	* object.c (check_setter_id): use rb_check_id to convert names.

	* variable.c (uninitialized_constant): use NameError::message to
	  keep the receiver of uninitialized constant.  [Feature #10881]

	* error.c (rb_name_err_new): new function to create NameError
	  exception instance.  [Feature #10881]

Wed Oct 28 13:29:39 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (new_attr_op_assign): fix op_assign type, which is
	  already an ID since r52284.  [Feature #11537]

Tue Oct 27 23:14:14 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* defs/id.def: enable anonymous IDs not to expose internal IDs for
	  frozen-string-literal-debug by Marshal.dump.

Tue Oct 27 17:06:55 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* defs/id.def: move internal IDs for frozen-string-literal-debug.

Tue Oct 27 16:41:05 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* error.c (rb_error_frozen_object): use rb_attr_get instead of
	  rb_ivar_get to get rid of warnings for string objects created
	  when frozen-string-literal-debug is disabled.

Tue Oct 27 16:18:12 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/logger.rb (Logger::Period#previous_period_end): as weekly
	  rotation shifts the log file on Sundays, the end date of the
	  previous period should be Saturdays.  fix r45072.
	  [ruby-dev:49314] [Bug #11622]

Tue Oct 27 16:12:37 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* vm_dump.c (rb_print_backtrace): our addr2line doesn't work on sparc.
	  http://rubyci.s3.amazonaws.com/unstable11s/ruby-trunk/log/20151027T043311Z.log.html.gz

Tue Oct 27 12:00:33 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/logger.rb (Logger::Period#next_rotate_time): get rid of
	  adding to mday not to exceed the days of the month.
	  [ruby-core:71185] [Bug #11620]

Mon Oct 26 22:43:03 2015  yui-knk  <spiketeika@gmail.com>

	* test/ruby/test_module.rb (test_method_defined): Add test cases
	  for `public/protected/private _method_defined?`
	  These methods accept string as argument, so add string argument
	  cases.  [Fix GH-1067]

Mon Oct 26 22:23:30 2015  SimonDKnight  <simondknight@hotmail.com>

	* lib/racc/rdoc/grammar.en.rdoc: Grammatical errors fixed.
	  [Fix GH-1070]

Mon Oct 26 18:36:43 2015  Shota Fukumori (sora_h) <her@sorah.jp>

	* vm_method.c(rb_method_entry_make):
	  [DOC] [ci skip] Remove a needless space from comment
	  [Fixes GH-1069] Patch by @yui-knk

Mon Oct 26 17:30:13 2015  Ryan Hosford  <tad.hosford@gmail.com>

	* lib/fileutils.rb: rename tailing to trailing.
	  [Misc #11548]

Mon Oct 26 17:11:53 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (call_op, call_op2): fix values on ripper.  [Feature #11537]

Mon Oct 26 12:55:06 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (call_op2): separate from call_op and also allow "::",
	  while dot_or_colon should not allow ".?".  [Feature #11537]

Mon Oct 26 01:03:23 2015  Rei Odaira  <Rei.Odaira@gmail.com>

	* thread_pthread.c: fix compile errors when
	  USE_SLEEPY_TIMER_THREAD is disabled.

Sun Oct 25 10:12:05 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* symbol.c (op_tbl): add DOTQ for ripper.  [Feature #11537]

Sat Oct 24 22:51:18 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* configure.in: fixed build failure of Haiku.
	  [fix GH-984] Patch by @kallisti5
	* ext/socket/getaddrinfo.c: ditto.
	* ext/socket/getnameinfo.c: ditto.
	* ext/socket/rubysocket.h: ditto.

Sat Oct 24 21:16:53 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/fileutils/test_fileutils.rb (test_uptodate): relax error
	  message format.  [Feature #9025], [ruby-core:71178] [Bug #11617]

Sat Oct 24 21:06:43 2015  Shota Fukumori (sora_h)  <her@sorah.jp>

	* lib/mkmf.rb: Revert r45640 because it may lead to link
	  with different libruby. [Bug #9760]

Sat Oct 24 15:42:20 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* bootstraptest/test_method.rb: relax error message format.

	* test/ruby/test_arity.rb (err_mess): ditto.
	  [Feature #9025], [ruby-core:71178] [Bug #11617]

Sat Oct 24 12:47:47 2015  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* vm_insnhelper.c: improved error message for "wrong number
	  of arguments", distinguishing given and expected argument
	  numbers clearly. [Feature #9025]

Sat Oct 24 11:57:59 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* vm_insnhelper.c: remove the typedef redeclaration of
	  vm_call_handler.

Sat Oct 24 07:29:12 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/forwardable.rb (def_instance_delegator, def_single_delegator):
	  match backtraces against ::Forwardable in case the target class
	  is a subclass of BasicObject and does not include Kernel.
	  [ruby-core:71176] [Bug #11616]

Sat Oct 24 04:10:13 2015  Koichi Sasada  <ko1@atdot.net>

	* iseq.c (make_compile_option_value): include frozen_string_literal*
	  in a made option value.

	* vm_opts.h: forgot to add OPT_FROZEN_STRING_LITERAL_DEBUG
	  at last commit.

Sat Oct 24 03:58:02 2015  Koichi Sasada  <ko1@atdot.net>

	* ruby.c: introduce --enable-frozen-string-literal-debug option.
	  If this option is enabled, the modify error will be:
	    can't modify frozen String (RuntimeError) =>
	    can't modify frozen String, created at test.rb:3 (RuntimeError)

	* iseq.h: add compile option frozen_string_literal_debug.

	* compile.c: catch up this fix.

	* error.c (rb_error_frozen): ditto.

	* iseq.c (set_compile_option_from_hash): ditto.

	* test/ruby/test_rubyoptions.rb: add a test for this fix.

Sat Oct 24 02:02:24 2015  Koichi Sasada  <ko1@atdot.net>

	* vm_insnhelper.c: introduce new call handler for simple ISeqs.

	  vm_call_iseq_setup_normal_0start() is simple, however it has
	  some loops/conditions depends on ISeq::param.size and
	  ISeq::local_size (in vm_push_frame(), inlined into this function).

	  There are many simple methods which has a few parameters and local
	  variables. So that this patch introduces several special functions
	  generated in vm_call_iseq_optimized.inc by
	  tool/mk_call_iseq_optimized.rb.

	  This script makes
	    vm_call_iseq_setup_normal_0start_Xparams_Ylocals()
	  where X is 0 to 3 and Y is 1 to 6 (as current setting).
	  In this case, X * Y = 24 functions are created.

	  These functions creates fast method dispatch by inlining
	  vm_push_frame() with immediate params/locals sizes.

	  On my laptop, we can have the following results.

	  vm2_method*       1.083 (8.3% faster)
	  vm2_poly_method*  0.961 (3.4% slower)

	  It shows 8.3% faster for inner loop method dispatch (hit inline
	  cache), but 3.4% slower when inline cache miss because we need
	  to find a suitable call handler.

	* common.mk: add a rule for vm_call_iseq_optimized.inc.

	* tool/mk_call_iseq_optimized.rb: added.

	* vm.c: include vm_call_iseq_optimized.inc.

Sat Oct 24 01:58:50 2015  Koichi Sasada  <ko1@atdot.net>

	* vm_core.h: define vm_call_handler.

Sat Oct 24 01:56:01 2015  Koichi Sasada  <ko1@atdot.net>

	* vm_core.h, vm_insnhelper.h: move definition of VMDEBUG
	  from vm_insnhelper.h to vm_core.h.

Sat Oct 24 01:51:01 2015  Akinori MUSHA  <knu@iDaemons.org>

	* NEWS: [DOC] In the new safe call syntax, arguments are evaluated
	  only if a call is made.

	* doc/syntax/calling_methods.rdoc: Fix a typo.

Sat Oct 24 00:38:34 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/forwardable (def_instance_delegator, def_single_delegator):
	  rescue ::Exception instead of Exception in case Exception is
	  defined under the target class.
	  [ruby-core:71175] [Ruby trunk - Bug #11615]

Fri Oct 23 21:10:37 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* error.c (name_err_mesg_to_str): separate class names from the
	  receiver description.

	* vm_eval.c (make_no_method_exception, raise_method_missing): add
	  format specifiers for class names.

Fri Oct 23 18:10:32 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* .gitignore: ignored environmental wrapper files.

Fri Oct 23 17:55:29 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/irb.rb: Ignored assignment of STDOUT.sync = true
	  when irb.rb loaded. It's affected to IDE such as Jetbrain.
	  [fix GH-864] Patch by @os97673

Fri Oct 23 16:35:08 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/ipaddr.rb, test/test_ipaddr.rb: Reject invalid address contained
	  EOL string. Patch by @kachick [fix GH-942][Bug #11513]

Fri Oct 23 16:03:26 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* file.c: fix indent style. [fix GH-977]
	* test/ruby/test_string.rb: indent. [fix GH-975]
	  [ci skip] These patches are contributed from @yui-knk

Fri Oct 23 15:46:09 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* string.c: Added method signature to include hash. It's inconsistency
	  with `gsub` method signature.
	  [ci skip][fix GH-1023] Patch by @danielevans

Fri Oct 23 15:25:51 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/imap.rb: remove an empty comment line and -*-.

Fri Oct 23 15:20:02 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/ftp.rb (gettextfile, getbinaryfile): use the safe
	  navigation operator.

Fri Oct 23 13:51:33 2015  yui-knk  <spiketeika@gmail.com>

	* test_call.rb (test_safe_call): Add test cases for safe
	  navigation operator assignment.  [Fix GH-1064]
	  Validate:
	  * can assign an attribute which is `nil`
	  * can "or assign" an attribute which is `nil`

Fri Oct 23 11:58:21 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_peephole_optimize): optimize lengthy safe
	  navigation method chain.  [Feature #11537]

Fri Oct 23 10:58:41 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/matrix/eigenvalue_decomposition.rb (tridiagonalize): fix
	  indentation to avoid a warning when the command line option -w of
	  ruby is specified.

	* lib/matrix/eigenvalue_decomposition.rb (hessenberg_to_real_schur):
	  change the name of a block parameter to avoid a warning when the
	  command line option -w of ruby is specified.

Fri Oct 23 10:49:36 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_compile_each): support safe navigation of simple
	  attribute assignment.  [Feature #11537]

	* parse.y (mlhs_node, lhs, attrset_gen): ditto.  keep mid
	  non-attrset as the sign of safe navigation.

Fri Oct 23 07:17:11 2015  Eric Wong  <e@80x24.org>

	* test/io/wait/test_io_wait.rb (test_wait_eof): test return value

Fri Oct 23 00:32:02 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/openssl/ossl_ssl.c (ssl_npn_select_cb): explicitly raise error
	  in ext/openssl instead of OpenSSL itself because LibreSSL
	  silently truncate the selected protocol name by casting the length
	  from int to unsigned char. [Bug #11369]
	  Patch by Jeremy Evans <merch-redmine@jeremyevans.net>

Fri Oct 23 00:49:45 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/un.rb (help): change the name of a block parameter to avoid
	  a warning when the command line option -w of ruby is specified.

Fri Oct 23 00:22:20 2015  Josef Simanek  <josef.simanek@gmail.com>

	* string.c (rb_str_tr): [DOC] Escape backslash in String#tr
	  documentation.  [Fix GH-1063]

Fri Oct 23 00:19:04 2015  yui-knk  <spiketeika@gmail.com>

	* array.c (rb_ary_collect): [DOC] Fix space of code example of
	  Array#map.  [Fix GH-1062]

Thu Oct 22 18:52:53 2015  Akinori MUSHA  <knu@iDaemons.org>

	* vm_eval.c (rb_f_loop): When a loop is stopped by a StopIteration
	  exception, return what the enumerator has returned instead of
	  nil. [ruby-core:71133] [Feature #11498]

Thu Oct 22 18:25:10 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/imap.rb (idle): add a new argument timeout for keep-alive.
	  [ruby-core:63693] [Bug #10031]

Thu Oct 22 15:30:08 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_peephole_optimize): peephole optimization for
	  branchnil jumps.

	* compile.c (iseq_compile_each): generate save navigation operator
	  code.

	* insns.def (branchnil): new opcode to pop the tos and branch if
	  it is nil.

	* parse.y (NEW_QCALL, call_op, parser_yylex): parse token '.?'.
	  [Feature #11537]

Thu Oct 22 13:16:19 2015  Guilherme Reis Campos  <guilhermekbsa@gmail.com>

	* dir.c (ruby_brace_expand): glob brace expansion edge case fix.
	  When there are closing braces '}' before a open brace '{' it
	  must be ignored and considered as literal.
	  [ruby-core:71138] [Bug #11609]

Thu Oct 22 13:13:49 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (argf_next_argv): check ARGV element type, and try
	  conversion if necessary.  [ruby-core:71140] [Bug #11610]

Thu Oct 22 11:11:16 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* test/net/ftp/test_ftp.rb: add tests for getbinaryfile and
	  gettextfile.

Wed Oct 21 18:34:06 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_magic_comment): allow a sole magic comment without
	  indicators, neither other non-space comments.  [Feature #8976]

Tue Oct 20 12:17:56 2015  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/prime.rb: Add basic argument checking to Prime.prime?
	  [Bug #11606]

Tue Oct 20 12:17:50 2015  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/prime.rb: Optimize Integer#prime?
	  Patch by Nick Slocum [Bug #10354]

Tue Oct 20 08:12:47 2015  Rei Odaira  <Rei.Odaira@gmail.com>

	* configure.in: pthread_getattr_np is broken on AIX.
	  More specifically, the stack address and size returned are
	  not correct.

Tue Oct 20 05:54:46 2015  Eric Wong  <e@80x24.org>

	* ext/fiddle/closure.c (callback): static function

Mon Oct 19 10:33:46 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/socket/init.c (rsock_raise_socket_error): get rid of a glibc
	  bug.  [ruby-core:71100] [Bug #11600]

Mon Oct 19 01:26:26 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* file.c (rb_file_identical_p): not necessary to compare the paths after
	  comparing the file indexes on Windows.  designate by kosaki.

Sun Oct 18 21:17:27 2015  Tanaka Akira  <akr@fsij.org>

	* lib/open-uri.rb: Specify frozen_string_literal: true.

Sun Oct 18 14:37:56 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* random.c (fill_random_bytes_urandom): add a comment why using
	  O_NONBLOCK and O_NOCTTY.

Sun Oct 18 13:24:17 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* random.c (fill_random_bytes_syscall): use ATOMIC_SET() for
	  updating try_syscall.

Sun Oct 18 13:03:52 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* include/ruby/backward/util.h: Good-by Borland-C.

Sun Oct 18 13:03:09 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* common.mk: add a comment how to use "make test-all"

Sun Oct 18 12:59:22 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* common.mk: add comments how to use "make benchmark"

Sun Oct 18 12:58:15 2015  Tanaka Akira  <akr@fsij.org>

	* lib/securerandom.rb: Specify frozen_string_literal: true.

Sun Oct 18 11:22:52 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* dln.c: remove defined(__WATCOMC__).

Sun Oct 18 11:16:33 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* lib/mkmf.rb: Good-by Borland-C.

Sun Oct 18 11:04:36 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* numeric.c: Good-by Borland-C.
	* include/ruby/backward/rubyio.h: ditto.
	* include/ruby/backward/st.h: ditto.
	* include/ruby/backward/util.h: ditto.
	* include/ruby/backward/rubysig.h: ditto.
	* include/ruby/backward/classext.h: ditto.
	* dln.c: ditto.
	* gc.c: ditto.
	* win32/resource.rb: ditto.
	* win32/dir.h: ditto.
	* ext/tk/tcltklib.c: ditto.
	* NEWS: announce that Borland-C is no longer supported.

Sun Oct 18 10:54:52 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* dln.c: simplify #ifdef. _WIN32 and __CYGWIN__ are exclusive.
	  see include/ruby/defines.h
	* gc.c: ditto.
	* ext/sdbm/_sdbm.c: ditto.

Sun Oct 18 10:42:19 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* ruby.c (open_load_file): add a comment.

Sun Oct 18 10:12:46 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* file.c (rb_file_identical_p): simplify ifdefs

Sun Oct 18 10:01:40 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* ChangeLog: Good-bye OS/2.
	* common.mk: ditto.
	* configure.in: ditto.
	* dln_find.c: ditto.
	* ext/Setup.emx: ditto.
	* ext/extmk.rb: ditto.
	* ext/socket/extconf.rb: ditto.
	* ext/zlib/extconf.rb: ditto.
	* file.c: ditto.
	* include/ruby/defines.h: ditto.
	* io.c: ditto.
	* lib/mkmf.rb: ditto.
	* missing/os2.c: ditto.
	* process.c: ditto.
	* ruby.c: ditto.
	* NEWS: announce OS/2 is no longer supported.

Sun Oct 18 08:50:15 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* include/ruby/defines.h (DOSISH): add comments.

Sun Oct 18 08:26:51 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* io.c (fptr_finalize): don't release gvl if fptr is not writable.
	  writable fd may block on close(2) when it's on NFS. But readonly
	  fd doesn't. [Bug #11559]
	  result: make benchmark OPTS="-p bm_require_t -e ruby-trunk -e ruby-2.2.2"
	    build-ruby:             0.171
	    ruby 2.3.0dev(r52151):  0.659
	    ruby 2.2.0p95 (r50295): 0.834

Sun Oct 18 09:32:58 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* file.c (ruby_is_fd_loadable): this should be fail if st_mode is
	  not regular file nor FIFO.

Sun Oct 18 09:20:17 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* ruby.c (open_load_file): use rb_thread_wait_fd() instead of reopen.

Sun Oct 18 05:11:22 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* ruby.c (open_load_file): reset O_NONBLOCK after open.
	  Even if S_ISREG() is true, the file may be file on FUSE filesystem
	  or something. We can't assume O_NONBLOCK is safe.
	  Moreover, we should wait if the path is point to FIFO. That's
	  FIFO semantics. GVL should be transparent from ruby script.
	  Thus, just reopen without O_NONBLOCK for filling the requirements.
	  [Bug #11060][Bug #11559]

	* ruby.c (loadopen_func): new for the above.

	* file.c (ruby_is_fd_loadable): new. for checks loadable file type
	  of not.
	* file.c (rb_file_load_ok): use ruby_is_fd_loadble()
	* internal.h: add ruby_is_fd_loadble()

	* common.mk: now, ruby.o depend on thread.h.

	* test/ruby/test_require.rb
	(TestRequire#test_loading_fifo_threading_success): new test.
	  This test successful case that loading from FIFO.

	* test/ruby/test_require.rb
	(TestRequire#test_loading_fifo_threading_raise): rename from
	  test_loading_fifo_threading. You shouldn't rescue an exception
	  if you test raise or not.
	  Moreover, this case should be caught IOError because load(FIFO)
	  should be blocked until given any input.

Sat Oct 17 13:55:32 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (rb_file_expand_path_internal): concatenate converted
	  string to the result instead of making converted string and
	  append it.

	* string.c (rb_str_cat_conv_enc_opts): from rb_str_conv_enc_opts,
	  separate function to concatenate with transcoding.

Sat Oct 17 13:19:10 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby.c (load_file): unify each preparations and clean-ups by
	  merging load_file_internal and load_file_internal2, and remove
	  nested rb_protect and rb_ensure.

Sat Oct 17 05:28:32 2015  Rei Odaira  <Rei.Odaira@gmail.com>

	* test/ruby/test_symbol.rb (test_symbol_fstr_leak): add a warm-up
	  code and check RSS to avoid false positive on AIX and false
	  negative on Mac OS X. [Bug #10686]

Fri Oct 16 15:54:37 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (rb_file_load_ok): open in non-blocking mode withoout
	  releasing GVL.  don't care about others than regular files and
	  directories.  [ruby-dev:49272] [Bug #11559]

	* ruby.c (load_file_internal): ditto.

Thu Oct 15 23:56:03 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (rb_sym_to_proc): make void env.

Thu Oct 15 13:37:23 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (rb_sym_to_proc): move from string.c and create a Proc
	  with no environments.  [ruby-core:71088] [Bug #11594]

Thu Oct 15 01:57:03 2015  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* test/objspace/test_objspace.rb
	  (test_trace_object_allocations_start_stop_clear): clear object
	  allocation table first to get rid of erroneous detection for obj3.
	  [ruby-dev:49095] [Bug #11271]

Thu Oct 15 01:53:38 2015  Benoit Daloze  <eregontp@gmail.com>

	* test/ostruct/test_ostruct.rb: Add tests for OpenStruct#respond_to.
	  Patch by @jeremy in [GH-1041]: https://github.com/ruby/ruby/pull/1041

Thu Oct 15 01:49:25 2015  Benoit Daloze  <eregontp@gmail.com>

	* lib/ostruct.rb: Finish defining OpenStruct attributes lazily.
	  Patch by @sferik in [GH-1037]: https://github.com/ruby/ruby/pull/1037
	  This commit is an addendum to https://github.com/ruby/ruby/pull/1033.
	  It:
	  1. lazily defines attribute accessors for copied and marshaled objects,
	  2. returns nil when an attribute reader is not defined, and
	  3. defines respond_to_missing? to maintain the same respond_to? behavior

Wed Oct 14 16:56:50 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in: check for libunwind.h, which is not available in
	  very old OS X SDK.  [ruby-core:71080] [Bug #11591]

Wed Oct 14 14:11:42 2015  Brian Black  <bblack@veracode.com>

	* iseq.c (rb_insn_operand_intern): change kw in callinfo disasm from the
	  number of keyword arguments to an ordered list of the keywords used.
	  [Feature #11589]

Wed Oct 14 13:58:44 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_nextc): send a warning to ripper, not to STDERR
	  always.

	* parse.y (rb_warn1, rb_warning1): move argument conversions to
	  callers.  PRIsVALUE is not valid in String#%.

Wed Oct 14 13:37:23 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/racc/rdoc/grammar.en.rdoc: fix spell error.
	  [fix GH-1053][ci skip] Patch by @Matrixbirds

Tue Oct 13 22:06:50 2015  Tanaka Akira  <akr@fsij.org>

	* ext/socket/raddrinfo.c (rsock_fd_family): Check sa_len.

Tue Oct 13 12:14:10 2015  Craig Davison  <craig65535@gmail.com>

	* ext/socket/rsock_addrinfo (rsock_addrinfo): specify address
	  family.  [Fix GH-1052]

	* ext/socket/udpsocket.c (udp_connect, udp_bind, udp_send):
	  address family by the receiver.

Sun Oct 11 07:09:19 2015  Koichi Sasada  <ko1@atdot.net>

	* vm_insnhelper.c (vm_push_frame): initialize other than sp (and ep)
	  first for performance.

Sun Oct 11 06:21:50 2015  Koichi Sasada  <ko1@atdot.net>

	* vm_eval.c, internal.h (rb_yield_1): added for performance which
	  doesn't check Qundef.

	* numeric.c (int_dotimes): use rb_yield_1.

Sun Oct 11 06:19:49 2015  Koichi Sasada  <ko1@atdot.net>

	* vm_insnhelper.c (vm_call_iseq_setup_normal): setup sp first
	  for performance.

Sun Oct 11 05:29:51 2015  Koichi Sasada  <ko1@atdot.net>

	* vm.c (invoke_block_from_c): split this function into several
	  functions.

	* vm_insnhelper.c (vm_yield_callee_setup_arg): remove this function
	  because it is only delegation function.

Sun Oct 11 03:48:46 2015  Koichi Sasada  <ko1@atdot.net>

	* gc.c (newobj_of_slowpass): fix typo (pass -> path).
	  Pointed out by Yukihiro Matsumoto  <matz@ruby-lang.org>.

	* gc.c (newobj_of_...): `of' is unnecessary.

Sat Oct 10 19:04:42 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/socket/udpsocket.c (udp_connect, udp_bind): get open files
	  inside ensure functions.

Sat Oct 10 18:35:12 2015  Koichi Sasada  <ko1@atdot.net>

	* vm_insnhelper.c (vm_call_method0): do not propagate enable_fastpath,
	  but pass dummy CC to prevent wrong caching.

Sat Oct 10 15:28:45 2015  Koichi Sasada  <ko1@atdot.net>

	* import a github pull request
	  https://github.com/ruby/ruby/pull/1050
	  by Kazuho Oku <kazuho@natadeco.co>.

	  This pull request has the following commits.

	* gc.c: reduce # of args to 6 (max. of register args on x86-64) so
	  that the `newobj_of_slowpass` can be called via TCO.

	* gc.c (newobj_of), string.c (str_duplicate): for performance,
	  the hot functions must be inlined.

	* gc.c: for performance, preceding arguments of `.*newobj_of.*`
	  must be same, so that the arg registers can be reused in case of
	  TCO.

Sat Oct 10 08:52:21 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/socket/udpsocket.c (udp_connect, udp_bind, udp_send): fix
	  memory leaks at closed socket.

Fri Oct  9 17:29:07 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/ftp.rb (parse257): refactor.

Fri Oct  9 16:42:26 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/imap.rb: use frozen_string_literal: true.

	* test/net/imap/test_imap.rb: ditto.

	* test/net/imap/test_imap_response_parser.rb: ditto.

Fri Oct  9 15:52:28 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/ftp.rb: use frozen_string_literal: true.

	* test/net/ftp/test_buffered_socket.rb: ditto.

	* test/net/ftp/test_ftp.rb: ditto.

	* test/net/ftp/test_mlsx_entry.rb: ditto.

Fri Oct  9 14:12:35 2015  Shota Fukumori (sora_h)  <her@sorah.jp>

	* ext/openssl/lib/openssl/ssl.rb: Revert r52082 because it was
	  dropping TLS v1.1 support too. Supporting only TLS v1.2 is too
	  early, because many popular websites still don't support it.

	  For instance, Servers where aws-sdk connects to still don't support
	  TLS v1.2 and it became broken.

	  We should consider more carefully about this.

	  [Fix GH-873] [Feature #11524]

Fri Oct  9 12:52:08 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* compile.c (iseq_compile_each): Dynamic string literals (e.g.,
	  "#{x}") should not be frozen because they don't literally
	  represent strings.
	  https://twitter.com/shugomaeda/status/651937650027401216
	  https://twitter.com/yukihiro_matz/status/651942882312482817
	  https://twitter.com/yukihiro_matz/status/651980835181096960

Fri Oct  9 06:52:49 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* benchmark/prepare_require.rb: skip file creation if it already
	  exist. Suggested by ko1.

Fri Oct  9 06:18:04 2015  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>
	* benchmark/bm_require.rb: new benchmark for require.
	* benchmark/bm_require_thread.rb: new benchmark for conflicting
	  require vs thread. like [Bug #11559]
	* prepare_require.rb: new file for preparing above tests.
	* prepare_require.rb: ditto.

Thu Oct  8 14:10:45 2015  Zachary Scott  <zzak@ruby-lang.org>

	* ext/openssl/lib/openssl/ssl.rb: Default to TLSv1.2 and drop TLS v1
	  Patch provided by @claudijd [Fixes GH-873] [Feature #11524]:
	  https://github.com/ruby/ruby/pull/873

Wed Oct  7 22:55:02 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/minitest/metametameta.rb (with_output): restore output to
	  fix mixing test result output in worker responses.

Wed Oct  7 21:32:51 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (str_duplicate): move from rb_str_resurrect to short
	  circuit initialization.

Wed Oct  7 20:43:14 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_resurrect): fix resurrection of short enough to
	  be embedded but not embedded string.

Wed Oct  7 20:17:29 2015  Koichi Sasada  <ko1@atdot.net>

	* gc.c (newobj_of): divide fast path and slow path
	  to avoid register savings for fast path.

	  This idea is given by Kazuho Oku <kazuho@natadeco.co>.

Wed Oct  7 17:30:50 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_times): optimize for the argument 0 and 1.

Wed Oct  7 01:20:46 2015  Koichi Sasada  <ko1@atdot.net>

	* gc.h, gc.c: introduce new debug function rb_obj_info_dump(VALUE obj)
	  which prints the result of rb_raw_obj_info(..., obj).

Wed Oct  7 01:16:11 2015  Koichi Sasada  <ko1@atdot.net>

	* vm_args.c: remove an unused field args_info::calling.

Tue Oct  6 23:43:10 2015  Koichi Sasada  <ko1@atdot.net>

	* proc.c (rb_method_entry_min_max_arity): should support
	  OPTIMIZED_METHOD_TYPE_CALL.

Tue Oct  6 21:29:08 2015  Tanaka Akira  <akr@fsij.org>

	* lib/tmpdir.rb (Dir.tmpdir): return duplicated string to be
	  modify safely even when $SAFE > 0.

Tue Oct  6 19:24:38 2015  Koichi Sasada  <ko1@atdot.net>

	* vm_insnhelper.c (vm_call_method0): use switch() for visibilities
	  (for readability).

Tue Oct  6 19:23:58 2015  Koichi Sasada  <ko1@atdot.net>

	* proc.c (Init_Proc): Proc#call and others should be public.

Tue Oct  6 18:51:51 2015  Koichi Sasada  <ko1@atdot.net>

	* method.h: IMEMO_FL_USER3 and IMEMO_FL_USER4 is not needed any more.

Tue Oct  6 18:47:45 2015  Koichi Sasada  <ko1@atdot.net>

	* method.h: remove METHOD_ENTRY_SAFE(me) and related code
	  because $SAFE = 3 and 4 is not available.
	  Now, $SAFE is not checked on method dispatch at all.

	* vm_eval.c, vm_insnhelper.c, vm_method.c: ditto.

Tue Oct  6 13:56:14 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/ruby.h: turn function macros into inline functions,
	  for debuggers.

	* include/ruby/ruby.h: turn constant macros into enums, for
	  debuggers.

Tue Oct  6 13:48:05 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* method.h: typo fix. Patch by @davydovanton [fix GH-1032][ci skip]

Tue Oct  6 06:54:34 2015  Koichi Sasada  <ko1@atdot.net>

	* iseq.c (rb_iseq_free): free iseq::variable_body to avoid memory
	  leak.

Tue Oct  6 06:32:52 2015  Koichi Sasada  <ko1@atdot.net>

	* proc.c: enable optimization of Proc#call.
	  [Feature #11569]

	* NEWS: write about this optimization and incompatibilities.

	* test/ruby/test_backtrace.rb: catch up this fix.

Tue Oct  6 04:41:03 2015  Koichi Sasada  <ko1@atdot.net>

	* vm_insnhelper.c: solve goto spaghetti.

	  Change all goto statement across blocks to tail call functions.

Tue Oct  6 02:29:38 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_resurrect): optimize by short circuit to copy
	  hidden string without checking length, encoding and so on.

Mon Oct  5 23:08:17 2015  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* test/ruby/test_thread.rb (test_handle_interrupt_blocking): check if
	  exception handling was postponed until sleep.

Mon Oct  5 22:25:49 2015  Tanaka Akira  <akr@fsij.org>

	* lib/pp.rb: Use frozen_string_literal: true.

	* lib/prettyprint.rb: Ditto.

	* lib/resolv.rb: Ditto.

	* lib/tmpdir.rb: Ditto.

	* test/test_pp.rb: Ditto.

	* test/test_prettyprint.rb: Ditto.

	* tool/transcode-tblgen.rb: Ditto.

Mon Oct  5 20:39:32 2015  Benoit Daloze  <eregontp@gmail.com>

	* test/ruby/test_thread.rb: fix potential race condition.
	  The thread could have a "sleep" status because it tries
	  to acquire the mutex, but does not have it yet.

Mon Oct  5 15:39:30 2015  Zachary Scott  <zzak@ruby-lang.org>

	* numeric.c: [DOC] Overview for Numeric class by Joe Corcoran
	  This patch was created at ROSSConf Berlin 2015 [Bug #11555]

Mon Oct  5 15:34:56 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (proc_new): link ep to calling block.
	  [ruby-core:70980] [Bug #11566]

Mon Oct  5 00:53:51 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dir.c (rb_dir_getwd): make ASCII-8BIT if filesystem encoding is
	  US-ASCII, like as Dir.glob.

Sun Oct  4 23:39:09 2015  Tanaka Akira  <akr@fsij.org>

	* enum.c (nmin_filter): Fix limit value.
	  patch by Helder Pereira.
	  [Bug #11471] [ruby-core:70477]

Sun Oct  4 15:11:48 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* enc/euc_jp.c (mbc_case_fold): check given string is valid or not,
	  and if invalid, return 1. [Bug #11486]

Sun Oct  4 10:09:57 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dir.c (rb_dir_getwd): normalize OS path to UTF-8 on OS X.

Sun Oct  4 00:09:45 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* template/ruby-runner.c.in: wrapper to set dynamic loading path
	  environment variable.  /bin/sh on Mac OS X 10.11 (El Capitan)
	  clears DYLD_LIBRARY_PATH.

	  it must:
	  - do nothing even if current directory is not present
	  - do not set other environment variables, e.g. PWD, SHLVL, etc
	  - do not open other FDs, e.g. pipes for timer thread

Sun Oct 2 10:59:00 2015  schneems  <richard.schneeman@gmail.com>

	* ext/pathname/lib/pathname.rb: freeze string literals for
	  reduced object allocation.
	  [Feature #11375] [ruby-core:70043]

Fri Oct  2 09:20:20 2015  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* common.mk, lib/unicode_normalize/tables.rb: Change Unicode
	  Version for character normalization data from 7.0.0 to
	  8.0.0.

Fri Oct  2 00:18:39 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (proc_mark): block.ep of Proc from Symbol is now NULL.
	  [ruby-core:70961] [Bug #11560]

